<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
 */
defined( '_JEXEC' ) or die( 'Restricted access' );

class CrBcCategoriesHelper {
    
    
    
    public static function reorderCategories(JModelLegacy $model, $category_id = 0, $parent_id = 0) {
        
        if($parent_id > 0){
            $model->getTable('category')->reorder('parent_id = ' . $parent_id);
        }
        
        if($category_id > 0){
            $model->getTable('categoryproducts')->reorder('category_id = ' . $category_id);
        }
        
        if( $parent_id > 0 || $category_id > 0 ){
            return;
        }
        
        $db = JFactory::getDBO();
        $query = 'SELECT parent_id, id' .
                ' FROM #__breezingcommerce_categories';
        $db->setQuery( $query );
        $rows = $db->loadObjectList();
        foreach ($rows as $row) {
            $model->getTable('category')->reorder('parent_id = ' . $row->parent_id);
            $model->getTable('categoryproducts')->reorder('category_id = ' . $row->id);
        }
    }

    public static function getCategoriesSelectList($selected = 0, $list_name = 'category', $size = null, $onchange = '', $multiple = false, $topItem = '', $style = null, $class = 'chzn-done') {
        $db = JFactory::getDBO();

        // get a list of the menu items
        // excluding the current menu item and its child elements
        $query = 'SELECT c.*' .
                ' FROM #__breezingcommerce_categories c' .
                ' ORDER BY c.parent_id, c.ordering';
        $db->setQuery( $query );
        $mitems = $db->loadObjectList();

        // establish the hierarchy of the menu
        $children = array();

        if ( $mitems ) {
            // first pass - collect children
            foreach ( $mitems as $v ) {
                $v->name = CRBCOLDJ ? $v->title : '';
                $pt 	= $v->parent_id;
                $list 	= @$children[$pt] ? $children[$pt] : array();
                array_push( $list, $v );
                $children[$pt] = $list;
            }
        }

        // second pass - get an indent list of the items
        $list = JHTML::_('menu.treerecurse', 0, '', array(), $children, 99999 );

        // assemble menu items to the array
        $mitems 	= array();
        //if($topItem != '')
        //{
        //    $mitems[] 	= JHTML::_('select.option',  '0', $topItem );
        //}

        foreach ( $list as $item ) {
            if($item->id == 1){
                $item->treename = JText::_( 'COM_BREEZINGCOMMERCE_TOP' );
            }
            $mitems[] = JHTML::_('select.option',  $item->id, str_replace(array("&#160;","<sup>","</sup>"),array('.','',''), $item->treename ) );
        }

        $output = JHTML::_('select.genericlist',   $mitems, $list_name, ($style ? 'style="'.$style.'"' : '').($class ? ' class="'.$class.'"' : '').($size ? ' size="'.$size.'"' : '').($onchange != '' ? ' onchange="'.$onchange.'"' : '') . ($multiple ? ' multiple="multiple"' : ''), 'value', 'text', $selected );

        return $output;
    }

    public static function getCategoriesMultipleSelectList($selected = 0, $name = 'categories[]', $size = 10, $onchange = '', $style = '') {
        return self::getCategoriesSelectList($selected, $name, $size, $onchange, true, '', $style);
    }

    public static function getParentsSelectList( $row, $style = '', $class = 'chzn-done' ) {
        $db = JFactory::getDBO();

        $id = null;
        if ( $row->id ) {
            $id = ' Where id != '.(int) $row->id;
        }

        // In case the parent was null
        if (!$row->parent_id) {
            $row->parent_id = 0;
        }

        // get a list of the menu items
        // excluding the current menu item and its child elements
        $query = 'SELECT c.*' .
                ' FROM #__breezingcommerce_categories c' .
                $id .
                ' ORDER BY c.parent_id, c.ordering';
        $db->setQuery( $query );
        $mitems = $db->loadObjectList();

        // establish the hierarchy of the menu
        $children = array();

        if ( $mitems ) {
            // first pass - collect children
            foreach ( $mitems as $v ) {
                $v->name = CRBCOLDJ ? $v->title : '';
                $pt 	= $v->parent_id;
                $list 	= @$children[$pt] ? $children[$pt] : array();
                array_push( $list, $v );
                $children[$pt] = $list;
            }
        }

        // second pass - get an indent list of the items
        $list = JHTML::_('menu.treerecurse', 0, '', array(), $children, 99999 );

        // assemble menu items to the array
        $mitems 	= array();
        //$mitems[] 	= JHTML::_('select.option',  '0', JText::_( 'COM_BREEZINGCOMMERCE_TOP' ) );

        foreach ( $list as $item ) {
            if($item->id == 1){
                $item->treename = JText::_( 'COM_BREEZINGCOMMERCE_TOP' );
            }
            // looks like a joomla 1.6 bug, that's why we replace &#160; with underscore
            $mitems[] = JHTML::_('select.option',  $item->id, str_replace(array("&#160;","<sup>","</sup>"),array('.','',''), $item->treename ) );
        }

        $output = JHTML::_('select.genericlist',   $mitems, 'parent_id', 'style="'.$style.'"'.($class != '' ? ' class="'.$class.'"' : ''), 'value', 'text', $row->parent_id );

        return $output;
    }
}
