<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// No direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');

class CrBcFile{

    public static function copyProductFiles($src_product_id, $dest_product_id){
        
        $db = JFactory::getDBO();
        $db->setQuery("Select * From #__breezingcommerce_files Where product_id = " . intval($src_product_id));
        $files = $db->loadObjectList();
        
        $base_path = JPATH_ROOT . DS . 'media' . DS . 'breezingcommerce' . DS . 'files' . DS;
        
        foreach($files As $file){
            
            $file_name = md5( mt_rand(0, mt_getrandmax()).crc32($file->name.$file->filename2.uniqid()) );
            
            $success = JFile::copy($base_path.$file->filename, $base_path.$file_name);
            
            if($success){
                
                $db->setQuery("
                    Insert Into #__breezingcommerce_files
                    (
                        product_id,
                        filename,
                        filename2,
                        filetype,
                        filesize,
                        `name`,
                        `description`,
                        requires_verification,
                        verification_days,
                        verification_download_tries,
                        published
                    )
                    Values
                    (
                        " . intval($dest_product_id) . ",
                        " . $db->Quote(basename($file_name)) . ",
                        " . $db->Quote($file->filename2) . ",
                        " . $db->Quote($file->filetype) . ",
                        " . intval($file->filesize) . ",
                        " . $db->Quote($file->name) . ",
                        ". $db->Quote($file->description) . ",
                        ". $db->Quote($file->requires_verification) . ",
                        ". $db->Quote($file->verification_days) . ",
                        ". $db->Quote($file->verification_download_tries) . ",
                        ". $db->Quote($file->published) . "
                    )
                ");

                $db->query();
                
                $insertId = $db->insertid();
                
                CrBcHelpers::copyTranslations($file->id, $insertId, 'product_file');
            }
        }
    }
    
    public static function store($product_id, $fileinfo, $data, $file_id = 0){

        $out_file_id = 0;
        
        $db = JFactory::getDBO();

        if( !self::createDir( JPATH_ROOT . DS . 'media' ) ) return false;
        if( !self::createDir( JPATH_ROOT . DS . 'media' . DS . 'breezingcommerce' ) ) return false;
        if( !self::createDir( JPATH_ROOT . DS . 'media' . DS . 'breezingcommerce' . DS . 'files' ) ) return false;
        $def = '';
        if(!JFile::exists(JPATH_ROOT . DS . 'media' . DS . 'breezingcommerce' . DS . 'files' . DS . 'index.html')) JFile::write(JPATH_ROOT . DS . 'media' . DS . 'breezingcommerce' . DS . 'files' . DS . 'index.html', $def);
        $def = 'deny from all';
        if(!JFile::exists(JPATH_ROOT . DS . 'media' . DS . 'breezingcommerce' . DS . 'files' . DS . '.htaccess')) JFile::write(JPATH_ROOT . DS . 'media' . DS . 'breezingcommerce' . DS . 'files' . DS . '.htaccess', $def);

        $db->setQuery("Select id, filename From #__breezingcommerce_files Where id = " . intval($file_id));
        $id = $db->loadAssoc();

        if(intval($fileinfo['size'])){

            $src = $fileinfo['tmp_name'];
            $dest = JPATH_ROOT . DS . 'media' . DS . 'breezingcommerce' . DS . 'files' . DS . md5( mt_rand(0, mt_getrandmax()).crc32($fileinfo['tmp_name'].$fileinfo['name'].uniqid()) );

            if(!JFile::upload($src, $dest, false, true))
            {
                return false;
            }

        }

        if(is_array($id)){

            $_fileinfo = "";

            if(intval($fileinfo['size'])){
                $_fileinfo = "filename = " . $db->Quote(basename($dest)) . ",
                        filename2 = " . $db->Quote(basename($fileinfo['name'])) . ",
                        filetype = " . $db->Quote($fileinfo['type']) . ",
                        filesize = " . intval($fileinfo['size']) . ",";
                JFile::delete(JPATH_ROOT . DS . 'media' . DS . 'breezingcommerce' . DS . 'files' . DS . $id['filename']);
            }

            $db->setQuery("
                Update
                    #__breezingcommerce_files
                Set
                    ".$_fileinfo."
                    `name` = " . $db->Quote($data['file_name']) . ",
                    `description` = ". $db->Quote($data['file_description']) . ",
                    requires_verification = ". $db->Quote($data['file_verification']) . ",
                    verification_days = ". $db->Quote($data['file_verification_days']) . ",
                    verification_download_tries = ". $db->Quote($data['file_verification_tries']) . ",
                    published = ". $db->Quote($data['published']) . "
              Where
                    id = ".$id['id']."
            "
            );
            
            $db->query();
            
            $out_file_id = $id['id'];

        }else if(intval($fileinfo['size'])){
            $db->setQuery("
                Insert Into #__breezingcommerce_files
                (
                    product_id,
                    filename,
                    filename2,
                    filetype,
                    filesize,
                    `name`,
                    `description`,
                    requires_verification,
                    verification_days,
                    verification_download_tries,
                    published
                )
                Values
                (
                    " . intval($product_id) . ",
                    " . $db->Quote(basename($dest)) . ",
                    " . $db->Quote($fileinfo['name']) . ",
                    " . $db->Quote($fileinfo['type']) . ",
                    " . intval($fileinfo['size']) . ",
                    " . $db->Quote($data['file_name']) . ",
                    ". $db->Quote($data['file_description']) . ",
                    ". $db->Quote($data['file_verification']) . ",
                    ". $db->Quote($data['file_verification_days']) . ",
                    ". $db->Quote($data['file_verification_tries']) . ",
                    ". $db->Quote($data['file_published']) . "
                )
            ");

            $db->query();
            
            $out_file_id = $db->insertid();
        }

        if(!class_exists('TableFile')){
            require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce' . DS . 'tables' . DS . 'file.php');
        }
        
        $table = new TableFile(JFactory::getDBO());
        $table->reorder("product_id = " . intval($product_id));
        
        return $out_file_id;
    }

    public static function deleteProductFiles($product_id, $file_ids = null){
        $db = JFactory::getDBO();
        $where = '';
        $where2 = '';
        if(is_array($file_ids) && count($file_ids)){
            JArrayHelper::toInteger($file_ids);
            $where = ' And id In ('.implode(',', $file_ids).') ';
            $where2 = ' And file_id In ('.implode(',', $file_ids).') ';
        }
        $db->setQuery("Select id,filename From #__breezingcommerce_files Where product_id = " . intval($product_id) . $where);
        $files = $db->loadAssocList();
        foreach($files As $file){
            JFile::delete(JPATH_ROOT . DS . 'media' . DS . 'breezingcommerce' . DS . 'files' . DS . $file['filename']);
            $db->setQuery("Delete From #__breezingcommerce_translations Where type = 'product_file' And item_id = " . $file['id']);
            $db->query();
        }
        $db->setQuery("Delete from #__breezingcommerce_files Where product_id = " . intval($product_id) . $where);
        $db->query();
        $db->setQuery("Delete from #__breezingcommerce_orderitemfiles Where product_id = " . intval($product_id) . $where2);
        $db->query();
        if($where != ''){
            if(!class_exists('TableFile')){
                require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce' . DS . 'tables' . DS . 'file.php');
            }

            $table = new TableFile(JFactory::getDBO());
            $table->reorder("product_id = " . intval($product_id));
        }
    }

    public static function readfile_chunked ($filename) {
      $chunksize = 1*(1024*1024); // how many bytes per chunk
      $buffer = '';
      $handle = @fopen($filename, 'rb');
      if ($handle === false) {
        JError::raiseError( 404, JText::_( 'COM_BREEZINGCOMMERCE_FILE_NOT_FOUND_OR_NOT_PUBLISHED' ) );
      }
      while (!@feof($handle)) {
        $buffer = @fread($handle, $chunksize);
        print $buffer;
      }
      @fclose($handle);
    }
    
    public static function downloadFile($file_id, $ignore_published = false, $order_item_file_id = 0){
        $db = JFactory::getDBO();
        $db->setQuery("Select * From #__breezingcommerce_files Where id = " . intval($file_id) . ($ignore_published ? "" : " And published = 1"));
        $ass = $db->loadAssoc();
        if($ass){
            ob_end_clean();
            header("Pragma: public");
            header("Expires: 0");
            header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
            header("Cache-Control: public", false);
            header("Content-Description: File Transfer");
            header('Content-Type: application/octet-stream');
            header("Content-Disposition: attachment; filename=\"" . $ass['filename2'] . "\";");
            header("Content-Transfer-Encoding: binary");
            header("Content-Length: " . filesize(JPATH_ROOT . DS . 'media' . DS . 'breezingcommerce' . DS . 'files' . DS . $ass['filename']));
            self::readfile_chunked(JPATH_ROOT . DS . 'media' . DS . 'breezingcommerce' . DS . 'files' . DS . $ass['filename']);
            $db->setQuery("Update #__breezingcommerce_files Set downloads = downloads + 1 Where id = " . intval($file_id) . ($ignore_published ? "" : " And published = 1"));
            $db->execute();
            if($order_item_file_id && $ass['verification_download_tries'] > 0){
                $db->setQuery("Update #__breezingcommerce_orderitemfiles Set download_tries = download_tries + 1 Where id = " . intval($order_item_file_id));
                $db->execute();
            }
            exit;
        }else{
            JError::raiseError( 404, JText::_( 'COM_BREEZINGCOMMERCE_FILE_NOT_FOUND_OR_NOT_PUBLISHED' ) );
        }
    }

    public static function createDir($path)
    {
        if(!JFolder::exists( $path ))
        {
            if(!JFolder::create($path))
            {
                return false;
            }
        }

        return true;
    }
}