<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

class CrBcForm{
    
    /**
     * renders labels and fields based on the information given
     * 
     * @param array $fields field names from the xml file you want to render
     * @param string $json_state the current state of saved data as json string
     * @param string $form name of the form from the models/forms/ folder without xml suffix
     * @param string $control_parameter_name the resulting parameter name for storing data from a submission form parametername[attributename]
     * @return string
     */
    public static function render($fields, $json_state, $form, $control_parameter_name,$catchall = '',$input_only = false){
        jimport('joomla.form.form');
        JForm::addFormPath(JPATH_SITE . '/administrator/components/com_breezingcommerce/models/forms');
        $form = JForm::getInstance('com_breezingcommerce.'.$form.($catchall==''?$control_parameter_name:$catchall), $form, array('control' => ($catchall==''?$control_parameter_name:$catchall), 'load_data' => true));

        // Convert the attribs field to an array.
        $registry = new JRegistry;
        $registry->loadString($json_state);
        $json_state = $registry->toArray();

        $item = new stdClass();
        $item = $json_state;

        $form->bind( $item );
        
        $out = '';
        
        foreach($fields As $field){
            if( $input_only ){
                $out .= $form->getInput($field);
            }else{
                $out .= '<div class="control-group"><div class="control-label">'.$form->getLabel($field).'</div><div class="controls">'. $form->getInput($field).'</div></div>'."\n";
            }
        }
        
        return $out;
    }
}

