<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// No direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

if(!defined('DS')){
    define('DS','/');
}

class CrBcHelpers{
    
	public static function getCategoryPath($category_id){
	
		if(!class_exists('CrBcHelpers')){
			
			require(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce' . DS . 'classes' . DS . 'CrBcHelpers.php');
		}
		
		$db = JFactory::getDbo();

		$db->setQuery("SELECT parent.title, parent.id, parent.alias
							FROM #__breezingcommerce_categories AS node,
									#__breezingcommerce_categories AS parent
							WHERE node.lft BETWEEN parent.lft AND parent.rgt
									AND node.id = ".$db->quote($category_id)."
							ORDER BY node.lft");

		return $db->loadObjectList();
	
	}
    
	
    public static function bSixtyFourEncode($str){
        
        $base = 'base';
        $sixty_four = '64_encode';
        return call_user_func($base.$sixty_four, $str);
    }
    
    public static function bSixtyFourDecode($str){
        
        $base = 'base';
        $sixty_four = '64_decode';
        return call_user_func($base.$sixty_four, $str);
    }
    
    public static function setPageTitle($title){
        
        $sitename = JFactory::getConfig()->get('sitename', '');
        $titles = JFactory::getConfig()->get('sitename_pagetitles', 0); // 1 = before, after = 2, 0 = no
        $left   = '';
        $right  = '';

        if( $sitename != '' && $titles != 0 ){

            if($titles == 1){
                $left = $sitename . ' - ';
            }
            else if($titles == 2)
            {
                $right = ' - ' . $sitename;
            }
        }

        JFactory::getDocument()->setTitle($left.$title.$right);
    }
    
    public static function getEnabledLanguages($client = 0)
    {
        static $return_list = array();
            
        if(!isset($return_list[$client])){
            
            // Create a new db object.
            $db = JFactory::getDbo();
            $query = $db->getQuery(true);
            $type = "language";

            // Select field element from the extensions table.
            $query->select('a.element')
                    ->from('#__extensions AS a');

            $type = $db->quote($type);
            $query->where('(a.type = ' . $type . ')')
                    ->where('state = 0')
                    ->where('enabled = 1')
                    ->where('client_id=' . (int) $client);

            // For client_id = 1 do we need to check language table also?
            $db->setQuery($query);

            $column = $db->loadColumn();
            
            $list = array();
            
            if( $column !== null ){
                
                foreach($column As $tag){
                    
                    $db->setQuery("Select * From #__languages Where published = 1 And lang_code = " . $db->quote($tag) . " Order By ordering Limit 1");
                    $tag_entry = $db->loadObject();
                    if(is_object($tag_entry)){
                        $list[] = $tag_entry;
                    }
                }
            }
            
            $return_list[$client] = $list;
            return $return_list[$client];
        }
            
        return $return_list[$client];
    }
    
    public static function setAlternate($url, $lang){
        
        if(method_exists($obj = JFactory::getDocument(), 'addCustomTag')){
            
            $doc = JFactory::getDocument(); 
                foreach ( $doc->_links as $k => $array ) { 
                  if ( $array['relation'] == 'alternate' ) { 
                     unset($doc->_links[$k]); 
                  } 
            }
            
            $link = '<link rel="alternate" href="'.$url.'" hreflang="'.htmlentities($lang, ENT_QUOTES, 'UTF-8').'" />' ."\n";
            JFactory::getDocument()->addCustomTag($link);
        }
        
    }
    
    public static function setCanonical($which, $subject, $return_only = false){
        
        $config = self::getBcConfig();
        
        if($which == 'product'){
        
            $alias = $subject->alias == '' ? CrBcHelpers::getSlug($subject->title) : $subject->alias;
            $url = JRoute::_('index.php?option=com_breezingcommerce&perm=1&Itemid='.CrBcHelpers::getDefaultMenuItemId().'&controller=product&alias='.$alias.'&product_id='.$subject->id,false);
            
        }
        else if( $which == 'category' )
        {
            $alias = $subject->alias == '' ? CrBcHelpers::getSlug($subject->title) : $subject->alias;
            $url = JRoute::_('index.php?option=com_breezingcommerce&perm=1&controller=category&category_id='.$subject->id.'&Itemid='.CrBcHelpers::getDefaultMenuItemId().'&alias='.$alias,false);
        }
        else if( $which == 'categories' )
        {
            $alias = $subject->alias == '' ? CrBcHelpers::getSlug($subject->title) : $subject->alias;
            $url = JRoute::_('index.php?option=com_breezingcommerce&perm=1&controller=categories&parent_category_id='.$subject->id.'&Itemid='.CrBcHelpers::getDefaultMenuItemId().'&alias='.$alias,false);
        }
        
        $uri     = Juri::getInstance();
        $current = $uri->toString( array('scheme', 'host', 'port'));
        
        if( $config->get('canonical_host', '') !== '' ){
            
            $current = rtrim($config->get('canonical_host', ''), '/');
        }
        
        if(!$return_only){
            
            $doc = JFactory::getDocument(); 
            foreach ( $doc->_links as $k => $array ) { 
              if ( $array['relation'] == 'canonical' ) { 
                 unset($doc->_links[$k]); 
              } 
            }
            
            JFactory::getDocument()->setMetaData('canonical', $current . $url);
        }
        
        return $current . $url;
    }
    
    public static function getDefaultMenuItemId($controller = ''){
        
        $config = self::getBcConfig();
        
        if( $controller == 'cart' ){
            $cart_menu_id = intval($config->get('default_cart_menu_item_id', 0));
            
            if($cart_menu_id > 0){
                
                return $cart_menu_id;
            }
        }
        else
        if( $controller == 'checkout' ){
            
            $checkout_menu_id = intval($config->get('default_checkout_menu_item_id', 0));
            
            if($checkout_menu_id > 0){
                
                return $checkout_menu_id;
            }
        }
        
        if(null === JFactory::getApplication()->getMenu()->getDefault(JFactory::getLanguage()->getTag())){
            return 0;
        }
        
        return JFactory::getApplication()->getMenu()->getDefault(JFactory::getLanguage()->getTag())->id;
    }
    
    public static function getSlug($str){
        
        jimport('joomla.filter.output');
        
        if (JFactory::getConfig()->get('unicodeslugs') == 1){
            
            return JFilterOutput::stringURLUnicodeSlug($str);
        } 
        else
        {
            if(function_exists('transliterator_transliterate')){
                
                $trans = @transliterator_transliterate('Any-Latin; Latin-ASCII; NFD; [:Nonspacing Mark:] Remove; NFC; Lower();', $str);
                $result = JFilterOutput::stringURLSafe($trans);
                if(trim($result) == ''){
                    return JHtml::date('now', 'Y-m-d-H-i-s');
                }
                return $result;
            }
            else
            {
                $result = JFilterOutput::stringURLSafe($str);
                
                if(trim($result) == ''){
                    
                    return JHtml::date('now', 'Y-m-d-H-i-s');
                }
                
                return $result;
            }
        }
        
        return '';
    }
    
    public static function addJsonLd($content){
        if(method_exists($obj = JFactory::getDocument(), 'addCustomTag')){
            $style = '<script type="application/ld+json">' ."\n";
            $style .= '{' . "\n" . $content . "\n" . '}' ."\n";
            $style .= '</script>' ."\n";
            JFactory::getDocument()->addCustomTag($style);
        }
    }
    
    public static function addCssFile($url){
        if(method_exists($obj = JFactory::getDocument(), 'addCustomTag')){
            $stylelink = '<link rel="stylesheet" href="'.$url.'" />' ."\n";
            JFactory::getDocument()->addCustomTag($stylelink);
        }
    }
    
    public static function addCss($content){
        
        if(method_exists($obj = JFactory::getDocument(), 'addCustomTag')){
            $style = '<style type="text/css">' ."\n";
            $style .= $content."\n";
            $style .= '</style>' ."\n";
            JFactory::getDocument()->addCustomTag($style);
        }
    }
    
    public static function createMatchAgainstLookupSql($query_in, array $fields, $tbl_pfx = '', $clause_and_or = '' ){
        
        $db = JFactory::getDbo();
        
        if( $clause_and_or != '' ){
            
            if(strtolower($clause_and_or) != 'and' && strtolower($clause_and_or) != 'or' ){
                $clause_and_or = ' ' . $clause_and_or . ' ';
            }
        }
        
        if(trim($query_in) == ''){
            return '';
        }
        
        if( count($fields) == 0 ){
            return '';
        }
        
        if( $tbl_pfx != '' ){
            
            $tbl_pfx = $db->quoteName($tbl_pfx) . '.';
        }
        
        $query = '';
        $search_lookup = '';
        $shorties = array();
        $first_done = false;
        
        $broken = explode(' ', $query_in);

        foreach($broken As $broke){

            $broke = trim($broke);
            if( $broke != '' && !$first_done){
                $query .= '+'.str_replace(array("+",'"',"-","<",">","~","*","@","(",")"), '', $broke).'* ';
                $first_done = true;
                if(function_exists('mb_strlen')){
                    if( mb_strlen($broke) < 4 && mb_strlen($broke) > 1 ){
                        $shorties[] = $broke;
                    }
                }
                else
                {
                    if( strlen($broke) < 4 && strlen($broke) > 1 ){
                        $shorties[] = $broke;
                    }
                }
            }
            else if( $broke != '' ){

                $query .= str_replace(array("+",'"',"-","<",">","~","*","@","(",")"), '', $broke).'* ';

                if(function_exists('mb_strlen')){
                    if( mb_strlen($broke) < 4 && mb_strlen($broke) > 1 ){
                        $shorties[] = $broke;
                    }
                }
                else
                {
                    if( strlen($broke) < 4 && strlen($broke) > 1 ){
                        $shorties[] = $broke;
                    }
                }
            }
        }

        $the_fields = '';
        foreach( $fields As $field ){
            $the_fields .= $tbl_pfx.$db->quoteName($field).",";
        }
        
        $the_fields = rtrim($the_fields,',');
        
        $search_lookup = $clause_and_or . " ( Match (".$the_fields.") Against (" . $db->quote( trim($query) ) . " IN BOOLEAN MODE) ";

        $shorties_lookup = '';
        
        if( count( $shorties ) > 0 ){

            foreach($shorties As $shorty){

                foreach( $fields As $field ){
                    
                    $shorties_lookup .= $tbl_pfx.$db->quoteName($field)." Like " . $db->quote( '%' . $shorty . '%' ) . " Or ";
                }
            }
        }
        
        $shorties_lookup = rtrim(rtrim(rtrim($shorties_lookup, ' '),'r'),'O');
        
        if($shorties_lookup != ''){
           
            $search_lookup .= ' Or ( ' . $shorties_lookup . ' ) ) ';
        }
        else
        {
            $search_lookup .= ' ) ';
        }
        
        return $search_lookup;
        
    }
    
    public static function updateGroupPriceMap($customergroup_id){
        
        require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcCart.php');
        
        $db = JFactory::getDbo();
        
        $db->setQuery("Select currency_id From #__breezingcommerce_customergroups Where id = ".intval($customergroup_id)."");
        $currency_id = $db->loadResult();
       
        if($currency_id){
            
            $db->setQuery("Select conversion_rate, symbol, code From #__breezingcommerce_currencies Where id = " . intval($currency_id)  . "");
            $customergroup_result = $db->loadObject();
            $customergroup_result_conversion_rate = isset($customergroup_result->conversion_rate) ? $customergroup_result->conversion_rate : 1;

            $db->setQuery("Select * From #__breezingcommerce_group_price_map Where customergroup_id = " . intval($customergroup_id) );
            $rows = $db->loadObjectList();

            if( count($rows) > 0 ){
            
                foreach($rows As $row){

                    $price = CrBcCart::applyProductPricePlugins($row->product_id);
                    $price = isset($price->price) ? $price->price : 0;

                    $_price = CrBcCart::getItemPrice($price, $customergroup_result_conversion_rate, intval($row->producttaxclass_id), array(), array(), 1, 0, false, true, $customergroup->id);

                    $db->setQuery("INSERT
                            INTO #__breezingcommerce_group_price_map 
                            (
                                id,
                                product_id,
                                price,
                                producttaxclass_id,
                                customergroup_id
                            ) 
                            VALUES 
                            (
                                ".$db->quote($row->id).",
                                ".$db->quote($row->product_id).",
                                ".$db->quote($_price['gross']).",
                                ".$db->quote(intval($row->producttaxclass_id)).",
                                ".$db->quote(intval($customergroup_id))."
                            ) 
                            ON DUPLICATE KEY UPDATE price = " . $db->quote($_price['gross']));

                    $db->execute();

                }
            
            }
            
        } else {
            
            self::disableGroupPriceMapEntries($customergroup_id);
        }
        
        return false;
    }
    
    public static function disableGroupPriceMapEntries($customergroup_id){
        $db = JFactory::getDbo();
        $db->setQuery("Update #__breezingcommerce_group_price_map Set published = 0 Where customergroup_id = " . intval($customergroup_id));
        $db->execute();
    }
    
    public static function enableGroupPriceMapEntries($customergroup_id){
        $db = JFactory::getDbo();
        $db->setQuery("Update #__breezingcommerce_group_price_map Set published = 1 Where customergroup_id = " . intval($customergroup_id));
        $db->execute();
    }
    
    public function addToPriceMap($product_id, $producttaxclass_id){
      
        
        self::addToCurrencyPriceMap($product_id, $producttaxclass_id);
        self::addToGroupPriceMap($product_id, $producttaxclass_id);
    }
    
    public static function addToCurrencyPriceMap($product_id, $producttaxclass_id){
        
        $db = JFactory::getDbo();
        
        $product_id = intval($product_id);
        $producttaxclass_id = intval($producttaxclass_id);
        
        // THIS IS A DEFINITE TEMPORARY SOLUTION!
        // TODO: price mapping must be written a lot more clevery
        // populate price map
        
        require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcCart.php');
        
        $price = CrBcCart::applyProductPricePlugins($product_id);
        $price = isset($price->price) ? $price->price : 0;
        
        $db->setQuery("Delete From #__breezingcommerce_currency_price_map Where product_id = " . $db->quote(intval($product_id)));
        $db->execute();
        
        $db->setQuery("Select * From #__breezingcommerce_currencies");
        $currencies = $db->loadObjectList();
        
        if( count( $currencies ) != 0 ){
        
            foreach($currencies As $currency){

                $_price = CrBcCart::getItemPrice($price, $currency->conversion_rate, intval($producttaxclass_id), array(), array(), 1, 0);

                $db->setQuery("
                        Insert 
                            Into 
                        #__breezingcommerce_currency_price_map 
                        (
                            product_id, 
                            price, 
                            producttaxclass_id, 
                            currency_id
                        ) 
                        Values
                        (
                            ".$db->quote($product_id).",
                            ".$db->quote($_price['gross']).",
                            ".$db->quote(intval($producttaxclass_id)).",
                            ".$db->quote($currency->id)."
                        )
                    ");

                    $db->execute();
                
            }
            
        }
        
        // END Price Map
        
    }
    
    public static function addToGroupPriceMap($product_id, $producttaxclass_id){
        
        $db = JFactory::getDbo();
        
        $product_id = intval($product_id);
        $producttaxclass_id = intval($producttaxclass_id);
        
        // THIS IS A DEFINITE TEMPORARY SOLUTION!
        // TODO: price mapping must be written a lot more clevery
        // populate price map
        
        require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcCart.php');
        
        $price = CrBcCart::applyProductPricePlugins($product_id);
        $price = isset($price->price) ? $price->price : 0;
        
        $db->setQuery("Delete From #__breezingcommerce_group_price_map Where product_id = " . $db->quote(intval($product_id)));
        $db->execute();
        
        $db->setQuery("Select * From #__breezingcommerce_customergroups");
        $customergroups = $db->loadObjectList();

        // everything in place? ok, write it all

        if( count($customergroups) != 0 ){

            foreach($customergroups As $customergroup){

                $db->setQuery("Select conversion_rate, symbol, code From #__breezingcommerce_currencies Where id = " . intval($customergroup->currency_id)  . "");
                $customergroup_result = $db->loadObject();
                $customergroup_result_conversion_rate = isset($customergroup_result->conversion_rate) ? $customergroup_result->conversion_rate : 1;

                $_price = CrBcCart::getItemPrice($price, $customergroup_result_conversion_rate, intval($producttaxclass_id), array(), array(), 1, 0, false, true, $customergroup->id);

                $db->setQuery("
                    Insert 
                        Into 
                    #__breezingcommerce_group_price_map 
                    (
                        product_id, 
                        price, 
                        producttaxclass_id,
                        customergroup_id
                    ) 
                    Values
                    (
                        ".$db->quote($product_id).",
                        ".$db->quote($_price['gross']).",
                        ".$db->quote(intval($producttaxclass_id)).",
                        ".$db->quote($customergroup->id)."
                    )
                ");

                $db->execute();

            }

        }
        
        // END Price Map
        
    }
    
    public static function jsonEncode($value){
        return json_encode($value, JSON_HEX_QUOT|JSON_HEX_TAG|JSON_HEX_AMP|JSON_HEX_APOS);
    }
    
    public static function applyProductDisplayPlugins($product_id, $combination_id = 0, $is_complex = false){
        
        $out = array();
        $out['before_price']       = array();
        $out['after_price']        = array();
        $out['before_description'] = array();
        $out['after_description']  = array();
        $out['inside_footer']      = array();
        $out['default']            = array();
        $out['refreshable']        = array();
        $out['force_details']      = array();

        $db = JFactory::getDBO();
        
        $db->setQuery("Select * From #__breezingcommerce_plugins Where published = 1 And type = 'productdetails' Order By `ordering`");
        $plugins = $db->loadObjectList();
        
        $db->setQuery('Select c.* From #__breezingcommerce_product_property_combinations As c, #__breezingcommerce_products As p Where p.id = c.product_id And c.product_id = ' . $db->quote( intval($product_id) ) . ' '.($combination_id ? ' And c.id = ' . intval($combination_id) : ' And selected = 1 ').' And p.published = 1 And c.published = 1 And use_combinations = 1 Order By c.`ordering`');
        $row = $db->loadObject();
       
        foreach($plugins As $plugin){
            
            $class = CrBcPlugin::getPluginClass($plugin->name, $plugin->type, JFactory::getApplication()->isAdmin() ? 'admin' : 'site');
            $instance = new $class();
            
            $out['refreshable'][] = $instance->refreshable($product_id, !isset($row->id) || !$row->id ? 0 : $row->id);
            $out['force_details'][] = $instance->forceDetails($product_id, !isset($row->id) || !$row->id ? 0 : $row->id);
            
            if(JFactory::getApplication()->isSite() && $is_complex && $instance->complexDisplay($product_id, !isset($row->id) || !$row->id ? 0 : $row->id) === false){
                
                continue;
            }
            
            $info = $class::getInfo($product_id, !isset($row->id) || !$row->id ? 0 : $row->id);

            $out['before_price'][]       = $_1 = $class::infoBeforePrice($info);
            $out['after_price'][]        = $_2 = $class::infoAfterPrice($info);
            $out['before_description'][] = $_3 = $class::infoBeforeDescription($info);
            $out['after_description'][]  = $_4 = $class::infoAfterDescription($info);
            $out['inside_footer'][]      = $_5 = $class::infoInsideFooter($info);
            // if no slots have been applied by the plugin, put the info into the default slot
            if(!$_1 && !$_2 && !$_3 && !$_4 && !$_5){
                $out['default'][] = $info;
            }else{
                $out['default'][] = '';
            }
        }
        
        return $out;
    }
    
    /**
     * Set the document's metadata. Checking if a translation exists and uses the translations instead.
     * Also checks if there are existing matches based on the current menu item and applies them instead.
     * 
     * @param string $metadesc
     * @param string $metakey
     * @param string $metadata json encoded string with the parameters robots, author, rights, xreference
     * @param int $id the item id to use to find a translation if available (for example product id)
     * @param type $translation_type the type of the translation. Goes along with the id (for example 'product_metadata')
     */
    public static function setMetaData($metadesc = '', $metakey = '', $metadata = '', $id = 0, $translation_type = ''){
        
        $metadesc_translation = '';
        $metakey_translation  = '';
        $metadata_translation = '';
        $translated_object = null;
        
        if($id > 0 && $translation_type != ''){
            $translated_object = self::loadTranslation($id, $translation_type);
        }
        
        if($translated_object !== null){
            $_meta = json_decode($translated_object->body);
            $metadesc_translation = $_meta->metadesc;
            $metakey_translation  = $_meta->metakey;
            $metadata_translation = $_meta->metadata;
        }
        
        if($metadesc_translation){
            JFactory::getDocument()->setMetaData('description', $metadesc_translation);
        }else
        if($metadesc){
            JFactory::getDocument()->setMetaData('description', $metadesc);
        }
        
        if($metakey_translation){
            JFactory::getDocument()->setMetaData('keywords', $metakey_translation);
        }else
        if($metakey){
            JFactory::getDocument()->setMetaData('keywords', $metakey);
        }
        
        $menu = JFactory::getApplication()->getMenu();
        $active = $menu->getActive();

        if(is_object($active)){

            if($active->params->get('menu-meta_description')){
                $description = $active->params->get('menu-meta_description');
                JFactory::getDocument()->setMetaData('description', $description);
            }
            
            if($active->params->get('menu-meta_description')){
                $keywords = $active->params->get('menu-meta_keywords');
                JFactory::getDocument()->setMetaData('keywords', $keywords);
            }
            
            if($active->params->get('robots')){
                $robots = $active->params->get('robots');
                JFactory::getDocument()->setMetaData('robots', $robots);
            }
        } 
        
        if($metadata_translation){
            
            $meta = $metadata_translation;
            
            if(isset($meta->robots) && $meta->robots){
                JFactory::getDocument()->setMetaData('robots', $meta->robots);
            }

            if(isset($meta->author) && $meta->author){
                JFactory::getDocument()->setMetaData('author', $meta->author);
            }

            if(isset($meta->rights) && $meta->rights){
                JFactory::getDocument()->setMetaData('rights', $meta->rights);
            }

            if(isset($meta->xreference) && $meta->xreference){
                JFactory::getDocument()->setMetaData('xreference', $meta->xreference);
            }
            
        }else if($metadata){
            
            $meta_form = new JRegistry(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'models'.DS.'metadata.xml');
            
            $meta = $meta_form->loadString($metadata);
            
            if($meta->get('robots','')){
                JFactory::getDocument()->setMetaData('robots', $meta->get('robots',''));
            }

            if($meta->get('author','')){
                JFactory::getDocument()->setMetaData('author', $meta->get('author',''));
            }

            if($meta->get('rights','')){
                JFactory::getDocument()->setMetaData('rights', $meta->get('rights',''));
            }

            if($meta->get('xreference','')){
                JFactory::getDocument()->setMetaData('xreference', $meta->get('xreference',''));
            }
        }
        
    }
    
    public static function parseIniFile($path){
        if(JFile::exists($path)){
            return @parse_ini_file($path, true);
        }
        return null;
    }
    
    public static function isBot(){
        
        static $bots;
        static $isBot;
        
        if(!$bots){
            
            $bots = self::parseIniFile(JPATH_ADMINISTRATOR.'/components/com_breezingcommerce/assets/misc/useragents.ini');
        }
        
        if($isBot !== 1 && $isBot !== 0){
        
            foreach ($bots['robots'] as $test) { 

                if (strtolower(trim($test[0])) == strtolower(trim($_SERVER['HTTP_USER_AGENT']))) {
                    $isBot = 1;
                    break;
                }
            }
            
            if($isBot !== 1){
                $isBot = 0;
            }
        }
        
        return $isBot === 1 || strpos($_SERVER['HTTP_USER_AGENT'], 'Google Page Speed') !== false ? true : false;
    }
    
    public static function getBestCustomerGroupByLocation($return_object = false){
        
        // location begin

        $db = JFactory::getDbo();
        
        $group = null;

        $form = CrBcHelpers::getBcConfig();

        // if location based tax rules are enabled and actually have been executed before....

        $customer_id = 0;
        
        if( intval(JFactory::getUser()->get('id', 0)) != 0 ){
            JFactory::getDbo()->setQuery("Select id From #__breezingcommerce_customers Where userid = " . intval(JFactory::getUser()->get('id', 0)) . " Limit 1");
            $customer_id = JFactory::getDbo()->loadResult();
        }
        
        if(  !$customer_id && $form->get('location_based_tax_rules', 0) == 1 && JFactory::getSession()->get('com_breezingcommerce.userlocation', null) !== null ){
            
            // ....try to find the best matching customer group and use it in the behalf of the customer

            $location = JFactory::getSession()->get('com_breezingcommerce.userlocation', null);

            if($location->country_code !== null){

                $db->setQuery("
                Select
                        groups.*  
                    From 
                        #__breezingcommerce_customergroups groups,
                        #__breezingcommerce_countries countries
                        ".($location->region_code !== null ? ',#__breezingcommerce_country_regions As regions' : '')."
                    Where
                        Upper(Trim(countries.code)) = ".$db->quote(strtoupper($location->country_code))."
                    And
                        groups.`default_country_id` = countries.id
                    ".($location->region_code !== null ? " And regions.country_id =  countries.id " : '')."
                    ".($location->region_code !== null ? " And Upper(Trim(regions.code)) =  ".$db->quote(strtoupper($location->region_code))." " : '')."
                    ".($location->region_code !== null ? " And groups.default_region_id =  regions.id " : '')."

                Limit 1");

                if($return_object){
                    $group = $db->loadObject();
                }else{
                    $group = $db->loadAssoc();
                }
                
                if($group){

                    return $group;
                }
                else if( $form->get('location_based_tax_rules_lax', 0) == 1 ){

                    // once more, in case a region was given but there is none specified in database
                    // then we just try the country (if allowed to be lax on this)
                    $db->setQuery("
                    Select
                        Distinct
                            groups.*  
                        From 
                            #__breezingcommerce_customergroups groups,
                            #__breezingcommerce_countries countries
                        Where
                            Upper(Trim(countries.code)) = ".$db->quote(strtoupper($location->country_code))."
                        And
                            groups.`default_country_id` = countries.id

                    Limit 1");

                    if($return_object){
                        $group = $db->loadObject();
                    }else{
                        $group = $db->loadAssoc();
                    }

                    if($group){

                        return $group;
                    }
                }
            }
        } else 
        if(  $customer_id > 0 && $form->get('location_based_tax_rules', 0) == 1 && JFactory::getSession()->get('com_breezingcommerce.userlocation', null) !== null ){
            
            $db->setQuery("Select Distinct groups.* From #__breezingcommerce_customergroups groups, #__breezingcommerce_customers customers Where customers.customergroup_id = groups.id And customers.id = " . $db->quote($customer_id) . " Limit 1");
            if($return_object){
                $group = $db->loadObject();
            }else{
                $group = $db->loadAssoc();
            }

            if($group){

                return $group;
                
            }
        }
        
        return $group;

        // location end
    }
    
    /**
     * Determine the current product ID either by request parameter or if a product ID is loaded from within a menu item
     */
    public static function determineCurrentProductId(){
        
        if(JRequest::getVar('controller',  '') != 'product' && JRequest::getVar('view',  '') != 'product'){
            
            return 0;
        }
        
        $product_id = JRequest::getInt('product_id',  0);
        $item = JFactory::getApplication()->getMenu()->getActive();
        if (is_object($item) && $item->component == 'com_breezingcommerce') {
            if($item->params->get('is_product', null) !== null && $item->params->get('is_product', null) == 1){
                $product_id = intval($item->params->get('product_id', null));
            }
        }
        
        return $product_id;
    }
    
    public static function determineCurrentCategoryId(){
        
        if(JRequest::getVar('controller',  '') != 'category' && JRequest::getVar('view',  '') != 'category'){
            
            return 0;
        }
        
        $category_id = JRequest::getInt('category_id',  0);
        $active = JFactory::getApplication()->getMenu()->getActive();
        if(is_object($active) && $active->params->get('category_id')){
            $category_id = $active->params->get('category_id');
        }
        
        return $category_id;
    }
    
    public static function copyTranslations($src_item_id, $dest_item_id, $type){
        
        $db = JFactory::getDbo();
        
        $db->setQuery("Select * From #__breezingcommerce_translations Where type = ".$db->quote($type)." And item_id = " . intval($src_item_id) );
        $translations = $db->loadAssocList();
        foreach($translations As $translation)
        {
            $fields = array();
            
            foreach($translation As $key => $value){
                if($key != 'ordering' && $key != 'id' && $key != 'item_id' && $key != 'language_code' && $key != 'type'){
                    $fields[$key] = $value;
                }
            }

            self::storeTranslation($fields, $dest_item_id, $type, $translation['language_code']);
        }
    }
    
    public static function populateTranslation($subject, $type, $keymap, $override_language_code = null){
        
        if(is_array( $subject )){
        
            $index = 0;
            $subject_ids = array();
            $finder = array();
            foreach( $subject As $sub ){
                if(!isset($sub->id)){
                    $index++;
                    continue;
                }
                $subject_ids[] = $sub->id;
                $finder[$sub->id] = $index;
                $index++;
            }

            if(count($subject_ids)){

                $translated_objects = CrBcHelpers::loadTranslation($subject_ids, $type);

                if($translated_objects !== null){

                    foreach($translated_objects As $translated_object){
                        if(isset($keymap['title']) && isset($subject[$finder[$translated_object->item_id]]->{$keymap['title']})){
                            $subject[$finder[$translated_object->item_id]]->{$keymap['title']} = $translated_object->title;
                        }
                        if(isset($keymap['body']) && isset($subject[$finder[$translated_object->item_id]]->{$keymap['body']})){
                            $subject[$finder[$translated_object->item_id]]->{$keymap['body']} = $translated_object->body;
                        }
                        if(isset($keymap['alias']) && isset($subject[$finder[$translated_object->item_id]]->{$keymap['alias']})){
                            $subject[$finder[$translated_object->item_id]]->{$keymap['alias']} = $translated_object->alias;
                        }
                    }
                }
            }
        
            return $subject;
        }
        else
        {
            if(is_object($subject)){
                
                if(!isset($subject->id)){
                    return $subject;
                }
                
                $translated_object = CrBcHelpers::loadTranslation($subject->id, $type);
                
                if($translated_object !== null){
                    $subject->description = $translated_object->body;
                    $subject->title = $translated_object->title;
                    $subject->alias = $translated_object->alias;
                    
                    if(isset($keymap['title']) && isset($subject->{$keymap['title']})){
                        $subject->{$keymap['title']} = $translated_object->title;
                    }
                    if(isset($keymap['body']) && isset($subject->{$keymap['body']})){
                        $subject->{$keymap['body']} = $translated_object->body;
                    }
                    if(isset($keymap['alias']) && isset($subject->{$keymap['alias']})){
                        $subject->{$keymap['alias']} = $translated_object->alias;
                    }
                }
                
                return $subject;
            }
        }
        
        return $subject;
    }
    
    public static function loadTranslation($item_id, $type, $override_language_code = null){
        
        $db = JFactory::getDbo();
        
        $item_id_str = '';
        
        $is_multi = false;
        
        if(is_array($item_id) && count($item_id)){
            
            $item_id = \Joomla\Utilities\ArrayHelper::toInteger($item_id);
            
            $item_id_str = 'item_id In ('.implode(',', $item_id).')';
            
            $is_multi = true;
        }
        else if(is_array($item_id))
        {
            return null;
        }
        else
        {
            $item_id_str = "item_id = " . $db->quote($item_id);
        }
        
        if(JFactory::getApplication()->isAdmin() ){
            
            if( ( JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','') != '' || $override_language_code !== null ) ){
                $db->setQuery("Select * From #__breezingcommerce_translations Where type = " . $db->quote($type) . " And ".$item_id_str." And language_code = " . ( $override_language_code === null ? $db->quote( JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','') ) : $db->quote($override_language_code) ));
                if($is_multi){
                    return $db->loadObjectList();
                }
                return $db->loadObject();
            }
            
        }else if(count(JFactory::getLanguage()->getKnownLanguages()) > 1){
            
            $db->setQuery("Select * From #__breezingcommerce_translations Where type = " . $db->quote($type) . " And ".$item_id_str." And language_code = " . ( $override_language_code === null ? $db->quote( JFactory::getLanguage()->getTag() ) : $db->quote($override_language_code) ));
            
            if($is_multi){
                return $db->loadObjectList();
            }
            return $db->loadObject();
        }
        return null;
    }
    
    public static function assignTranslation(array $assignment_options, stdClass $row, $item_id, $type, $override_language_code = null){
        
        $trans = self::loadTranslation($item_id, $type, $override_language_code);
        if($trans !== null){
            foreach($assignment_options As $src => $dest){
                if(isset($trans->{$src})){
                    $row->{$dest} = $trans->{$src};
                }
            }
        }

        return $row;
    }
    
    public static function storeTranslation($fields, $item_id, $type, $override_language_code = null, $ordering = 0){
        
        // translations
        if( count($fields) && ( JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','') != '' || $override_language_code !== null ) ){
            
            $db = JFactory::getDbo();
        
            $keys = '';
            $inserts = '';
            $updates = '';

            foreach($fields As $key => $value){
                $keys .= $db->quoteName($key).',';
                $inserts .= $db->quote($value) . ',';
                $updates .= $db->quoteName($key).'='.$db->quote($value).',';
                $updates .= ' ordering='.intval($ordering).',';
            }

            $keys = rtrim($keys,',');
            $inserts = rtrim($inserts,',');
            $updates = rtrim($updates,',');
            
            $db->setQuery("INSERT INTO #__breezingcommerce_translations (".$keys.",item_id, language_code, `type`, ordering) VALUES
                  (
                    ".$inserts.",
                    ".$item_id.",
                    ".( $override_language_code === null ? $db->quote( JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','') ) : $db->quote($override_language_code) ).",
                    ".$db->quote($type).",
                    ".intval($ordering)."
                    )
                  ON DUPLICATE KEY UPDATE 
                    ".$updates."
                ");
            
            $db->execute();
        }
    }
    
   /**
    *
    * @return JParameter 
    */
   public static function getBcConfig(){
        static $form;
        if( !($form instanceof JRegistry) ){
            $query = 'Select attribs From #__breezingcommerce_configuration Order By id Desc Limit 1';
            JFactory::getDBO()->setQuery($query);
            $result = JFactory::getDBO()->loadResult();
            $form = new JRegistry(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'models'.DS.'forms'.DS.'configuration.xml');
            $form->loadString($result ? $result : null);
            return $form;
        }
        return $form;
   }

   public static function listReadonly($row, $i, $imgY = 'check', $imgX = 'times', $prefix='') {
       
        JFactory::getDocument()->addStyleSheet(Juri::root(true).'/components/com_breezingcommerce/css/font-awesome/css/font-awesome.min.css');
       
        $img = $row->readonly ? $imgY : $imgX;
        $task = $row->readonly ? 'unreadonly' : 'readonly';
        $alt = $row->readonly ? JText::_('Publish') : JText::_('Not Published');
        $action = $row->readonly ? JText::_('Unpublish Item') : JText::_('Publish Item');

        $href = '
		<a href="javascript:void(0);" onclick="return listItemTask(\'cb' . $i . '\',\'' . $prefix . $task . '\')" title="' . $action . '">
		<i style="color:'.($row->readonly ? 'green' : 'red').';font-size:24px;" class="crbc-fa crbc-fa-'.$img.'"></i></a>'
        ;

        return $href;
    }
   
   public static function listPublished($row, $i, $imgY = 'check', $imgX = 'times', $prefix='') {
       
        JFactory::getDocument()->addStyleSheet(Juri::root(true).'/components/com_breezingcommerce/css/font-awesome/css/font-awesome.min.css');
       
        $img = $row->published ? $imgY : $imgX;
        $task = $row->published ? 'unpublish' : 'publish';
        $alt = $row->published ? JText::_('Publish') : JText::_('Not Published');
        $action = $row->published ? JText::_('Unpublish Item') : JText::_('Publish Item');

        $href = '
		<a href="javascript:void(0);" onclick="return listItemTask(\'cb' . $i . '\',\'' . $prefix . $task . '\')" title="' . $action . '">
		<i style="color:'.($row->published ? 'green' : 'red').';font-size:24px;" class="crbc-fa crbc-fa-'.$img.'"></i></a>'
        ;

        return $href;
    }
   
   public static function listVerified($row, $i, $imgY = 'check', $imgX = 'times', $prefix='') {
       
        JFactory::getDocument()->addStyleSheet(Juri::root(true).'/components/com_breezingcommerce/css/font-awesome/css/font-awesome.min.css');
       
        $img = $row->verified ? $imgY : $imgX;
        $task = $row->verified ? 'unverify' : 'verify';
        $alt = $row->verified ? JText::_('Verified') : JText::_('Not Verified');
        $action = $row->verified ? JText::_('Unverify Item') : JText::_('Verify Item');

        $href = '
		<a href="javascript:void(0);" onclick="return listItemTask(\'cb' . $i . '\',\'' . $prefix . $task . '\')" title="' . $action . '">
		<i style="color:'.($row->verified ? 'green' : 'red').';font-size:24px;" class="crbc-fa crbc-fa-'.$img.'"></i></a>'
        ;

        return $href;
    }

   public static function listRequired($row, $i, $imgY = 'check', $imgX = 'times', $prefix='') {
        $img = $row->required ? $imgY : $imgX;
        $task = $row->required ? 'unrequired' : 'required';
        $alt = $row->required ? JText::_('Required') : JText::_('Not Required');
        $action = $row->required ? JText::_('Unrequire Item') : JText::_('Require Item');

        $href = '
		<a href="javascript:void(0);" onclick="return listItemTask(\'cb' . $i . '\',\'' . $prefix . $task . '\')" title="' . $action . '">
		<i style="color:'.($row->required ? 'green' : 'red').';font-size:24px;" class="crbc-fa crbc-fa-'.$img.'"></i></a>'
        ;

        return $href;
    }
    
    public static function registerUser($name, $username, $email, $password)
    {
        JFactory::getLanguage()->load('com_users', JPATH_SITE);

        $params = JComponentHelper::getParams('com_users');

        // Initialise the table with JUser.
        $user = new JUser;
        
        $data = array();
        
        $data['email'] = $email;
        $data['name'] = $name;
        $data['username'] = $username;
        $data['password'] = $password;
        
        $data['groups'] = array();
        $data['groups'][] = $params->get('new_usertype', 2);;
        
        // Prepare the data for the user object.
        $data['email'] = JStringPunycode::emailToPunycode($data['email']);
        $useractivation = $params->get('useractivation');
        $sendpassword = $params->get('sendpassword', 1);

        // Check if the user needs to activate their account.
        if (($useractivation == 1) || ($useractivation == 2))
        {
                $data['activation'] = JApplication::getHash(JUserHelper::genRandomPassword());
                $data['block'] = 1;
        }

        // Bind the data.
        if (!$user->bind($data))
        {
                return JText::sprintf('COM_USERS_REGISTRATION_BIND_FAILED', $user->getError());
        }

        // Load the users plugin group.
        JPluginHelper::importPlugin('user');

        // Store the data.
        if (!$user->save())
        {
                return JText::sprintf('COM_USERS_REGISTRATION_SAVE_FAILED', $user->getError());
        }

        $config = JFactory::getConfig();
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);

        // Compile the notification mail values.
        $data = $user->getProperties();
        $data['fromname'] = $config->get('fromname');
        $data['mailfrom'] = $config->get('mailfrom');
        $data['sitename'] = $config->get('sitename');
        $data['siteurl'] = JUri::root();

        // Handle account activation/confirmation emails.
        if ($useractivation == 2)
        {
                // Set the link to confirm the user email.
                $uri = JUri::getInstance();
                $base = $uri->toString(array('scheme', 'user', 'pass', 'host', 'port'));
                $data['activate'] = $base . JRoute::_('index.php?option=com_users&task=registration.activate&token=' . $data['activation'], false);

                // removing administrator part, the registrations are frontend, only
                $pos = strpos($data['activate'], '/administrator/');
                if ($pos !== false) {
                    $data['activate'] = substr_replace($data['activate'], '/', $pos, strlen('/administrator/'));
                }
                
                $emailSubject = JText::sprintf(
                        'COM_USERS_EMAIL_ACCOUNT_DETAILS',
                        $data['name'],
                        $data['sitename']
                );

                if ($sendpassword)
                {
                        $emailBody = JText::sprintf(
                                'COM_USERS_EMAIL_REGISTERED_WITH_ADMIN_ACTIVATION_BODY',
                                $data['name'],
                                $data['sitename'],
                                $data['activate'],
                                $data['siteurl'],
                                $data['username'],
                                $data['password_clear']
                        );
                }
                else
                {
                        $emailBody = JText::sprintf(
                                'COM_USERS_EMAIL_REGISTERED_WITH_ADMIN_ACTIVATION_BODY_NOPW',
                                $data['name'],
                                $data['sitename'],
                                $data['activate'],
                                $data['siteurl'],
                                $data['username']
                        );
                }
        }
        elseif ($useractivation == 1)
        {
                // Set the link to activate the user account.
                $uri = JUri::getInstance();
                $base = $uri->toString(array('scheme', 'user', 'pass', 'host', 'port'));
                $data['activate'] = $base . JRoute::_('index.php?option=com_users&task=registration.activate&token=' . $data['activation'], false);

                // removing administrator part, the registrations are frontend, only
                $pos = strpos($data['activate'], '/administrator/');
                if ($pos !== false) {
                    $data['activate'] = substr_replace($data['activate'], '/', $pos, strlen('/administrator/'));
                }
                
                $emailSubject = JText::sprintf(
                        'COM_USERS_EMAIL_ACCOUNT_DETAILS',
                        $data['name'],
                        $data['sitename']
                );

                if ($sendpassword)
                {
                        $emailBody = JText::sprintf(
                                'COM_USERS_EMAIL_REGISTERED_WITH_ACTIVATION_BODY',
                                $data['name'],
                                $data['sitename'],
                                $data['activate'],
                                $data['siteurl'],
                                $data['username'],
                                $data['password_clear']
                        );
                }
                else
                {
                        $emailBody = JText::sprintf(
                                'COM_USERS_EMAIL_REGISTERED_WITH_ACTIVATION_BODY_NOPW',
                                $data['name'],
                                $data['sitename'],
                                $data['activate'],
                                $data['siteurl'],
                                $data['username']
                        );
                }
        }
        else
        {

                $emailSubject = JText::sprintf(
                        'COM_USERS_EMAIL_ACCOUNT_DETAILS',
                        $data['name'],
                        $data['sitename']
                );

                if ($sendpassword)
                {
                        $emailBody = JText::sprintf(
                                'COM_USERS_EMAIL_REGISTERED_BODY',
                                $data['name'],
                                $data['sitename'],
                                $data['siteurl'],
                                $data['username'],
                                $data['password_clear']
                        );
                }
                else
                {
                        $emailBody = JText::sprintf(
                                'COM_USERS_EMAIL_REGISTERED_BODY_NOPW',
                                $data['name'],
                                $data['sitename'],
                                $data['siteurl']
                        );
                }
        }

        // Send the registration email.
        $return = JFactory::getMailer()->sendMail($data['mailfrom'], $data['fromname'], $data['email'], $emailSubject, $emailBody);

        // Send Notification mail to administrators
        if (($params->get('useractivation') < 2) && ($params->get('mail_to_admin') == 1))
        {
                $emailSubject = JText::sprintf(
                        'COM_USERS_EMAIL_ACCOUNT_DETAILS',
                        $data['name'],
                        $data['sitename']
                );

                $emailBodyAdmin = JText::sprintf(
                        'COM_USERS_EMAIL_REGISTERED_NOTIFICATION_TO_ADMIN_BODY',
                        $data['name'],
                        $data['username'],
                        $data['siteurl']
                );

                // Get all admin users
                $query->clear()
                        ->select($db->quoteName(array('name', 'email', 'sendEmail')))
                        ->from($db->quoteName('#__users'))
                        ->where($db->quoteName('sendEmail') . ' = ' . 1);

                $db->setQuery($query);

                try
                {
                        $rows = $db->loadObjectList();
                }
                catch (RuntimeException $e)
                {
                        return JText::sprintf('COM_USERS_DATABASE_ERROR', $e->getMessage());
                }

                // Send mail to all superadministrators id
                foreach ($rows as $row)
                {
                        $return = JFactory::getMailer()->sendMail($data['mailfrom'], $data['fromname'], $row->email, $emailSubject, $emailBodyAdmin);

                        // Check for an error.
                        if ($return !== true)
                        {
                                return JText::_('COM_USERS_REGISTRATION_ACTIVATION_NOTIFY_SEND_MAIL_FAILED');
                        }
                }
        }

        // Check for an error.
        if ($return !== true)
        {
                JFactory::getApplication()->enqueueMessage(JText::_('COM_USERS_REGISTRATION_SEND_MAIL_FAILED'));

                // Send a system message to administrators receiving system mails
                $db = JFactory::getDbo();
                $query->clear()
                        ->select($db->quoteName(array('name', 'email', 'sendEmail', 'id')))
                        ->from($db->quoteName('#__users'))
                        ->where($db->quoteName('block') . ' = ' . (int) 0)
                        ->where($db->quoteName('sendEmail') . ' = ' . (int) 1);
                $db->setQuery($query);

                try
                {
                        $sendEmail = $db->loadColumn();
                }
                catch (RuntimeException $e)
                {
                        return JText::sprintf('COM_USERS_DATABASE_ERROR', $e->getMessage());
                }

                if (count($sendEmail) > 0)
                {
                        $jdate = new JDate;

                        // Build the query to add the messages
                        foreach ($sendEmail as $userid)
                        {
                                $values = array($db->quote($userid), $db->quote($userid), $db->quote($jdate->toSql()), $db->quote(JText::_('COM_USERS_MAIL_SEND_FAILURE_SUBJECT')), $db->quote(JText::sprintf('COM_USERS_MAIL_SEND_FAILURE_BODY', $return, $data['username'])));
                                $query->clear()
                                        ->insert($db->quoteName('#__messages'))
                                        ->columns($db->quoteName(array('user_id_from', 'user_id_to', 'date_time', 'subject', 'message')))
                                        ->values(implode(',', $values));
                                $db->setQuery($query);

                                try
                                {
                                        $db->execute();
                                }
                                catch (RuntimeException $e)
                                {
                                        return JText::sprintf('COM_USERS_DATABASE_ERROR', $e->getMessage());
                                }
                        }
                }
                return false;
        }

        return $user->id;
    }

    public static function isEmail($email, $checkDNS = false) {
        //      Check that $email is a valid address
        //              (http://tools.ietf.org/html/rfc3696)
        //              (http://tools.ietf.org/html/rfc2822)
        //              (http://tools.ietf.org/html/rfc5322#section-3.4.1)
        //              (http://tools.ietf.org/html/rfc5321#section-4.1.3)
        //              (http://tools.ietf.org/html/rfc4291#section-2.2)
        //              (http://tools.ietf.org/html/rfc1123#section-2.1)
        //      the upper limit on address lengths should normally be considered to be 256
        //              (http://www.rfc-editor.org/errata_search.php?rfc=3696)
        if (strlen($email) > 256)
            return false;   //      Too long
            //      Contemporary email addresses consist of a "local part" separated from
            //      a "domain part" (a fully-qualified domain name) by an at-sign ("@").
            //              (http://tools.ietf.org/html/rfc3696#section-3)
 $index = strrpos($email, '@');

        if ($index === false)
            return false;   //      No at-sign
 if ($index === 0)
            return false;   //      No local part
 if ($index > 64)
            return false;   //      Local part too long

            $localPart = substr($email, 0, $index);
        $domain = substr($email, $index + 1);
        $domainLength = strlen($domain);

        if ($domainLength === 0)
            return false;   //      No domain part
 if ($domainLength > 255)
            return false;   //      Domain part too long
            //      Let's check the local part for RFC compliance...
            //
            //      local-part      =       dot-atom / quoted-string / obs-local-part
            //      obs-local-part  =       word *("." word)
            //              (http://tools.ietf.org/html/rfc2822#section-3.4.1)
 if (preg_match('/^"(?:.)*"$/', $localPart) > 0) {
            $dotArray[] = $localPart;
        } else {
            $dotArray = explode('.', $localPart);
        }

        foreach ($dotArray as $localElement) {
            //      Period (".") may...appear, but may not be used to start or end the
            //      local part, nor may two or more consecutive periods appear.
            //              (http://tools.ietf.org/html/rfc3696#section-3)
            //
            //      A zero-length element implies a period at the beginning or end of the
            //      local part, or two periods together. Either way it's not allowed.
            if ($localElement === '')
                return false;   //      Dots in wrong place
                //      Each dot-delimited component can be an atom or a quoted string
                //      (because of the obs-local-part provision)
 if (preg_match('/^"(?:.)*"$/', $localElement) > 0) {
                //      Quoted-string tests:
                //
                //      Note that since quoted-pair
                //      is allowed in a quoted-string, the quote and backslash characters may
                //      appear in a quoted-string so long as they appear as a quoted-pair.
                //              (http://tools.ietf.org/html/rfc2822#section-3.2.5)
                $groupCount = preg_match_all('/(?:^"|"$|\\\\\\\\|\\\\")|(\\\\|")/', $localElement, $matches);
                array_multisort($matches[1], SORT_DESC);
                if ($matches[1][0] !== '')
                    return false;   //      Unescaped quote or backslash character inside quoted string
 if (preg_match('/^"\\\\*"$/', $localElement) > 0)
                    return false;   //      "" and "\" are slipping through - note: must tidy this up

            } else {
                //      Unquoted string tests:
                //
                //      Any ASCII graphic (printing) character other than the
                //      at-sign ("@"), backslash, double quote, comma, or square brackets may
                //      appear without quoting.  If any of that list of excluded characters
                //      are to appear, they must be quoted
                //              (http://tools.ietf.org/html/rfc3696#section-3)
                //
                $stripped = '';
                //      Any excluded characters? i.e. <space>, @, [, ], \, ", <comma>
                if (preg_match('/[ @\\[\\]\\\\",]/', $localElement) > 0)
                //      Check all excluded characters are escaped
                    $stripped = preg_replace('/\\\\[ @\\[\\]\\\\",]/', '', $localElement);
                if (preg_match('/[ @\\[\\]\\\\",]/', $stripped) > 0)
                    return false;   //      Unquoted excluded characters

            }
        }

        //      Now let's check the domain part...
        //      The domain name can also be replaced by an IP address in square brackets
        //              (http://tools.ietf.org/html/rfc3696#section-3)
        //              (http://tools.ietf.org/html/rfc5321#section-4.1.3)
        //              (http://tools.ietf.org/html/rfc4291#section-2.2)
        if (preg_match('/^\\[(.)+]$/', $domain) === 1) {
            //      It's an address-literal
            $addressLiteral = substr($domain, 1, $domainLength - 2);
            $matchesIP = array();

            //      Extract IPv4 part from the end of the address-literal (if there is one)
            if (preg_match('/\\b(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/', $addressLiteral, $matchesIP) > 0) {
                $index = strrpos($addressLiteral, $matchesIP[0]);

                if ($index === 0) {
                    //      Nothing there except a valid IPv4 address, so...
                    return true;
                } else {
                    //      Assume it's an attempt at a mixed address (IPv6 + IPv4)
                    if ($addressLiteral[$index - 1] !== ':')
                        return false;   //      Character preceding IPv4 address must be ':'
 if (substr($addressLiteral, 0, 5) !== 'IPv6:')
                        return false;   //      RFC5321 section 4.1.3

                        $IPv6 = substr($addressLiteral, 5, ($index === 7) ? 2 : $index - 6);
                    $groupMax = 6;
                }
            } else {
                //      It must be an attempt at pure IPv6
                if (substr($addressLiteral, 0, 5) !== 'IPv6:')
                    return false;   //      RFC5321 section 4.1.3
 $IPv6 = substr($addressLiteral, 5);
                $groupMax = 8;
            }

            $groupCount = preg_match_all('/^[0-9a-fA-F]{0,4}|\\:[0-9a-fA-F]{0,4}|(.)/', $IPv6, $matchesIP);
            $index = strpos($IPv6, '::');

            if ($index === false) {
                //      We need exactly the right number of groups
                if ($groupCount !== $groupMax)
                    return false;   //      RFC5321 section 4.1.3

            } else {
                if ($index !== strrpos($IPv6, '::'))
                    return false;   //      More than one '::'
 $groupMax = ($index === 0 || $index === (strlen($IPv6) - 2)) ? $groupMax : $groupMax - 1;
                if ($groupCount > $groupMax)
                    return false;   //      Too many IPv6 groups in address

            }

            //      Check for unmatched characters
            array_multisort($matchesIP
                    [1], SORT_DESC);
            if ($matchesIP[1][0] !== '')
                return false;   //      Illegal characters in address
                //      It's a valid IPv6 address, so...
 return true;
        } else {
            //      It's a domain name...
            //      The syntax of a legal Internet host name was specified in RFC-952
            //      One aspect of host name syntax is hereby changed: the
            //      restriction on the first character is relaxed to allow either a
            //      letter or a digit.
            //              (http://tools.ietf.org/html/rfc1123#section-2.1)
            //
            //      NB RFC 1123 updates RFC 1035, but this is not currently apparent from reading RFC 1035.
            //
            //      Most common applications, including email and the Web, will generally not permit...escaped strings
            //              (http://tools.ietf.org/html/rfc3696#section-2)
            //
            //      Characters outside the set of alphabetic characters, digits, and hyphen MUST NOT appear in domain name
            //      labels for SMTP clients or servers
            //              (http://tools.ietf.org/html/rfc5321#section-4.1.2)
            //
            //      RFC5321 precludes the use of a trailing dot in a domain name for SMTP purposes
            //              (http://tools.ietf.org/html/rfc5321#section-4.1.2)
            $matches = array();
            $groupCount = preg_match_all('/(?:[0-9a-zA-Z][0-9a-zA-Z-]{0,61}[0-9a-zA-Z]|[a-zA-Z])(?:\\.|$)|(.)/', $domain, $matches);
            $level = count($matches[0]);

            if ($level == 1)
                return false;   //      Mail host can't be a TLD

                $TLD = $matches[0][$level - 1];
            if (substr($TLD, strlen($TLD) - 1, 1) === '.')
                return false;   //      TLD can't end in a dot
 if (preg_match('/^[0-9]+$/', $TLD) > 0)
                return false;   //      TLD can't be all-numeric
                //      Check for unmatched characters
 array_multisort($matches[1], SORT_DESC);
            if ($matches[1][0] !== '')
                return false;   //      Illegal characters in domain, or label longer than 63 characters
                //      Check DNS?
            if ($checkDNS && function_exists('checkdnsrr')) {
                if (!(checkdnsrr($domain, 'A') || checkdnsrr($domain, 'MX'))) {
                    return false;   //      Domain doesn't actually exist
                }
            }

            //      Eliminate all other factors, and the one which remains must be the truth.
            //              (Sherlock Holmes, The Sign of Four)
            return true;
        }
    }

}