<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// No direct access
defined('_JEXEC') or die('Restricted access');

$libpath = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce' . DS . 'classes' . DS . 'plugin' . DS;
require_once($libpath . 'CrBcUserlocationPlugin.php');

/**
 * Every method has to be implemented.
 * 
 * IF A RETURN VALUE IS NOT PROVIDED BY THE SERVICE, PLEASE RETURN NULL!
 */
interface CrBcUserlocationSitePlugin extends CrBcUserlocationPlugin{
    
    /**
     * This methode must be implemented correctly.
     * If you for example call an ip geolocation based cloud service and there is 
     * any error on the response, then please return a fals here.
     * 
     * The store will then try the next available geolocation plugin as fallback and son on.
     * 
     * @return boolean true if there is an error and false if the result is valid
     */
    public function hasError();
    
    /**
     * @return The time zone string
     */
    public function getTimeZone();
    
    /**
     * @return The continent code
     */
    public function getContinentCode();
    
    /**
     * @return The regular continent name
     */
    public function getContinent();
    
    /**
     * @return The country code
     */
    public function getCountryCode();
    
    /**
     * @return The regular country name
     */
    public function getCountry();
    
    /**
     * @return The region code
     */
    public function getRegionCode();
    
    /**
     * @return The regular region name
     */
    public function getRegion();
    
    /**
     * @return the city code
     */
    public function getCityCode();
    
    /**
     * @return the regular city name
     */
    public function getCity();
    
    /**
     * @return the zip code
     */
    public function getZipCode();
    
    /**
     * @return the long. value
     */
    public function getLongitude();
    
    /**
     * @return the latt. value
     */
    public function getLatitude();
}