<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// no direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');

class BreezingcommerceControllerCountries extends JControllerLegacy
{
    function __construct()
    {
        parent::__construct();
        
        // Register Extra tasks
        $this->registerTask( 'add', 'edit' );
    }

    function orderup() {
        $model = $this->getModel( 'country' );
        $model->move(-1);
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=countries&limitstart='.JRequest::getInt('limitstart') );
    }

    function listorderup() {
        $model = $this->getModel( 'country' );
        $model->listMove(-1);
        JRequest::setVar( 'view', 'country' );
        JRequest::setVar( 'layout', 'form'  );
        JRequest::setVar( 'hidemainmenu', 1 );
        JRequest::setVar( 'filter_order', 'ordering' );
        JRequest::setVar( 'filter_order_Dir', 'asc' );
        JRequest::setVar( 'limitstart', JRequest::getInt('limitstart') );
        parent::display();
    }

    function orderdown() {
        $model = $this->getModel( 'country' );
        $model->move(1);
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=countries&limitstart='.JRequest::getInt('limitstart') );
    }

    function listorderdown() {
        $model = $this->getModel( 'country' );
        $model->listMove(1);
        JRequest::setVar( 'view', 'country' );
        JRequest::setVar( 'layout', 'form'  );
        JRequest::setVar( 'hidemainmenu', 1 );
        JRequest::setVar( 'filter_order', 'ordering' );
        JRequest::setVar( 'filter_order_Dir', 'asc' );
        JRequest::setVar( 'limitstart', JRequest::getInt('limitstart') );
        parent::display();
    }

    function saveorder(){
        $model = $this->getModel( 'countries' );
        $model->saveOrder();
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=countries&limitstart='.JRequest::getInt('limitstart') );
    }

    function listsaveorder(){
        $model = $this->getModel( 'country' );
        $model->listSaveOrder();
        JRequest::setVar( 'view', 'country' );
        JRequest::setVar( 'layout', 'form'  );
        JRequest::setVar( 'hidemainmenu', 1 );
        JRequest::setVar( 'filter_order', 'ordering' );
        JRequest::setVar( 'filter_order_Dir', 'asc' );
        JRequest::setVar( 'limitstart', JRequest::getInt('limitstart') );

        parent::display();
    }

    function publish() {
        $cid = JRequest::getVar('cid', array(), '', 'array');
        
        if(count($cid) == 1)
        {
            $model = $this->getModel( 'country' );
            $model->setPublished();
        }
        else if(count($cid) > 1)
        {
            $model = $this->getModel( 'countries' );
            $model->setPublished();
        }
        
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=countries&limitstart='.JRequest::getInt('limitstart'), JText::_('Country Published') );
    }

    function listpublish() {
        $cid = JRequest::getVar('cid', array(), '', 'array');

        $model = $this->getModel( 'country' );
        $model->setListPublished();

        JRequest::setVar( 'view', 'country' );
        JRequest::setVar( 'layout', 'form'  );
        JRequest::setVar( 'hidemainmenu', 1 );
        JRequest::setVar( 'filter_order', 'ordering' );
        JRequest::setVar( 'filter_order_Dir', 'asc' );
        JRequest::setVar( 'limitstart', JRequest::getInt('limitstart') );

        parent::display();
    }

    function unpublish() {
        $cid = JRequest::getVar('cid', array(), '', 'array');
        
        if(count($cid) == 1)
        {
            $model = $this->getModel( 'country' );
            $model->setUnpublished();
        }
        else if(count($cid) > 1)
        {
            $model = $this->getModel( 'countries' );
            $model->setUnpublished();
        }

        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=countries&limitstart='.JRequest::getInt('limitstart'), JText::_('Country Unpublished') );
    }

    function listunpublish() {
        $cid = JRequest::getVar('cid', array(), '', 'array');

        $model = $this->getModel( 'country' );
        $model->setListUnpublished();

        JRequest::setVar( 'view', 'country' );
        JRequest::setVar( 'layout', 'form'  );
        JRequest::setVar( 'hidemainmenu', 1 );
        JRequest::setVar( 'filter_order', 'ordering' );
        JRequest::setVar( 'filter_order_Dir', 'asc' );
        JRequest::setVar( 'limitstart', JRequest::getInt('limitstart') );

        parent::display();
    }

    /**
     * display the edit form
     * @return void
     */
    function edit()
    {
        JRequest::setVar( 'view', 'country' );
        JRequest::setVar( 'layout', 'form'  );
        JRequest::setVar( 'hidemainmenu', 1 );
        JRequest::setVar( 'filter_order', 'ordering' );
        JRequest::setVar( 'filter_order_Dir', 'asc' );
        parent::display();
    }

    function apply()
    {
        $this->save(true);
    }

    function save($keep_task = false)
    {
        $model = $this->getModel('country');

        if ($model->store()) {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_COUNTRY_SAVED' );
        } else {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_ERROR_SAVING_COUNTRY' );
        }

        $limit = 0;
        $additionalParams = '';
        if($keep_task){
            $id = JRequest::getInt('id', 0);
            if($id){
                $additionalParams = '&task=edit&cid[]='.$id;
                $limit = JRequest::getInt('limitstart');
            }
        }

        // Check the table in so it can be edited.... we are done with it anyway
        $link = 'index.php?option=com_breezingcommerce&controller=countries&limitstart='.$limit.$additionalParams;
        $this->setRedirect($link, $msg);
    }

    function saveNew()
    {
        $model = $this->getModel('country');

        if ($model->store()) {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_COUNTRY_SAVED' );
        } else {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_ERROR_SAVING_COUNTRY' );
        }

        // Check the table in so it can be edited.... we are done with it anyway
        $link = 'index.php?option=com_breezingcommerce&controller=countries&task=edit&limitstart='.JRequest::getInt('limitstart');
        $this->setRedirect($link, $msg);
    }

    function remove()
    {
        $type = 'message';
        $model = $this->getModel('country');
        $result = $model->delete();
        if($result === 1){
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_COUNTRY_COULD_NOT_BE_DELETED_BECAUSE_THERE_IS_A_CUSTOMERGROUP_USING_IT_AS_DEFAULT' );
            $type = 'error';
        }else
        if($result === false) {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_AT_LEAST_ONE_COUNTRY_COULD_NOT_BE_DELETED' );
        } else {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_COUNTRY_DELETED' );
        }

        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=countries&limitstart='.JRequest::getInt('limitstart'), $msg, $type );
    }

    function listremove()
    {
        $model = $this->getModel('country');
        $type = 'message';
        $result = $model->listDelete();
        if($result === 1){
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_REGION_COULD_NOT_BE_DELETED_BECAUSE_THERE_IS_A_CUSTOMER_GROUP_USING_IT_AS_DEFAULT' );
            $type = 'error';
        }else
        if($result === false) {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_AT_LEAST_ONE_REGION_COULD_NOT_BE_DELETED' );
        } else {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_REGIONS_DELETED' );
        }

        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=countries&view=country&task=edit&cid[]='.JRequest::getInt('id', 0).'hidemainmenu=1&filter_order=ordering&filter_order_Dir=asc&limitstart='.JRequest::getInt('limitstart', 0), $msg, $type );
    }

    function cancel()
    {
        $msg = JText::_( 'COM_BREEZINGCOMMERCE_OPERATION_CANCELLED' );
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=countries&limitstart=0', $msg );
    }

    function display($cachable = false, $urlparams = array())
    {
        JRequest::setVar('view', 'countries');
        
        parent::display();
    }
}
