<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// no direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');

class BreezingcommerceControllerCurrencies extends JControllerLegacy
{
    function __construct()
    {
        parent::__construct();
        
        // Register Extra tasks
        $this->registerTask( 'add', 'edit' );
        $this->registerTask( 'default', 'makeDefault' );
    }

    function orderup() {
        $model = $this->getModel( 'currency' );
        $model->move(-1);
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=currencies&limitstart='.JRequest::getInt('limitstart') );
    }

    function orderdown() {
        $model = $this->getModel( 'currency' );
        $model->move(1);
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=currencies&limitstart='.JRequest::getInt('limitstart') );
    }

    function saveorder(){
        $model = $this->getModel( 'currencies' );
        $model->saveOrder();
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=currencies&limitstart='.JRequest::getInt('limitstart') );
    }

    function makeDefault()
    {
        $cid = JRequest::getVar('cid', array(), '', 'array');
        $msg = '';
        $type = 'message';

        if(count($cid) != 0)
        {
            $model = $this->getModel( 'currency' );
            if($model->setDefault() === 1){
                $msg = JText::_( 'COM_BREEZINGCOMMERCE_YOU_CANNOT_CHANGE_THE_CURRENCY_BECAUSE_YOU_HAVE_UNFINISHED_ORDERS_PLEASE_FINISH_OR_DELETE_THEM_IN_ORDER_TO_CHANGE_THE_DEFAULT_CURRENCY' );
                $type = 'error';
            } else {
                $msg = JText::_('Currency now default');
            }
        }

        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=currencies&limitstart='.JRequest::getInt('limitstart'), $msg, $type );
    }

    function publish() {
        $cid = JRequest::getVar('cid', array(), '', 'array');
        
        if(count($cid) == 1)
        {
            $model = $this->getModel( 'currency' );
            $model->setPublished();
        }
        else if(count($cid) > 1)
        {
            $model = $this->getModel( 'currencies' );
            $model->setPublished();
        }
        
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=currencies&limitstart='.JRequest::getInt('limitstart'), JText::_('Currency Published') );
    }

    function unpublish() {
        $cid = JRequest::getVar('cid', array(), '', 'array');
        
        if(count($cid) == 1)
        {
            $model = $this->getModel( 'currency' );
            $model->setUnpublished();
        }
        else if(count($cid) > 1)
        {
            $model = $this->getModel( 'currencies' );
            $model->setUnpublished();
        }

        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=currencies&limitstart='.JRequest::getInt('limitstart'), JText::_('Currency Unpublished') );
    }

    /**
     * display the edit form
     * @return void
     */
    function edit()
    {
        JRequest::setVar( 'view', 'currency' );
        JRequest::setVar( 'layout', 'form'  );
        JRequest::setVar( 'hidemainmenu', 1 );

        parent::display();
    }

    function save()
    {
        $model = $this->getModel('currency');

        if ($model->store()) {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_CURRENCY_SAVED' );
        } else {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_ERROR_SAVING_CURRENCY' );
        }

        // Check the table in so it can be edited.... we are done with it anyway
        $link = 'index.php?option=com_breezingcommerce&controller=currencies&limitstart='.JRequest::getInt('limitstart');
        $this->setRedirect($link, $msg);
    }

    function remove()
    {
        $model = $this->getModel('currency');
        if(!$model->delete()) {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_AT_LEAST_ONE_CURRENCY_COULD_NOT_BE_DELETED' );
        } else {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_CURRENCY_DELETED' );
        }

        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=currencies&limitstart='.JRequest::getInt('limitstart'), $msg );
    }

    function cancel()
    {
        $msg = JText::_( 'COM_BREEZINGCOMMERCE_OPERATION_CANCELLED' );
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=currencies&limitstart='.JRequest::getInt('limitstart'), $msg );
    }

    function display($cachable = false, $urlparams = array())
    {
        JRequest::setVar('view', 'currencies');
        
        parent::display();
    }
}
