<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// no direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');

class BreezingcommerceControllerCustomergroups extends JControllerLegacy
{
    function __construct()
    {
        parent::__construct();
        
        // Register Extra tasks
        $this->registerTask( 'add', 'edit' );
        $this->registerTask( 'default', 'makeDefault' );
    }

    function orderup() {
        $model = $this->getModel( 'customergroup' );
        $model->move(-1);
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=customergroups&limitstart='.JRequest::getInt('limitstart') );
    }

    function orderdown() {
        $model = $this->getModel( 'customergroup' );
        $model->move(1);
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=customergroups&limitstart='.JRequest::getInt('limitstart') );
    }

    function saveorder(){
        $model = $this->getModel( 'customergroups' );
        $model->saveOrder();
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=customergroups&limitstart='.JRequest::getInt('limitstart') );
    }

    function makeDefault()
    {
        $cid = JRequest::getVar('cid', array(), '', 'array');

        if(count($cid) != 0)
        {
            $model = $this->getModel( 'customergroup' );
            $model->setDefault();
        }

        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=customergroups&limitstart='.JRequest::getInt('limitstart'), JText::_('Customergroup now default') );
    }

    function publish() {
        $cid = JRequest::getVar('cid', array(), '', 'array');
        
        if(count($cid) == 1)
        {
            $model = $this->getModel( 'customergroup' );
            $model->setPublished();
        }
        else if(count($cid) > 1)
        {
            $model = $this->getModel( 'customergroups' );
            $model->setPublished();
        }
        
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=customergroups&limitstart='.JRequest::getInt('limitstart'), JText::_('Customergroup Published') );
    }

    function unpublish() {
        $cid = JRequest::getVar('cid', array(), '', 'array');
        
        if(count($cid) == 1)
        {
            $model = $this->getModel( 'customergroup' );
            $model->setUnpublished();
        }
        else if(count($cid) > 1)
        {
            $model = $this->getModel( 'customergroups' );
            $model->setUnpublished();
        }

        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=customergroups&limitstart='.JRequest::getInt('limitstart'), JText::_('Customergroup Unpublished') );
    }

    /**
     * display the edit form
     * @return void
     */
    function edit()
    {
        JRequest::setVar( 'view', 'customergroup' );
        JRequest::setVar( 'layout', 'form'  );
        JRequest::setVar( 'hidemainmenu', 1 );

        parent::display();
    }

    function save()
    {
        $model = $this->getModel('customergroup');

        if ($model->store()) {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_CUSTOMERGROUP_SAVED' );
        } else {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_ERROR_SAVING_CUSTOMERGROUP' );
        }

        // Check the table in so it can be edited.... we are done with it anyway
        $link = 'index.php?option=com_breezingcommerce&controller=customergroups&limitstart='.JRequest::getInt('limitstart');
        $this->setRedirect($link, $msg);
    }

    function remove()
    {
        $model = $this->getModel('customergroup');
        if(!$model->delete()) {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_AT_LEAST_ONE_CUSTOMERGROUP_COULD_NOT_BE_DELETED' );
        } else {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_CUSTOMERGROUP_DELETED' );
        }

        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=customergroups&limitstart='.JRequest::getInt('limitstart'), $msg );
    }

    function cancelGroups()
    {
        $msg = JText::_( 'COM_BREEZINGCOMMERCE_OPERATION_CANCELLED' );
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=customers&limitstart='.JRequest::getInt('limitstart'), $msg );
    }

    function cancel()
    {
        $msg = JText::_( 'COM_BREEZINGCOMMERCE_OPERATION_CANCELLED' );
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=customergroups&limitstart='.JRequest::getInt('limitstart'), $msg );
    }

    function display($cachable = false, $urlparams = array())
    {
        JRequest::setVar('view', 'customergroups');
        
        parent::display();
    }
}
