<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// no direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');

class BreezingcommerceControllerImages extends JControllerLegacy
{
    function __construct()
    {
        parent::__construct();

        JRequest::setVar('tmpl', 'component');
    }

    function orderup() {
        $model = $this->getModel( 'image' );
        $model->move(-1);
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=images&limitstart='.JRequest::getInt('limitstart') );
    }

    function orderdown() {
        $model = $this->getModel( 'image' );
        $model->move(1);
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=images&limitstart='.JRequest::getInt('limitstart') );
    }

    function saveorder(){
        $model = $this->getModel( 'image' );
        $model->saveOrder();
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=images&limitstart='.JRequest::getInt('limitstart') );
    }

    function publish() {
        $cid = JRequest::getVar('cid', array(), '', 'array');

        if(count($cid) == 1)
        {
            $model = $this->getModel( 'image' );
            $model->setPublished();
        }
        else if(count($cid) > 1)
        {
            $model = $this->getModel( 'images' );
            $model->setPublished();
        }

        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=images&limitstart='.JRequest::getInt('limitstart'), JText::_('IMAGE_PUBLISHED') );
    }

    function unpublish() {
        $cid = JRequest::getVar('cid', array(), '', 'array');

        if(count($cid) == 1)
        {
            $model = $this->getModel( 'image' );
            $model->setUnpublished();
        }
        else if(count($cid) > 1)
        {
            $model = $this->getModel( 'images' );
            $model->setUnpublished();
        }

        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=images&limitstart='.JRequest::getInt('limitstart'), JText::_('IMAGE_UNPUBLISHED') );
    }

    /**
     * display the edit form
     * @return void
     */
    function edit()
    {
        JRequest::setVar( 'view', 'image' );
        JRequest::setVar( 'layout', 'form'  );
        JRequest::setVar( 'hidemainmenu', 1 );

        parent::display();
    }

    function save()
    {
        $model = $this->getModel('image');

        if ($model->store()) {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_IMAGE_SAVED' );
        } else {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_ERROR_SAVING_IMAGE' );
        }

        // Check the table in so it can be edited.... we are done with it anyway
        $link = 'index.php?option=com_breezingcommerce&controller=images&limitstart='.JRequest::getInt('limitstart');
        $this->setRedirect($link, $msg);
    }

    function remove()
    {
        $model = $this->getModel('image');
        if(!$model->delete()) {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_ONE_OR_MORE_IMAGES_COULD_NOT_BE_DELETED' );
        } else {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_IMAGE_DELETED' );
        }

        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=images&limitstart='.JRequest::getInt('limitstart'), $msg );
    }

    function cancel()
    {
        $msg = JText::_( 'Operation Cancelled' );
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=images&limitstart='.JRequest::getInt('limitstart'), $msg );
    }

    function display($cachable = false, $urlparams = array())
    {
        JRequest::setVar('view', 'images');

        parent::display();
    }
}
