<?php
/**
 * @package     Joomla.Administrator
 * @subpackage  com_content
 *
 * @copyright   Copyright (C) 2005 - 2014 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die('Restricted access');
jimport('joomla.html.html');
jimport('joomla.form.formfield');
/**
 * Supports a modal article picker.
 *
 * @package     Joomla.Administrator
 * @subpackage  com_content
 * @since       1.6
 */
class JFormFieldArticlepicker extends JFormField
{
	function getInput()
	{
                $backend_language = JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','');

                if($backend_language == ''){
                    $backend_language = JComponentHelper::getParams('com_languages')->get('administrator');
                }

                $languages = array();
                $_ids = array();
                if(trim($this->value)){
                    $languages = explode(',',$this->value);
                    foreach($languages As $language){
                        $language = explode(':', $language);
                        if(count($language) == 2){
                            $_ids[$language[0]] = $language[1];
                        }
                    }
                }
            
		$allowEdit		= ((string) $this->element['edit'] == 'true') ? true : false;
		$allowClear		= ((string) $this->element['clear'] != 'false') ? true : false;

		// Load language
		JFactory::getLanguage()->load('com_content', JPATH_ADMINISTRATOR);

		// Load the modal behavior script.
		JHtml::_('behavior.modal', 'a.modal');

		// Build the script.
		$script = array();

		// Select button script
		$script[] = '	function jSelectArticle_' . $this->id . '(id, title, catid, object) {';
                $script[] = '		var comma = ""; if(document.getElementById("' . $this->id . '_id").value != "") { comma = ","; } ';
                $script[] = '	        document.getElementById("' . $this->id . '_id").value = document.getElementById("' . $this->id . '_id").value.replace(/'.$backend_language.':[0-9]*,/gi,"")';
                $script[] = '	        document.getElementById("' . $this->id . '_id").value = document.getElementById("' . $this->id . '_id").value.replace(/,'.$backend_language.':[0-9]*/gi,"")';
                $script[] = '	        document.getElementById("' . $this->id . '_id").value = document.getElementById("' . $this->id . '_id").value.replace(/'.$backend_language.':[0-9]*/gi,"")';
                $script[] = '		document.getElementById("' . $this->id . '_id").value = document.getElementById("' . $this->id . '_id").value+comma+'.CrBcHelpers::jsonEncode($backend_language.':').'+id;';
		$script[] = '		document.getElementById("' . $this->id . '_name").value = title;';

		if ($allowEdit)
		{
			$script[] = '		jQuery("#' . $this->id . '_edit").removeClass("hidden");';
		}

		if ($allowClear)
		{
			$script[] = '		jQuery("#' . $this->id . '_clear").removeClass("hidden");';
		}

		$script[] = '		SqueezeBox.close();';
		$script[] = '	}';

		// Clear button script
		static $scriptClear;

		if ($allowClear && !$scriptClear)
		{
			$scriptClear = true;

			$script[] = '	function jClearArticle(id) {';
                        $script[] = '	        document.getElementById(id + "_id").value = document.getElementById(id + "_id").value.replace(/'.$backend_language.':[0-9]*,/gi,"")';
                        $script[] = '	        document.getElementById(id + "_id").value = document.getElementById(id + "_id").value.replace(/,'.$backend_language.':[0-9]*/gi,"")';
                        $script[] = '	        document.getElementById(id + "_id").value = document.getElementById(id + "_id").value.replace(/'.$backend_language.':[0-9]*/gi,"")';
			$script[] = '		document.getElementById(id + "_name").value = "' . htmlspecialchars(JText::_('COM_CONTENT_SELECT_AN_ARTICLE', true), ENT_COMPAT, 'UTF-8') . '";';
			$script[] = '		jQuery("#"+id + "_clear").addClass("hidden");';
			$script[] = '		if (document.getElementById(id + "_edit")) {';
			$script[] = '			jQuery("#"+id + "_edit").addClass("hidden");';
			$script[] = '		}';
			$script[] = '		return false;';
			$script[] = '	}';
		}

		// Add the script to the document head.
		JFactory::getDocument()->addScriptDeclaration(implode("\n", $script));

		// Setup variables for display.
		$html	= array();
		$link	= 'index.php?option=com_content&amp;view=articles&amp;layout=modal&amp;tmpl=component&amp;function=jSelectArticle_' . $this->id;

		$link .= '&amp;forcedLanguage=' . $backend_language;
		
		if (isset($_ids[$backend_language]) && (int) $_ids[$backend_language] > 0)
		{
			$db	= JFactory::getDbo();
			$query = $db->getQuery(true)
				->select($db->quoteName('title'))
				->from($db->quoteName('#__content'))
				->where($db->quoteName('id') . ' = ' . (int) $_ids[$backend_language]);
			$db->setQuery($query);

			try
			{
				$title = $db->loadResult();
			}
			catch (RuntimeException $e)
			{
				JError::raiseWarning(500, $e->getMessage());
			}
		}

		if (empty($title))
		{
			$title = JText::_('COM_CONTENT_SELECT_AN_ARTICLE');
		}
		$title = htmlspecialchars($title, ENT_QUOTES, 'UTF-8');

		// The active article id field.
		if (isset($_ids[$backend_language]) && (int) $_ids[$backend_language] > 0)
		{
			$value = (int) $_ids[$backend_language];
                } 
                else 
                {
                    $value = '';
                }

		// The current article display field.
		$html[] = '<span class="input-append">';
		$html[] = '<input type="text" class="input-medium" id="' . $this->id . '_name" value="' . $title . '" disabled="disabled" size="35" />';
		$html[] = '<a class="modal btn hasTooltip" title="' . JHtml::tooltipText('COM_CONTENT_CHANGE_ARTICLE') . '"  href="' . $link . '&amp;' . JSession::getFormToken() . '=1" rel="{handler: \'iframe\', size: {x: 800, y: 450}}"><i class="icon-file"></i> ' . JText::_('JSELECT') . '</a>';

		// Edit article button
		if ($allowEdit)
		{
			$html[] = '<a class="btn hasTooltip' . ($value ? '' : ' hidden') . '" href="index.php?option=com_content&layout=modal&tmpl=component&task=article.edit&id=' . $value . '" target="_blank" title="' . JHtml::tooltipText('COM_CONTENT_EDIT_ARTICLE') . '" ><span class="icon-edit"></span> ' . JText::_('JACTION_EDIT') . '</a>';
		}

		// Clear article button
		if ($allowClear)
		{
			$html[] = '<button id="' . $this->id . '_clear" class="btn' . ($value ? '' : ' hidden') . '" onclick="return jClearArticle(\'' . $this->id . '\')"><span class="icon-remove"></span> ' . JText::_('JCLEAR') . '</button>';
		}

		$html[] = '</span>';
                
                if(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','')){
                    // skip
                }else{
                    $html[] = '<div class="row-fluid">&nbsp;</div>';
                    $html[] = '<div class="row-fluid">';
                    $html[] = '<div class="alert alert-info">'.JText::_('All checkout information articles you choose must have a language assigned, even if this is not a multilanguage site. Otherwise no articles will show up in the checkout. Use the top left language switcher to select an article for each of your languages if you have a multi language site.').'</div>';
                    $html[] = '</div>';
                }
                
		// class='required' for client side validation
		$class = '';
		if ($this->required)
		{
			$class = ' class="required modal-value"';
		}
                
                $value = $this->value;
                
		$html[] = '<input type="hidden" id="' . $this->id . '_id"' . $class . ' name="' . $this->name . '" value="' . $value . '" />';

		return implode("\n", $html);
	}
}
