<?php
/**
 * @package     Joomla.Plugin
 * @subpackage  System.log
 *
 * @copyright   Copyright (C) 2005 - 2015 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

/**
 * Joomla! System Logging Plugin.
 *
 * @since  1.5
 */
class PlgSystemBreezingcommerce extends JPlugin
{
	
    public function onAfterRoute(){
        
        if(!file_exists(JPATH_ADMINISTRATOR . '/components/com_breezingcommerce/classes/CrBcHelpers.php')){ return; }
        
        require_once(JPATH_ADMINISTRATOR . '/components/com_breezingcommerce/classes/CrBcHelpers.php');
        
        $config = CrBcHelpers::getBcConfig();
        
        // loading theme plugins that are possibly addressing bc related modules
        // but not being in breezingcommerce scope
        
        if( JRequest::getVar('option','') != 'com_breezingcommerce' && JFactory::getApplication()->isSite() ){
            
            //CrBcHelpers::addCssFile(JUri::root(true).'/components/com_breezingcommerce/css/system/global.css');

            $libpath = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce' . DS . 'classes' . DS . 'plugin' . DS;
            require_once($libpath . 'CrBcPlugin.php');
            
            $plugins = CrBcPlugin::getPlugins('theme');

            foreach($plugins As $plugin){

                $plugin_instance = CrBcPlugin::getPluginInstance($plugin->name, $plugin->type, 'site');

                if($plugin_instance instanceof CrBcThemeSitePlugin){

                    $plugin_instance->wireUp();
                }

                // we only need the first one, therefore we need to take a break...
                break;
            }
            
        }
        
        if(
            $config->get('session_keepalive','breezingcommerce') == 'site'
            ||
            ( JRequest::getVar('option','') == 'com_breezingcommerce' && $config->get('session_keepalive','breezingcommerce') == 'breezingcommerce' ) ){
            
            JHtml::_('behavior.keepalive');
        }
        
        // synch the emails between users and customer update_billing_information
        // we make an exception here for checkout and customer profile changes. In these cases, the shop will update the user instead
        if( JFactory::getUser()->get('id', 0) > 0 
                && JFactory::getUser()->get('email', '') != ''
                    && !( JRequest::getVar('controller', '') == 'checkout' && JRequest::getVar('task', '') == 'update_billing_information' && JRequest::getVar('option', '') == 'com_breezingcommerce' )
                        && !( JRequest::getVar('controller', '') == 'customerprofile' && JRequest::getVar('task', '') == 'update_billing_information' && JRequest::getVar('option', '') == 'com_breezingcommerce' ) ){
            
            $db = JFactory::getDbo();
            
            // we don't want nothing from the session but what is actually stored
            $db->setQuery('Select email From #__users Where id = '.$db->quote(JFactory::getUser()->get('id', 0)));
            $user_email = $db->loadResult();
            
            $db->setQuery('Select email From #__breezingcommerce_customers Where userid = '.$db->quote(JFactory::getUser()->get('id', 0)).' Limit 1');
            $customer_email = $db->loadResult();
            
            if( $user_email !== null && $customer_email !== null && $user_email != $customer_email ){
                
                $db->setQuery('Update #__breezingcommerce_customers Set email = ' . $db->quote( $user_email ) . ' Where userid = ' . $db->quote(JFactory::getUser()->get('id', 0)));
                $db->execute();
            }
        }
    }
    
    public function onAfterRender()
    {
        
        if(!file_exists(JPATH_ADMINISTRATOR . '/components/com_breezingcommerce/classes/CrBcHelpers.php')){ return; }
        
        $app = JFactory::getApplication();

        if( $app->input->getString('option') == 'com_menus' && $app->input->getString('view') == 'items' ){

            $body = JResponse::getBody();
            $body = str_replace('&lt;img src=../administrator/components/com_breezingcommerce/assets/css/images/icon-16-breezingcommerce-blue.png width=23px; /&gt;', '', $body);
            JResponse::setBody($body);
        }
    }
}
