<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// No direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class BreezingcommerceModelBreezingcommerce extends JModelLegacy
{

    function  __construct($config) {
        parent::__construct($config);
    }
    
    function getTotalCustomers(){
        
        $sql = "Select count(id) From #__breezingcommerce_customers Where is_tmp = 0 And published = 1";
        $this->_db->setQuery($sql);
        return $this->_db->loadResult();
    }
    
    function getTotalSales(){
        
        $sql = "
            Select SQL_CALC_FOUND_ROWS Distinct o.history_currency_code, o.history_symbol, Sum(i.history_gross) As sales_total
                From
                    #__breezingcommerce_orders As o
                Left Join
                    ( 
                      #__breezingcommerce_order_items As i
                    )
                On
                    (
                        
                        i.order_id = o.id
                    )
                Where o.paid = 1 And o.checked_out = 1 And o.history = 1 And o.published = 1  Group By o.history_currency_code  ORDER BY o.id desc
            ";
        
        $this->_db->setQuery($sql);
        return $this->_db->loadObjectList();
    }
    
    function getTotalOrders(){
        
        $this->_db->setQuery("
            Select
                Distinct
                count(orders.id)
            From
                #__breezingcommerce_orders As orders
            Where
                orders.published = 1
            And
                orders.checked_out = 1
            And
                orders.history = 1
            And
                orders.paid = 1
            ");
        
        return $this->_db->loadResult();
    }
    
    function getLatestOrders(){
        
        $sql = "
            Select SQL_CALC_FOUND_ROWS Distinct o.*, s.name As order_status_name, Sum(i.published) As backorder, Sum(i.history_gross) + o.history_shipping_costs As order_total
                From
                    #__breezingcommerce_orders As o
                Left Join
                    ( 
                      #__breezingcommerce_order_status As s,
                      #__breezingcommerce_order_items As i
                    )
                On
                    (
                        s.id = o.order_status_id
                      And
                        i.order_id = o.id
                    )
                Where o.history_customer_name <> '' And o.published = 1  Group By o.id  ORDER BY o.id desc
                Limit 6
            ";
        
        $this->_db->setQuery($sql);
        
        return $this->_db->loadObjectList();
    }
    
    function getSalesData(){
        
        $offset = 0;
        $slots = 'G';
        $units = 23;
        
        $expression = "Date(orders.payment_date) = Date(".$this->_db->quote(JFactory::getDate('now', JFactory::getConfig()->get('offset'))->format('Y-m-d H:i:s', true)).")";
                
        switch( JRequest::getVar('sale_chart_choosen','') ){
            case 'today':
                $offset = 0;
                $units = 23;
                $slots = 'G';
                $expression = "Date(orders.payment_date) = Date(".$this->_db->quote(JFactory::getDate('now', JFactory::getConfig()->get('offset'))->format('Y-m-d H:i:s', true)).")";
                break;
            case 'yesterday':
                $offset = 0;
                $units = 23;
                $slots = 'G';
                $expression = "Date(orders.payment_date) = Date(".$this->_db->quote(JFactory::getDate('now -1 days', JFactory::getConfig()->get('offset'))->format('Y-m-d H:i:s', true)).")";
                break;
            case 'this-week':
                $offset = 1;
                $units = 7;
                $slots = 'N';
                $expression = "YEARWEEK(orders.payment_date, 1) = YEARWEEK(".$this->_db->quote(JFactory::getDate('now', JFactory::getConfig()->get('offset'))->format('Y-m-d H:i:s', true)).", 1)";
                break;
            case 'last-week':
                $offset = 1;
                $units = 7;
                $slots = 'N';
                $expression = "YEARWEEK(orders.payment_date, 1) = YEARWEEK(".$this->_db->quote(JFactory::getDate('now -7 days', JFactory::getConfig()->get('offset'))->format('Y-m-d H:i:s', true)).", 1)";
                break;
            case 'this-year':
                $offset = 1;
                $units = 12;
                $slots = 'n';
                $expression = "YEAR(orders.payment_date) = YEAR(".$this->_db->quote(JFactory::getDate('now', JFactory::getConfig()->get('offset'))->format('Y-m-d H:i:s', true)).")";
                break;
            case 'last-year':
                $offset = 1;
                $units = 12;
                $slots = 'n';
                $expression = "YEAR(orders.payment_date) = YEAR(".$this->_db->quote(JFactory::getDate('now -1 year', JFactory::getConfig()->get('offset'))->format('Y-m-d H:i:s', true)).")";
                break;
            case 'this-month':
                $offset = 1;
                $units = cal_days_in_month(CAL_GREGORIAN, JFactory::getDate('now', JFactory::getConfig()->get('offset'))->format('m', true), JFactory::getDate('now', JFactory::getConfig()->get('offset'))->format('Y', true));
                $slots = 'j';
                $expression = "YEAR(orders.payment_date) = YEAR(".$this->_db->quote(JFactory::getDate('now', JFactory::getConfig()->get('offset'))->format('Y-m-d H:i:s', true)).") And Month(orders.payment_date) = Month(".$this->_db->quote(JFactory::getDate('now', JFactory::getConfig()->get('offset'))->format('Y-m-d H:i:s', true)).")";
                break;
            case 'last-month':
                $offset = 1;
                $units = cal_days_in_month(CAL_GREGORIAN, JFactory::getDate('now -1 month')->format('m', true), JFactory::getDate('now -1 month')->format('Y', true));
                $slots = 'j';
                $expression = "YEAR(orders.payment_date) = YEAR(".$this->_db->quote(JFactory::getDate('now -1 month', JFactory::getConfig()->get('offset'))->format('Y-m-d H:i:s', true)).") And Month(orders.payment_date) = Month(".$this->_db->quote(JFactory::getDate('now -1 month', JFactory::getConfig()->get('offset'))->format('Y-m-d H:i:s', true)).")";
                break;
        }
        
        $this->_db->setQuery("
            Select
                Distinct
                order_items.*,
                orders.history_symbol,
                orders.history_currency_code,
                orders.payment_date,
                orders.id As order_id
            From
                #__breezingcommerce_order_items As order_items,
                #__breezingcommerce_orders As orders
            Where
                orders.published = 1
            And
                orders.id = order_items.order_id
            And
                orders.checked_out = 1
            And
                orders.history = 1
            And
                orders.paid = 1
            And
                ".$expression."
            ");
        
        $rows = $this->_db->loadObjectList();
        
        for($i = $offset; $i <= $units; $i++){
            
            $prepared[$i] = array();
            
            foreach( $rows As $row ){
                
                $prepared[$i][$row->history_currency_code] = array();
                $prepared[$i][$row->history_currency_code]['taxes'] = 0;
                $prepared[$i][$row->history_currency_code]['net'] = 0;
                $prepared[$i][$row->history_currency_code]['gross'] = 0;
                $prepared[$i][$row->history_currency_code]['sales'] = 0;
                $prepared[$i][$row->history_currency_code]['label'] = '';
                $prepared[$i][$row->history_currency_code]['currency_code'] = '';
                $prepared[$i][$row->history_currency_code]['currency_symbol'] = '';
            }
            
        }
        
        foreach( $rows As $row ){
            
            if( $row->history_currency_code == '' ){

                continue;
            }
            
            $signature = JHTML::_('date', $row->payment_date, $slots, false);
            
            if($prepared[$signature][$row->history_currency_code]['label'] == ''){
                
                $prepared[$signature][$row->history_currency_code]['label'] = JFactory::getDate($row->payment_date, JFactory::getConfig()->get('offset'))->format('D', true);
                $prepared[$signature][$row->history_currency_code]['currency_code'] = $row->history_currency_code;
                $prepared[$signature][$row->history_currency_code]['currency_symbol'] = $row->history_symbol;
            }
            
            $prepared[$signature][$row->history_currency_code]['gross'] += $row->history_gross;
            $prepared[$signature][$row->history_currency_code]['net'] += $row->history_net;
            $prepared[$signature][$row->history_currency_code]['taxes'] += $row->history_taxes;
        
            // counting the amount of orders in a pretty wild way...
            if( !isset( $prepared[$signature][$row->history_currency_code]['order_id_'.$row->order_id] ) ){
                $prepared[$signature][$row->history_currency_code]['sales']++;
                $prepared[$signature][$row->history_currency_code]['order_id_'.$row->order_id] = true;
            }
        }
        
        
        return $prepared;
        
    }
    
    function getDays($year){

        $days = 0;
        
        for($m=1; $m<=12; $m++){
            $days += cal_days_in_month(CAL_GREGORIAN, $m, $year);
        }

        return $days;
    }

}
