<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// No direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class BreezingcommerceModelCategory extends JModelLegacy
{
    function  __construct($config)
    {
        parent::__construct();

        $mainframe = JFactory::getApplication();
        $option = 'com_breezingcommerce';
        
        $array = JRequest::getVar('cid',  0, '', 'array');
        $this->setId((int)$array[0]);

        $search = $mainframe->getUserStateFromRequest("$option.category_tabStartOffset".$this->getId(), 'tabStartOffset', '', '0');
        $this->setState('category_tabStartOffset'.$this->getId(), $search);
        
    }

    function copy()
    {
        $obj = clone($this->getData());
        
        unset($obj->metadesc_translation);
        unset($obj->metakey_translation);
        unset($obj->metadata_translation);
        unset($obj->description_translation);
        unset($obj->title_translation);
        unset($obj->alias_translation);
        unset($obj->image_description_translation);
        unset($obj->image_alt_name_translation);
        
        $origId = $obj->id;
        unset($obj->id);
        $obj->title = 'Copy of ' . $obj->title;
        $obj->created = JFactory::getDate()->toSql();
        $obj->created_by = JFactory::getUser()->get('id', 0);
        $obj->created_by_alias = JFactory::getUser()->get('username', '');
        $obj->modified = JFactory::getDate()->toSql();
        $obj->modified_by = JFactory::getUser()->get('id', 0);
        $obj->modified_by_alias = JFactory::getUser()->get('username', '');
        $this->_db->insertObject('#__breezingcommerce_categories', $obj);
        $insertId = $this->_db->insertid();
        require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcImage.php');
        CrBcImage::copyCategoryImages($origId, $insertId);
        CrBcHelpers::copyTranslations($origId, $insertId, 'category_image');
        CrBcHelpers::copyTranslations($origId, $insertId, 'category');
        
        // Rebuild the path for the category:
        $row = $this->getTable('category');
        $row->load($insertId);
        if (!$row->rebuildPath($insertId))
        {
                $this->setError($row->getError());
                return false;
        }

        $build = $this->getTable('category');
        $build->load($row->getRootId());

        if (!$build->rebuild($build->id, $build->lft, $build->level, $build->path))
        {
            $this->setError($build->getError());
            return false;
        }
        
        CrBcCategoriesHelper::reorderCategories($this, $insertId);
    }

    function setPublished()
    {
        if (empty( $this->_data )) {
            $this->_db->setQuery( ' Update #__breezingcommerce_categories '.
                        '  Set published = 1 Where id = '.$this->_id );
            $this->_db->query();
        }
    }

    function setUnpublished()
    {
       if (empty( $this->_data )) {
           $this->_db->setQuery( ' Update #__breezingcommerce_categories '.
                        '  Set published = 0 Where id = '.$this->_id );
           $this->_db->query();
       }
    }

    /*
     * MAIN DETAILS AREA
     */

    /**
     *
     * @param int $id 
     */
    function setId($id) {
        // Set id and wipe data
        $this->_id      = $id;
        $this->_data    = null;
    }

    function getId(){
        return $this->_id;
    }

    /**
    * Gets the currencies
    * @return array List of categories
    */
    function getData()
    {
        // Load the data
        if (empty( $this->_data )) {
            $query = ' Select * From #__breezingcommerce_categories '.
                    '  Where id = '.$this->_id;
            $this->_db->setQuery( $query );
            $this->_data = $this->_db->loadObject();
        }
        if (!$this->_data) {
            $this->_data = new stdClass();
            $this->_data->id = 0;
            $this->_data->title = null;
            $this->_data->description = null;
            $this->_data->description_fulltext = null;
            $this->_data->alias = null;
            $this->_data->created = null;
            $this->_data->created_by = null;
            $this->_data->created_by_alias = null;
            $this->_data->modified = null;
            $this->_data->modified_by = null;
            $this->_data->modified_by_alias = null;
            $this->_data->published = 0;
            $this->_data->ordering = 0;
            $this->_data->parent_id = 0;
			$this->_data->catalog = 0;
			$this->_data->catalog_children = 0;
			$this->_data->catalog_strict = 0;
            $this->_data->image_name = null;
            $this->_data->image_alt_name = null;
            $this->_data->image_description = null;
            $this->_data->image_background_color = null;
            $this->_data->image_physical_name = null;
            $this->_data->metadesc = '';
            $this->_data->metakey  = '';
            $this->_data->metadata = '';
        }
        
        // translations
        $this->_data->description_translation = '';
        $this->_data->title_translation = '';
        $this->_data->alias_translation = '';
        
        $this->_data->metadesc_translation = '';
        $this->_data->metakey_translation = '';
        $this->_data->metadata_translation = '';
        
        $this->_data->image_description_translation = '';
        $this->_data->image_alt_name_translation = '';
        
        if($this->_id){
            
            $this->_db->setQuery("Select * From #__breezingcommerce_translations Where `type` = 'category' And item_id = ".$this->_db->quote( $this->_id )." And language_code = ".$this->_db->quote( JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','') ));
            
            $translated_object = $this->_db->loadObject();
            if($translated_object !== null){
                $this->_data->description_translation = $translated_object->body;
                $this->_data->title_translation = $translated_object->title;
                $this->_data->alias_translation = $translated_object->alias;
            }
            
            $translated_object = CrBcHelpers::loadTranslation($this->_id, 'category_metadata');
            if($translated_object !== null){
                $meta = json_decode($translated_object->body);
                $this->_data->metadesc_translation = $meta->metadesc;
                $this->_data->metakey_translation  = $meta->metakey;
                $this->_data->metadata_translation = json_encode($meta->metadata);
            }
            
            $this->_db->setQuery("Select * From #__breezingcommerce_translations Where `type` = 'category_image' And item_id = ".$this->_db->quote( $this->_id )." And language_code = ".$this->_db->quote( JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','') ));
            
            $translated_object = $this->_db->loadObject();
            if($translated_object !== null){
                $this->_data->image_description_translation = $translated_object->body;
                $this->_data->image_alt_name_translation = $translated_object->title;
            }
        }
        // translations end
        
        return $this->_data;

    }

    function store()
    {
       
        $row = $this->getTable();

        $data = JRequest::get( 'post' );

        $params = JRequest::getVar('params', array(), 'post', 'array');
        
        // Build parameter INI string
        if (is_array($params)) {
            $data['metadata'] = json_encode($params);
        }
        
        if( intval($data['id']) != 0 )
        {
            $row->load(intval($data['id']));
        }
        else
        {
            $data['parent_id'] = array();
            $data['parent_id']['category_id'] = 1;
        }
        
        $data['description'] = JRequest::getVar( 'description', '', 'POST', 'STRING', JREQUEST_ALLOWHTML );
        $data['description_translation'] = JRequest::getVar( 'description_translation', '', 'POST', 'STRING', JREQUEST_ALLOWHTML );
        $data['image_name'] = $data['img_name'];
        $data['image_alt_name'] = $data['img_alt_name'];
        $data['image_description'] = $data['img_description'];
        $data['image_background_color'] = $data['img_background_color'];

        if( intval($data['id']) > 0 )
        {
            $currentData = $this->getData();
            $data['created'] = $currentData->created;
            $data['created_by'] = $currentData->created_by;
            $data['created_by_alias'] = $currentData->created_by_alias;
            $data['modified'] = JFactory::getDate()->toSql();
            $data['modified_by'] = JFactory::getUser()->get('id', 0);
            $data['modified_by_alias'] = JFactory::getUser()->get('username', '');
        }
        else
        {
            $data['created'] = JFactory::getDate()->toSql();
            $data['created_by'] = JFactory::getUser()->get('id', 0);
            $data['created_by_alias'] = JFactory::getUser()->get('username', '');
            $data['modified'] = JFactory::getDate()->toSql();
            $data['modified_by'] = JFactory::getUser()->get('id', 0);
            $data['modified_by_alias'] = JFactory::getUser()->get('username', '');
        }
        
        // alias handling
        if(trim($data['alias']) == ''){
            $data['alias'] = CrBcHelpers::getSlug(trim($data['title']));
        }

        $text = $data['description'];
        $text = preg_replace('/</',' <',$text);
        $text = preg_replace('/>/','> ',$text);
        $desc = html_entity_decode(strip_tags($text));
        $desc = preg_replace('/[\n\r\t]/',' ',$desc);
        $desc = preg_replace('/  /',' ',$desc);

        // description fulltext is a raw text copy and needed for fulltext search
        $data['description_fulltext'] = preg_replace('/  /', ' ', $desc);

        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        $category_id = 0;
        $storeRes = $row->store();
        
        if (!$storeRes) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        else
        {
            if( intval($data['id']) != 0 )
            {
                $category_id = intval($data['id']);
            }
            else
            {
                $category_id = $row->id;
            }
        }
        
        if( intval($data['parent_id']['category_id']) == intval($category_id) ){
            
            JFactory::getApplication()->enqueueMessage(JText::_('COM_BREEZINGCOMMERCE_SAME_CATEGORY_ID'), 'error');
            
        } else {
        
            $this->_db->setQuery("update #__breezingcommerce_categories Set parent_id = " . intval($data['parent_id']['category_id']) . " Where id = " . intval($category_id));
            $this->_db->execute();
        
        }
        
        // translations
        $fields = array();
        
        if(isset($data['description_translation'])){
            $fields['body'] = $data['description_translation'];
        }
        if(isset($data['title_translation'])){
            $fields['title'] = $data['title_translation'];
        }
        if(isset($data['alias_translation'])){
            
            if(trim($data['alias_translation']) == ''){
                $fields['alias'] = CrBcHelpers::getSlug(trim($data['title_translation']));
            } else{
                $fields['alias'] = $data['alias_translation'];
            }
        }
        
        CrBcHelpers::storeTranslation($fields, $category_id, 'category');
        // translations end
        
        if(isset($data['metadesc_translation'])){
            $fields = array();
            $fields['body'] = new stdClass();
            $fields['body']->metadesc = $data['metadesc_translation'];
            $fields['body']->metakey  = $data['metakey_translation'];
            $fields['body']->metadata = $data['params_translation'];
            $fields['body'] = json_encode($fields['body']);
            CrBcHelpers::storeTranslation($fields, $category_id, 'category_metadata');
        }
        
        // rebuild the levels, very important to display the category levels properly
        
        // Rebuild the path for the category:
        if (!$row->rebuildPath($category_id))
        {
                $this->setError($row->getError());
                return false;
        }
        
        $build = $this->getTable();
        $build->load($row->getRootId());
        
        if (!$build->rebuild($build->id, $build->lft, $build->level, $build->path, true))
        {
            $this->setError($build->getError());
            return false;
        }
        
        CrBcCategoriesHelper::reorderCategories($this, $category_id, intval($data['parent_id']['category_id']));
        
        
        /**
         * TODO: remove any special characters from image name
         */
        $data['img_description_translation'] = JRequest::getVar( 'img_description_translation', '', 'POST', 'STRING', JREQUEST_ALLOWHTML );
        
        $fileinfo = JRequest::getVar('category_image', null, 'files', 'array');
        $data['img_name'] = strtolower( str_replace(array("-"," ","'","\"","\\","/"), array('_','_','','','',''), $data['img_name']) );

        if(trim($data['img_name']) == ''){
            $destNameNoExt = explode('.',$fileinfo['name']);
            unset($destNameNoExt[count($destNameNoExt)-1]);
            $destNameNoExt = implode('.', $destNameNoExt);
            $data['img_name'] = strtolower( str_replace(array("-"," ","'","\"","\\","/"), array('_','_','','','',''), $destNameNoExt) );
        }

        if(intval($fileinfo['size']) > 0 ) {
            
            require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcImage.php');
            
            $data['image_name'] = $data['img_name'];
            $image = CrBcImage::generateCategoryImages($fileinfo, $data);
            
            CrBcImage::deleteCategoryImages($category_id);
            
            if(false !== $image)
            {
                $this->_db->setQuery(
                        "Update
                                #__breezingcommerce_categories
                            Set
                                `image_name` = " . $this->_db->Quote($data['img_name']) . ",
                                `image_alt_name` = " . $this->_db->Quote($data['img_alt_name']) . ",
                                `image_description` = ". $this->_db->Quote($data['img_description']) .",
                                `image_background_color` = ". $this->_db->Quote($data['img_background_color']) .",
                                `image_physical_name` = ". $this->_db->Quote($image) ."
                            Where
                                id = " . $this->_db->Quote($category_id) . "
                            "
                );
                $this->_db->query();
            }
        }else{
            $this->_db->setQuery(
                        "Update
                                #__breezingcommerce_categories
                            Set
                                `image_name` = " . $this->_db->Quote($data['img_name']) . ",
                                `image_alt_name` = " . $this->_db->Quote($data['img_alt_name']) . ",
                                `image_description` = ". $this->_db->Quote($data['img_description']) .",
                                `image_background_color` = ". $this->_db->Quote($data['img_background_color']) ."
                            Where
                                id = " . $this->_db->Quote($category_id) . "
                            "
                );
                $this->_db->query();
        }
        
        // translations
        $fields = array();
        $fields['body'] = $data['img_description_translation'];
        $fields['title'] = $data['img_alt_name_translation'];
        
        CrBcHelpers::storeTranslation($fields, $category_id, 'category_image');
        // translations end

        if(JRequest::getBool('delete_uploaded_image', false))
        {
            require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcImage.php');
            CrBcImage::deleteCategoryImages($category_id);
        }
        else
        {
            if(trim($data['img_name']) != '' && intval($fileinfo['size']) == 0){
                require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcImage.php');
                CrBcImage::renameCategoryImage(trim($data['img_name']), $category_id);
            }
        }

        return true;
    }

    function delete()
    {
        $cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        JArrayHelper::toInteger($cids);
        $row = $this->getTable();

        require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcImage.php');

        foreach($cids as $cid) {

            $to_be_deleted = $this->getTable();
            $to_be_deleted->load($cid);
            $deleted_parent_id = $to_be_deleted->parent_id;
            
            CrBcImage::deleteCategoryImages(intval($cid));
            
            if (!$row->delete( $cid, false )) {
                return false;
            }
            else
            {
                $children = new stdClass();
                $children->list = array();
                $this->_populateChildren($cid, $children);
                if(count($children->list))
                {
                    foreach($children->list As $child){
                        CrBcImage::deleteCategoryImages(intval($child));
                    }

                    $this->_db->setQuery(
                            "Delete
                                From
                                    #__breezingcommerce_categories
                                Where
                                    id In (".implode(',', $children->list).")
                                "
                    );
                    $this->_db->query();
                    
                    $this->_db->setQuery("Delete From #__breezingcommerce_product_categories Where category_id In (" . implode(',', $children->list) . ")");
                    $this->_db->query();
                    
                    $this->_db->setQuery("Delete From #__breezingcommerce_translations Where type = 'category' And item_id In (" . implode(',', $children->list) . ")");
                    $this->_db->query();

                    $this->_db->setQuery("Delete From #__breezingcommerce_translations Where type = 'category_image' And item_id In (" . implode(',', $children->list) . ")");
                    $this->_db->query();
                    
                    $this->_db->setQuery("Delete From #__breezingcommerce_translations Where type = 'category_metadata' And item_id In (" . implode(',', $children->list) . ")");
                    $this->_db->query();
                }

                $this->_db->setQuery("Delete From #__breezingcommerce_product_categories Where category_id = " . $cid );
                $this->_db->query();
                
                $this->_db->setQuery("Delete From #__breezingcommerce_translations Where type = 'category' And item_id = " . $cid);
                $this->_db->query();
                
                $this->_db->setQuery("Delete From #__breezingcommerce_translations Where type = 'category_image' And item_id = " . $cid);
                $this->_db->query();
                
                $this->_db->setQuery("Delete From #__breezingcommerce_translations Where type = 'category_metadata' And item_id = " . $cid);
                $this->_db->query();
            }
            
            CrBcCategoriesHelper::reorderCategories($this, 0, $deleted_parent_id);
        }

        return true;
    }

    function _populateChildren($id, stdClass $children)
    {
        $db = $this->_db;
        $query = 'SELECT id' .
                ' FROM #__breezingcommerce_categories' .
                ' WHERE parent_id = '.(int) $id;
        $db->setQuery( $query );
        $rows = $db->loadObjectList();

        if ($db->getErrorNum()) {
            $this->setError($db->getErrorMsg());
            return false;
        }

        foreach ($rows as $row) {
            $children->list[] = $row->id;
            $this->_populateChildren($row->id, $children);
        }
    }

    function move($direction) {

      $db = JFactory::getDBO();
      $mainframe = JFactory::getApplication();

      $row = $this->getTable('categorysimple');
      if (!$row->load($this->_id)) {
         $this->setError($db->getErrorMsg());
         return false;
      }

      if (!$row->move( $direction, 'parent_id='.$row->parent_id )) {
         $this->setError($db->getErrorMsg());
         return false;
      }
      
      $row = $this->getTable('category');
      if (!$row->load($this->_id)) {
         $this->setError($db->getErrorMsg());
         return false;
      }

      if (!$row->move( $direction, 'parent_id='.$row->parent_id )) {
         $this->setError($db->getErrorMsg());
         return false;
      }
      
      if (!$row->rebuild($row->id, $row->lft, $row->level, $row->path))
      {
        $this->setError($row->getError());
        return false;
      }

      return true;
   }
}
