<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// No direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class BreezingcommerceModelCountry extends JModelLegacy
{

    function  __construct($config)
    {
        parent::__construct();

        $mainframe = JFactory::getApplication();
        $option = 'com_breezingcommerce';

        $array = JRequest::getVar('cid',  0, '', 'array');
        $this->setId((int)$array[0]);
        if(JRequest::getInt('id',0)>0){
            $this->setId(JRequest::getInt('id',0));
        }

        $limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
        $limitstart = JRequest::getVar('limitstart', 0, '', 'int');

        // In case limit has been changed, adjust it
        $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

        $this->setState('limit', $limit);
        $this->setState('limitstart', $limitstart);

        $filter_order     = $mainframe->getUserStateFromRequest(  $option.'countryitems_filter_order', 'filter_order', 'ordering', 'cmd' );
        $filter_order_Dir = $mainframe->getUserStateFromRequest( $option.'countryitems_filter_order_Dir', 'filter_order_Dir', 'asc', 'word' );

        $this->setState('countryitems_filter_order', $filter_order);
        $this->setState('countryitems_filter_order_Dir', $filter_order_Dir);

        $filter_state = $mainframe->getUserStateFromRequest( $option.'countryitems_filter_state', 'filter_state', '', 'word' );
        $this->setState('countryitems_filter_state', $filter_state);

    }

    function setPublished()
    {
        if (empty( $this->_data )) {
            $this->_db->setQuery( ' Update #__breezingcommerce_countries '.
                        '  Set published = 1 Where id = '.$this->_id );
            $this->_db->query();
        }
    }

    function setUnpublished()
    {
       if (empty( $this->_data )) {
           $this->_db->setQuery( ' Update #__breezingcommerce_countries '.
                        '  Set published = 0 Where id = '.$this->_id );
           $this->_db->query();
       }
    }

    function setListPublished()
    {
        $items	= JRequest::getVar( 'cid', array(), 'post', 'array' );
        JArrayHelper::toInteger($items);
        if (count($items)) {
            $this->_db->setQuery( ' Update #__breezingcommerce_country_regions '.
                        '  Set published = 1 Where id In ( '.implode(',', $items) . ')' );
            $this->_db->query();
        }
    }

    function setListUnpublished()
    {
       $items	= JRequest::getVar( 'cid', array(), 'post', 'array' );
        JArrayHelper::toInteger($items);
        if (count($items)) {
            $this->_db->setQuery( ' Update #__breezingcommerce_country_regions '.
                        '  Set published = 0 Where id In ( '.implode(',', $items) . ')' );
            $this->_db->query();
        }
    }

    /*
     * MAIN DETAILS AREA
     */

    /**
     *
     * @param int $id 
     */
    function setId($id) {
        // Set id and wipe data
        $this->_id      = $id;
        $this->_data    = null;
    }

    /**
    * Gets the currencies
    * @return array List of countries
    */
    function getCountry()
    {
        
        $query = ' Select * From #__breezingcommerce_countries '.
                    '  Where id = '.$this->_id;
        $this->_db->setQuery( $query );
        $data = $this->_db->loadObject();
        
        if (!$data) {
            $data = new stdClass();
            $data->id = 0;
            $data->name = null;
            $data->code = null;
            $data->ordering = null;
            $data->published = null;
        }
        
        $data->name_translation = '';
        
        $query = ' Select * From #__breezingcommerce_translations '.
                    '  Where language_code = '.$this->_db->quote( JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','') ) . ' And type = "country" And item_id = '.$this->_id;
        $this->_db->setQuery( $query );
        $translation = $this->_db->loadObject();
        
        $data->name_translation = '';
        
        if($translation !== null){
            $data->name_translation = $translation->title;
        }
        
        return $data;

    }

    private function buildOrderBy() {
        global $mainframe, $option;

        $orderby = '';
        $filter_order     = $this->getState('countryitems_filter_order');
        $filter_order_Dir = $this->getState('countryitems_filter_order_Dir');

        /* Error handling is never a bad thing*/
        if(!empty($filter_order) && !empty($filter_order_Dir) ) {
            $orderby = ' ORDER BY '.$filter_order.' '.$filter_order_Dir . ' , ordering ';
        } else {
           $orderby = ' ORDER BY ordering ';
        }

        return $orderby;
    }


    function _buildQuery()
    {
        $filter_state = '';
        if($this->getState('countryitems_filter_state') == 'P' || $this->getState('countryitems_filter_state') == 'U')
        {
            $published = 0;
            if($this->getState('countryitems_filter_state') == 'P')
            {
                $published = 1;
            }

            $filter_state .= ' And published = ' . $published;
        }

        return "Select * From #__breezingcommerce_country_regions Where country_id = " . $this->_id . $filter_state . $this->buildOrderBy();
    }

    function getData()
    {
        $this->_db->setQuery($this->_buildQuery(), $this->getState('limitstart'), $this->getState('limit'));
        $entries = $this->_db->loadObjectList();
        
        $i = 0;
        foreach( $entries As $entry ){
        
            $this->_db->setQuery("Select * From #__breezingcommerce_translations Where item_id = ".$entry->id." And type = 'country_region_".$this->_id."' And language_code = ".$this->_db->quote( JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','') ));
            $name_translation = $this->_db->loadObject();
            $entries[$i]->name_translation = '';
            if($name_translation !== null){
                $entries[$i]->name_translation = $name_translation->title;
            }
            
            $i++;
        }
        
        return $entries;
    }

    function store()
    {
        $row = $this->getTable();

        $data = JRequest::get( 'post' );
        
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        $country_id = 0;
        $storeRes = $row->store();

        if (!$storeRes) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        else
        {
            if( intval($data['id']) != 0 )
            {
                $country_id = intval($data['id']);
            }
            else
            {
                $country_id = $this->_db->insertid();
            }
        }
        
        $row->reorder();

        if(isset($data['name_translation']) && $data['name_translation'] != ''){
            $fields = array();
            $fields['title'] = trim($data['name_translation']);
            CrBcHelpers::storeTranslation($fields, $country_id, 'country');
        }
        
        $names = JRequest::getVar('countryNames', array());
        $names_translation = JRequest::getVar('countryNames_translation', array());
        $codes = JRequest::getVar('countryCodes', array());
        $items = JRequest::getVar( 'cid', array(), 'post', 'array' );

        JArrayHelper::toInteger($items);
        $size = count($items);
        for($i = 0; $i < $size; $i++)
        {
            $this->_db->setQuery("Update #__breezingcommerce_country_regions Set `country_id` = ".$this->_db->Quote($country_id).", `code` = ".$this->_db->Quote(trim($codes[$items[$i]])).",`name` =  ".$this->_db->Quote(trim($names[$items[$i]]))." Where id = " . $items[$i]);
            $this->_db->query();
            
            if(isset($names_translation[$items[$i]]) && trim($names_translation[$items[$i]]) != ''){
                $fields = array();
                $fields['title'] = trim($names_translation[$items[$i]]);
                CrBcHelpers::storeTranslation($fields, $items[$i], 'country_region_'.$country_id);
            }
            
        }

        // NEW ATTRIBUTE
        $name = JRequest::getVar('region_name', '');
        $name_translation = JRequest::getVar('region_name_translation', '');
        $code = JRequest::getVar('region_code', '');
        
        if($name != '' && $code != ''){

            $this->_db->setQuery("Insert Into #__breezingcommerce_country_regions (`country_id`,`name`,`code`,`ordering`) Values ($country_id,".$this->_db->Quote(trim($name)).",".$this->_db->Quote(trim($code)).",9999999999)");
            $this->_db->query();
            $key_id = $this->_db->insertid();
            $this->getTable('countryregions')->reorder('country_id = ' . $country_id);

            if($name_translation != ''){
                $fields = array();
                $fields['title'] = trim($name_translation);
                CrBcHelpers::storeTranslation($fields, $key_id, 'country_region_'.$country_id);
            }
        }

        return true;
    }

    function delete()
    {
        $cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        JArrayHelper::toInteger($cids);
        $row = $this->getTable();

        foreach($cids as $cid) {

            $this->_db->setQuery("Select default_country_id From #__breezingcommerce_customergroups Where default_country_id = " . $cid);
            if($this->_db->loadResult()){
                return 1;
            }

            $this->_db->setQuery("
                Delete
                    `regions`.*
                From
                    #__breezingcommerce_country_regions As `regions`
                Where
                    `regions`.country_id = " . $cid);
            
            $this->_db->query();

            $this->getTable('countryregions')->reorder('country_id = ' . $cid);

            $this->_db->setQuery("Delete From #__breezingcommerce_countries Where id = " . $cid);
            $this->_db->query();

            $this->_db->setQuery("Update #__breezingcommerce_taxrates Set country_id = 0, region_id = 0 Where country_id = " . $cid);
            $this->_db->query();

            $this->_db->setQuery("Update #__breezingcommerce_customers Set country_id = 0, region_id = 0 Where country_id = " . $cid);
            $this->_db->query();

            $this->_db->setQuery("Update #__breezingcommerce_customers Set shipping_country_id = 0, shipping_region_id = 0 Where shipping_country_id = " . $cid);
            $this->_db->query();
            
            $this->_db->setQuery("Delete From #__breezingcommerce_translations Where type = 'country_region_".$cid."'");
            $this->_db->query();
            
            $this->_db->setQuery("Delete From #__breezingcommerce_translations Where type = 'country' And item_id = ".$cid);
            $this->_db->query();

            if (!$row->delete( $cid )) {
                $this->setError( $row->getErrorMsg() );
                return false;
            }
        }

        $row->reorder();

        return true;
    }

    function listDelete()
    {
        $combinations_to_delete = array();
        $cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        JArrayHelper::toInteger($cids);
        foreach($cids as $cid) {

            $this->_db->setQuery("Select default_region_id From #__breezingcommerce_customergroups Where default_region_id = " . $cid);
            if($this->_db->loadResult()){
                return 1;
            }

            $this->_db->setQuery("
                Delete
                    `regions`.*
                From
                    #__breezingcommerce_country_regions As `regions`
                Where
                    `regions`.id = " . $cid);

            $this->_db->query();
            $this->getTable('countryregions')->reorder('country_id = ' . $this->_id);
            
            $this->_db->setQuery("Update #__breezingcommerce_taxrates Set region_id = 0 Where region_id = " . $cid);
            $this->_db->query();

            $this->_db->setQuery("Update #__breezingcommerce_customers Set region_id = 0 Where region_id = " . $cid);
            $this->_db->query();

            $this->_db->setQuery("Update #__breezingcommerce_customers Set shipping_region_id = 0 Where shipping_region_id = " . $cid);
            $this->_db->query();
            
            $this->_db->setQuery("Delete From #__breezingcommerce_translations Where type = 'country_region_".$this->_id."' And item_id = " . $cid);
            $this->_db->query();
        }
    }

    function move($direction) {

      $db = JFactory::getDBO();
      $mainframe = JFactory::getApplication();

      $row = $this->getTable('country');

      if (!$row->load($this->_id)) {
         $this->setError($db->getErrorMsg());
         return false;
      }

      if (!$row->move( $direction )) {
         $this->setError($db->getErrorMsg());
         return false;
      }

      return true;
   }

   function listMove($direction) {
      $mainframe = JFactory::getApplication();
      $items = JRequest::getVar( 'cid', array(), 'post', 'array' );
      JArrayHelper::toInteger($items);

      if(count($items)){
          $db = JFactory::getDBO();
          $row = $this->getTable('countryregions');

          if (!$row->load($items[0])) {
             $this->setError($db->getErrorMsg());
             return false;
          }

          if (!$row->move( $direction, 'country_id='.$this->_id )) {
             $this->setError($db->getErrorMsg());
             return false;
          }
      }

      return true;
   }

   function getTotal() {
        // Load the content if it doesn't already exist
        if (empty($this->_total)) {
            $query = $this->_buildQuery();
            $this->_total = $this->_getListCount($query);
        }
        return $this->_total;
    }

    function getPagination() {
        // Load the content if it doesn't already exist
        if (empty($this->_pagination)) {
            jimport('joomla.html.pagination');
            $this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
        }
        return $this->_pagination;
    }

    function listSaveOrder()
    {
        $items	= JRequest::getVar( 'cid', array(), 'post', 'array' );
        JArrayHelper::toInteger($items);

        $total		= count( $items );
        $row		= $this->getTable('countryregions');
        $groupings	= array();

        $order		= JRequest::getVar( 'order', array(), 'post', 'array' );
        JArrayHelper::toInteger($order);

        // update ordering values
        for( $i=0; $i < $total; $i++ ) {
            $row->load( $items[$i] );
            if ($row->ordering != $order[$i]) {
                $row->ordering = $order[$i];
                if (!$row->store()) {
                    $this->setError($row->getError());
                    return false;
                }
            } // if
        } // for


        $row->reorder("country_id = " . $this->_id);
    }
}
