<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// No direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class BreezingcommerceModelCurrency extends JModelLegacy
{

    function  __construct($config)
    {
        parent::__construct();

        $array = JRequest::getVar('cid',  0, '', 'array');
        $this->setId((int)$array[0]);

    }

    function setDefault()
    {
        $this->_db->setQuery("Select id From #__breezingcommerce_orders Where history = 1 And invoice_created = 0 And published = 1 Limit 1");
        if ($this->_db->loadResult()) {
            return 1;
        }

        if (empty( $this->_data )) {
            $this->_db->setQuery( ' Update #__breezingcommerce_currencies '.
                        '  Set `default` = 0' );
            $this->_db->query();
            
            $this->_db->setQuery( ' Update #__breezingcommerce_currencies '.
                        '  Set `default` = 1 Where id = '.$this->_id );
            $this->_db->query();
        }
    }

    function setPublished()
    {
        if (empty( $this->_data )) {
            $this->_db->setQuery( ' Update #__breezingcommerce_currencies '.
                        '  Set published = 1 Where id = '.$this->_id );
            $this->_db->query();
        }
    }

    function setUnpublished()
    {
       if (empty( $this->_data )) {
           $this->_db->setQuery( ' Update #__breezingcommerce_currencies '.
                        '  Set published = 0 Where id = '.$this->_id );
           $this->_db->query();
       }
    }

    /*
     * MAIN DETAILS AREA
     */

    /**
     *
     * @param int $id 
     */
    function setId($id) {
        // Set id and wipe data
        $this->_id      = $id;
        $this->_data    = null;
    }

    /**
    * Gets the currencies
    * @return array List of currencies
    */
    function getData()
    {
        // Load the data
        if (empty( $this->_data )) {
            $query = ' Select * From #__breezingcommerce_currencies '.
                    '  Where id = '.$this->_id;
            $this->_db->setQuery( $query );
            $this->_data = $this->_db->loadObject();
        }
        if (!$this->_data) {
            $this->_data = new stdClass();
            $this->_data->id = 0;
            $this->_data->name = null;
            $this->_data->code = null;
            $this->_data->symbol = null;
            $this->_data->conversion_rate = null;
            $this->_data->ordering = null;
            $this->_data->default = null;
            $this->_data->published = null;
        }
        
        // translations
        $this->_data->name_translation = '';
        
        if($this->_id){
            
            $this->_db->setQuery("Select * From #__breezingcommerce_translations Where `type` = 'currency' And item_id = ".$this->_db->quote( $this->_id )." And language_code = ".$this->_db->quote( JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','') ));
            
            $translated_object = $this->_db->loadObject();
            if($translated_object !== null){
                $this->_data->name_translation = $translated_object->title;
            }
        }
        // translations end
        
        return $this->_data;

    }

    function store()
    {
        $data = JRequest::get( 'post' );

        $this->_db->setQuery("Select count(id) From #__breezingcommerce_currencies Where `default` = 1");
        if(intval($this->_db->loadResult()) == 0){
            $data['default'] = 1;
        }

        $row = $this->getTable();

        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        $currency_id = 0;
        $store_res = $row->store();
        
        if (!$store_res) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        else
        {
            if( intval($data['id']) != 0 )
            {
                $currency_id = intval($data['id']);
            }
            else
            {
                $currency_id = $this->_db->insertid();
            }
        }
        
        if( isset( $data['name_translation'] ) ){
            $fields = array();
            $fields['title'] = $data['name_translation'];
            CrBcHelpers::storeTranslation($fields, $currency_id, 'currency');
        }
        
        $row->reorder();

        return true;
    }

    function delete()
    {
        $cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        JArrayHelper::toInteger($cids);
        $row = $this->getTable();

        foreach($cids as $cid) {
            if($row->load($cid) && !$row->default){
                if (!$row->delete( $cid )) {
                    $this->setError( $row->getErrorMsg() );
                    return false;
                }
                $this->_db->setQuery("Delete From #__breezingcommerce_translations Where type = 'currency' And item_id = " . $cid);
                $this->_db->query();
                $this->_db->setQuery("Delete From #__breezingcommerce_currency_price_map Where currency_id = " . $cid);
                $this->_db->query();
            }
        }

        $row->reorder();

        return true;
    }


    function move($direction) {

      $db = JFactory::getDBO();
      $mainframe = JFactory::getApplication();

      $row = $this->getTable('currency');

      if (!$row->load($this->_id)) {
         $this->setError($db->getErrorMsg());
         return false;
      }

      if (!$row->move( $direction )) {
         $this->setError($db->getErrorMsg());
         return false;
      }

      return true;
   }
}
