<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// No direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class BreezingcommerceModelCustomer extends JModelLegacy
{

    function  __construct($config)
    {
        parent::__construct();

        $array = JRequest::getVar('cid',  0, '', 'array');
        $this->setId((int)$array[0]);

    }

    function setPublished()
    {
        if (empty( $this->_data )) {
            $this->_db->setQuery( ' Update #__breezingcommerce_customers '.
                        '  Set published = 1 Where id = '.$this->_id );
            $this->_db->query();
        }
    }

    function setUnpublished()
    {
       if (empty( $this->_data )) {
           $this->_db->setQuery( ' Update #__breezingcommerce_customers '.
                        '  Set published = 0 Where id = '.$this->_id );
           $this->_db->query();
       }
    }

    /*
     * MAIN DETAILS AREA
     */

    /**
     *
     * @param int $id 
     */
    function setId($id) {
        // Set id and wipe data
        $this->_id      = $id;
        $this->_data    = null;
    }

    /**
    * Gets the customers
    * @return array List of customers
    */
    function getData()
    {
        // Load the data
        if (empty( $this->_data )) {
            $query = ' Select * From #__breezingcommerce_customers '.
                    '  Where id = '.$this->_id;
            $this->_db->setQuery( $query );
            $this->_data = $this->_db->loadObject();
        }
        if (!$this->_data) {
            $this->_data = new stdClass();
            $this->_data->id = 0;
            $this->_data->customergroup_id = 0;
            $this->_data->user_not_found = false;
            $this->_data->username = 0;
            
            $this->_data->userid = 0;
            $this->_data->firstname = null;
            $this->_data->lastname = null;
            $this->_data->company = null;
            $this->_data->email = null;
            $this->_data->address = null;
            $this->_data->address2 = null;
            $this->_data->city = null;
            $this->_data->zip = null;
            $this->_data->region_id = null;
            $this->_data->country_id = null;
            $this->_data->phone = null;
            $this->_data->mobile = null;
            $this->_data->fax = null;

            $this->_data->shipping_firstname = null;
            $this->_data->shipping_lastname = null;
            $this->_data->shipping_company = null;
            $this->_data->shipping_email = null;
            $this->_data->shipping_address = null;
            $this->_data->shipping_address2 = null;
            $this->_data->shipping_city = null;
            $this->_data->shipping_zip = null;
            $this->_data->shipping_region_id = null;
            $this->_data->shipping_country_id = null;
            $this->_data->shipping_phone = null;
            $this->_data->shipping_mobile = null;
            $this->_data->shipping_fax = null;
            
            $this->_data->use_shipping_address = false;

            $this->_data->ordering = null;
            $this->_data->published = null;
            
        }
        $query = ' Select * From #__breezingcommerce_countries ';
        $this->_db->setQuery($query);
        $this->_data->countries = $this->_db->loadObjectList();
        foreach ($this->_data->countries As $country) {
            $country->regions = array();
            $query = ' Select * From #__breezingcommerce_country_regions Where country_id = ' . $country->id;
            $this->_db->setQuery($query);
            $regions = $this->_db->loadObjectList();
            foreach ($regions As $region) {
                $country->regions[] = $region;
            }
        }

        $query = ' Select * From #__breezingcommerce_customergroups ';
        $this->_db->setQuery($query);
        $this->_data->customergroups = $this->_db->loadObjectList();

        $query = ' Select username From #__users Where id = ' . $this->_db->Quote($this->_data->userid);
        $this->_db->setQuery($query);
        $this->_data->username = $this->_db->loadResult();
        $this->_data->user_not_found = false;
        if(!$this->_data->username){
            $this->_data->username = JText::_('User doesn\'t exist');
            $this->_data->user_not_found = true;
        }

        $query = ' Select count(id) From #__breezingcommerce_orders Where published = 1 And customer_id = ' . $this->_id . ' And history_customer_id = customer_id And history_customer_name <> \'\'';
        $this->_db->setQuery($query);
        $this->_data->orders = $this->_db->loadResult();

        return $this->_data;

    }

    function store()
    {
        $data = JRequest::get( 'post' );
        
        if( isset($data['userid']) && isset($data['userid']['userid']) ){
            
            $data['userid'] = $data['userid']['userid'];
        }
        
        if( isset($data['userid']) && $data['userid'] != '0' ){
            
            $this->_db->setQuery("Select id From #__breezingcommerce_customers Where userid = " . $this->_db->quote($data['userid']) . ' Limit 1' );
            $exists = $this->_db->loadResult();
            
            if($exists){
                
                return 8;
            }
        }

        $data['address_complete'] = 1;
        
        if(!isset($data['customergroup_id']) || intval($data['customergroup_id']) == 0){
            return 1; // no customergroup
        }

        if(trim($data['firstname']) == '' || trim($data['lastname']) == ''){
            return 2; // firstname / lastname empty
        }

        if(!isset($data['use_shipping_address'])){
            $data['use_shipping_address'] = 0;
        }

        require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce' . DS . 'classes' . DS . 'CrBcHelpers.php');

        if(!CrBcHelpers::isEmail($data['email'])){
            return 3; // invalid email
        }

        if(isset($data['new_by']) && $data['new_by'] == 'existing_id'){

            if(intval($data['use_shipping_address']) == 1){
                if(!CrBcHelpers::isEmail($data['shipping_email'])){
                    return 4; // invalid shipping email
                }
            }

            if(isset($data['userid']) && intval($data['userid']) > 0){
                $this->_db->setQuery("Select id From #__users Where id = " . $this->_db->Quote($data['userid']));
                $result = $this->_db->loadResult();
                if(!$result){
                    return 5; // userid given but not found
                }
            }

        }
        else if(isset($data['new_by']) && $data['new_by'] == 'new_user'){

            if(isset($data['userid']) && intval($data['userid']) < 0){
                $data['userid'] = 0;
            }

            if(isset($data['username']) && isset($data['password']) && isset($data['password2'])){

                if (function_exists('mb_strlen')) {
                    if (mb_strlen($data['password']) < 8 || $data['password'] != $data['password2']) {
                        return 6; // password length
                    }
                } else {
                    if (strlen($data['password']) < 8 || $data['password'] != $data['password2']) {
                        return 6; // password length
                    }
                }

                $result = CrBcHelpers::registerUser(trim($data['firstname']) . ' ' . trim($data['lastname']), $data['username'], $data['email'], $data['password']);
                if(!is_numeric($result) || $result === false){
                    return 7; // registration issue
                }else{
                    $data['userid'] = $result;
                }
            }
        }
        
        $data['is_tmp'] = 0;
        
        $row = $this->getTable();

        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        if( isset($data['id']) && $data['id'] ){
            
            $this->_db->setQuery("Select userid From #__breezingcommerce_customers Where id = " . $this->_db->quote($data['id']));
            $userid = $this->_db->loadResult();
            
            $this->_db->setQuery("Select id From #__users Where email = " . $this->_db->quote($data['email']) . " And id <> ".$this->_db->quote($userid)." Limit 1");
            $exists = $this->_db->loadResult();
            
            if(!$exists && $userid > 0){
                
                $this->_db->setQuery("Update #__users Set email = " . $this->_db->quote($data['email']) . " Where id = " . $this->_db->quote($userid));
                $this->_db->execute();
            }
            else if($exists && $userid > 0)
            {
                JFactory::getApplication()->enqueueMessage(JText::_('COM_BREEZINGCOMMERCE_CUSTOMER_EMAIL_EXISTS'),'warning');
            }
        }

        return true;
    }

    function delete()
    {
        $cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        JArrayHelper::toInteger($cids);
        $row = $this->getTable();

        foreach($cids as $cid) {
            if($row->load($cid) && !$row->default){
                if (!$row->delete( $cid )) {
                    $this->setError( $row->getErrorMsg() );
                    return false;
                }

                $this->_db->setQuery("Select id From #__breezingcommerce_orders Where checked_out = 0 And history = 0 And customer_id = " . $cid);
                $orders = $this->_db->loadColumn();
                
                foreach($orders As $order){
                    $this->_db->setQuery("Delete From #__breezingcommerce_order_items Where order_id = " . $order);
                    $this->_db->query();
                }

                $this->_db->setQuery("Delete From #__breezingcommerce_orders Where checked_out = 0 And history = 0 And customer_id = " . $cid);
                $this->_db->query();
            }
        }

        //$row->reorder();

        return true;
    }


    function move($direction) {

      $db = JFactory::getDBO();
      $mainframe = JFactory::getApplication();

      $row = $this->getTable('customer');

      if (!$row->load($this->_id)) {
         $this->setError($db->getErrorMsg());
         return false;
      }

      if (!$row->move( $direction )) {
         $this->setError($db->getErrorMsg());
         return false;
      }

      return true;
   }

   function saveOrder()
    {
        $items	= JRequest::getVar( 'cid', array(), 'post', 'array' );
        JArrayHelper::toInteger($items);

        $total		= count( $items );
        $row		= $this->getTable('customer');
        $groupings	= array();

        $order		= JRequest::getVar( 'order', array(), 'post', 'array' );
        JArrayHelper::toInteger($order);

        // update ordering values
        for( $i=0; $i < $total; $i++ ) {
            $row->load( $items[$i] );
            if ($row->ordering != $order[$i]) {
                $row->ordering = $order[$i];
                if (!$row->store()) {
                    $this->setError($row->getError());
                    return false;
                }
            } // if
        } // for


        $row->reorder();
    }
}
