<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// No direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class BreezingcommerceModelCustomertaxclass extends JModelLegacy
{

    function  __construct($config)
    {
        parent::__construct();

        $array = JRequest::getVar('cid',  0, '', 'array');
        $this->setId((int)$array[0]);

    }

    function setDefault()
    {
        if (empty( $this->_data )) {
            $this->_db->setQuery( ' Update #__breezingcommerce_customertaxclasses '.
                        '  Set `default` = 0' );
            $this->_db->query();
            
            $this->_db->setQuery( ' Update #__breezingcommerce_customertaxclasses '.
                        '  Set `default` = 1 Where id = '.$this->_id );
            $this->_db->query();
        }
    }

    function setPublished()
    {
        if (empty( $this->_data )) {
            $this->_db->setQuery( ' Update #__breezingcommerce_customertaxclasses '.
                        '  Set published = 1 Where id = '.$this->_id );
            $this->_db->query();
        }
    }

    function setUnpublished()
    {
       if (empty( $this->_data )) {
           $this->_db->setQuery( ' Update #__breezingcommerce_customertaxclasses '.
                        '  Set published = 0 Where id = '.$this->_id );
           $this->_db->query();
       }
    }

    /*
     * MAIN DETAILS AREA
     */

    /**
     *
     * @param int $id 
     */
    function setId($id) {
        // Set id and wipe data
        $this->_id      = $id;
        $this->_data    = null;
    }

    /**
    * Gets the customertaxclasses
    * @return array List of customertaxclasses
    */
    function getData()
    {
        // Load the data
        if (empty( $this->_data )) {
            $query = ' Select * From #__breezingcommerce_customertaxclasses '.
                    '  Where id = '.$this->_id;
            $this->_db->setQuery( $query );
            $this->_data = $this->_db->loadObject();
        }
        if (!$this->_data) {
            $this->_data = new stdClass();
            $this->_data->id = 0;
            $this->_data->name = null;
            $this->_data->ordering = null;
            $this->_data->published = null;
        }
        $this->_db->setQuery("Select * From #__breezingcommerce_translations Where item_id = ".$this->_id." And type = 'customertaxclass' And language_code = ".$this->_db->quote( JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','') ));
        $name_translation = $this->_db->loadObject();
        $this->_data->name_translation = '';
        if($name_translation !== null){
            $this->_data->name_translation = $name_translation->title;
        }
        return $this->_data;

    }

    function store()
    {
        $row = $this->getTable();

        $data = JRequest::get( 'post' );
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        $customertaxclass_id = 0;
        $storeRes = $row->store();
        
        if (!$storeRes) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }else{
            if( intval($data['id']) != 0 )
            {
                $customertaxclass_id = intval($data['id']);
            }
            else
            {
                $customertaxclass_id = $this->_db->insertid();
            }
        }
        
        $row->reorder();

        if(isset($data['name_translation']) && $data['name_translation'] != ''){
            $fields = array();
            $fields['title'] = trim($data['name_translation']);
            CrBcHelpers::storeTranslation($fields, $customertaxclass_id, 'customertaxclass');
        }
        
        return true;
    }

    function delete()
    {
        $cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        JArrayHelper::toInteger($cids);
        $row = $this->getTable();

        foreach($cids as $cid) {
            if (!$row->delete( $cid )) {
                $this->setError( $row->getErrorMsg() );
                return false;
            }
            else{
                $this->_db->setQuery("Delete From #__breezingcommerce_taxrules_customertaxclasses Where customertaxclass_id = " . $cid);
                $this->_db->query();
                $this->_db->setQuery("Update #__breezingcommerce_customergroups Set tax_class_id = 0 Where tax_class_id = " . $cid);
                $this->_db->query();
            }
            $this->_db->setQuery("Delete From #__breezingcommerce_translations Where item_id = ".$cid." And type = 'customertaxclass'");
            $this->_db->query();
        }

        $row->reorder();

        return true;
    }


    function move($direction) {

      $db = JFactory::getDBO();
      $mainframe = JFactory::getApplication();

      $row = $this->getTable('customertaxclass');

      if (!$row->load($this->_id)) {
         $this->setError($db->getErrorMsg());
         return false;
      }

      if (!$row->move( $direction )) {
         $this->setError($db->getErrorMsg());
         return false;
      }

      return true;
   }
}
