<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// No direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class BreezingcommerceModelImage extends JModelLegacy
{

    function  __construct($config)
    {
        parent::__construct();

        $array = JRequest::getVar('cid',  0, '', 'array');
        $this->setId((int)$array[0]);

    }

    function setPublished()
    {
        if (empty( $this->_data )) {
            $this->_db->setQuery( ' Update #__breezingcommerce_images '.
                        '  Set published = 1 Where id = '.$this->_id );
            $this->_db->query();
        }
    }

    function setUnpublished()
    {
       if (empty( $this->_data )) {
           $this->_db->setQuery( ' Update #__breezingcommerce_images '.
                        '  Set published = 0 Where id = '.$this->_id );
           $this->_db->query();
       }
    }

    /*
     * MAIN DETAILS AREA
     */

    /**
     *
     * @param int $id 
     */
    function setId($id) {
        // Set id and wipe data
        $this->_id      = $id;
        $this->_data    = null;
    }

    /**
    * Gets the images
    * @return array List of images
    */
    function getData()
    {
        // Load the data
        if (empty( $this->_data )) {
            $query = ' Select * From #__breezingcommerce_images '.
                    '  Where id = '.$this->_id;
            $this->_db->setQuery( $query );
            $this->_data = $this->_db->loadObject();
        }
        if (!$this->_data) {
            $this->_data = new stdClass();
            $this->_data->id = 0;
            $this->_data->product_id = 0;
            $this->_data->name = null;
            $this->_data->alt_name = null;
            $this->_data->description = null;
            $this->_data->color = null;
            $this->_data->physical_name = null;
            $this->_data->default = null;
            $this->_data->published = null;
            $this->_data->ordering = null;
        }
        
        // translations
        $this->_data->description_translation = '';
        $this->_data->alt_name_translation = '';
        
        if($this->_id){
            
            $this->_db->setQuery("Select * From #__breezingcommerce_translations Where `type` = 'product_image' And item_id = ".$this->_db->quote( $this->_id )." And language_code = ".$this->_db->quote( JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','') ));
            
            $translated_object = $this->_db->loadObject();
            if($translated_object !== null){
                $this->_data->description_translation = $translated_object->body;
                $this->_data->alt_name_translation = $translated_object->title;
            }
        }
        // translations end
        
        return $this->_data;

    }

    function store()
    {
        $row = $this->getTable();

        $data = JRequest::get( 'post' );
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        
        $data['description_translation'] = JRequest::getVar( 'description_translation', '', 'POST', 'STRING', JREQUEST_ALLOWHTML );
        
        $fields = array();
        $fields['body'] = $data['description_translation'];
        $fields['title'] = $data['alt_name_translation'];

        CrBcHelpers::storeTranslation($fields, $row->id, 'product_image');
        
        $row->reorder('product_id = ' . JRequest::getInt('product_id', 0));

        /**
         * TODO: remove any special characters from image name
         */
        $fileinfo = JRequest::getVar('image', null, 'files', 'array');
        $data['name'] = strtolower( str_replace(array("-"," ","'","\"","\\","/"), array('_','_','','','',''), $data['name']) );

        if(trim($data['name']) == ''){
            $destNameNoExt = explode('.',$fileinfo['name']);
            unset($destNameNoExt[count($destNameNoExt)-1]);
            $destNameNoExt = implode('.', $destNameNoExt);
            $data['name'] = strtolower( str_replace(array("-"," ","'","\"","\\","/"), array('_','_','','','',''), $destNameNoExt) );
        }

        if(intval($fileinfo['size']) > 0 ) {

            require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcImage.php');
            CrBcImage::deleteProductImages(JRequest::getInt('product_id', 0), JRequest::getInt('id', 0));
            $data['image_name'] = $data['name'];
            $image = CrBcImage::generateProductImages($fileinfo, $data);

            if(false !== $image)
            {
                $this->_db->setQuery(
                        "Insert
                            Into
                                #__breezingcommerce_images
                                (`product_id`, `name`, `alt_name`, `description`, `background_color`, `physical_name`, `ordering`)
                            values
                                (
                                    " . $this->_db->Quote(JRequest::getInt('product_id', 0)) . ", "
                                      . $this->_db->Quote($data['name']) . ", "
                                      . $this->_db->Quote($data['alt_name']) . ","
                                      . $this->_db->Quote($data['description']) . ","
                                      . $this->_db->Quote($data['background_color']) . ","
                                      . $this->_db->Quote($image) . ",
                                      ".$row->ordering."
                                )
                            "
                ); // ordering = 999999 and reorder later makes sure that the image is inserted at last element. better for usability.
                $this->_db->query();
                $this->getTable('image')->reorder('product_id = ' . JRequest::getInt('product_id', 0));
            }
        }

        if(trim($data['name']) != '' && intval($fileinfo['size']) == 0){
           require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcImage.php');
           CrBcImage::renameProductImage(trim($data['name']), JRequest::getInt('product_id', 0), JRequest::getInt('id', 0));
        }

        return true;
    }

    function delete()
    {
        $cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        JArrayHelper::toInteger($cids);
        $row = $this->getTable();

        require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcImage.php');
        foreach($cids as $cid) {
            CrBcImage::deleteProductImages(intval(JRequest::getInt('product_id', 0)), $cid);
            if (!$row->delete( $cid )) {
                $this->setError( $row->getErrorMsg() );
                return false;
            }
            
            $this->_db->setQuery("Delete From #__breezingcommerce_translations Where type = 'product_image' And item_id = " . $cid);
            $this->_db->query();
        }

        $row->reorder('product_id = ' . JRequest::getInt('product_id', 0));

        return true;
    }

    function move($direction) {

      $db = JFactory::getDBO();
      $mainframe = JFactory::getApplication();

      $row = $this->getTable('image');

      if (!$row->load($this->_id)) {
         $this->setError($db->getErrorMsg());
         return false;
      }

      if (!$row->move( $direction, 'product_id = ' . JRequest::getInt('product_id', 0) )) {
         $this->setError($db->getErrorMsg());
         return false;
      }

      return true;
   }

    function saveOrder()
    {
        $items	= JRequest::getVar( 'cid', array(), 'post', 'array' );
        JArrayHelper::toInteger($items);

        $total		= count( $items );
        $row		= $this->getTable('image');
        $groupings	= array();

        $order		= JRequest::getVar( 'order', array(), 'post', 'array' );
        JArrayHelper::toInteger($order);

        for( $i=0; $i < $total; $i++ ) {
            $row->load( $items[$i] );
            $groupings[] = $row->product_id;
            if ($row->ordering != $order[$i]) {
                $row->ordering = $order[$i];
                if (!$row->store()) {
                    $this->setError($row->getError());
                    return false;
                }
            } // if
        } // for

        // execute updateOrder for each parent group
        $groupings = array_unique( $groupings );
        foreach ($groupings as $group) {
            $row->reorder('product_id = '.(int) $group);
        }
    }
}
