<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// No direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class BreezingcommerceModelPlugin extends JModelLegacy
{

    function  __construct($config)
    {
        parent::__construct();

        $array = JRequest::getVar('cid',  0, '', 'array');
        $this->setId((int)$array[0]);

    }

    function setDefault()
    {
        if (empty( $this->_data )) {
            $this->_db->setQuery( ' Update #__breezingcommerce_plugins '.
                        '  Set `default` = 0' );
            $this->_db->query();
            
            $this->_db->setQuery( ' Update #__breezingcommerce_plugins '.
                        '  Set `default` = 1 Where id = '.$this->_id );
            $this->_db->query();
        }
    }

    function setPublished()
    {
        if (empty( $this->_data )) {
            $this->_db->setQuery( ' Update #__breezingcommerce_plugins '.
                        '  Set published = 1 Where id = '.$this->_id );
            $this->_db->query();
        }
    }

    function setUnpublished()
    {
       if (empty( $this->_data )) {
           $this->_db->setQuery( ' Update #__breezingcommerce_plugins '.
                        '  Set published = 0 Where id = '.$this->_id );
           $this->_db->query();
       }
    }

    /*
     * MAIN DETAILS AREA
     */

    /**
     *
     * @param int $id 
     */
    function setId($id) {
        // Set id and wipe data
        $this->_id      = $id;
        $this->_data    = null;
    }

    function getPluginData($id){
        $query = ' Select * From #__breezingcommerce_plugins '.
                    '  Where id = '.intval($id);
        $this->_db->setQuery( $query );
        $data = $this->_db->loadObject();

        return $data;
    }

    function getPlugin($data){

        if(!isset($data->type) || !isset($data->name)) return null;

        jimport( 'joomla.filesystem.folder' );
        jimport( 'joomla.filesystem.file' );

        $path = JPATH_SITE . DS . 'media' . DS . 'breezingcommerce' . DS . 'plugins' . DS . $data->type . DS . $data->name . DS . 'admin' . DS;
        if(JFolder::exists($path)) {
            if(JFile::exists($path . 'index.php')) {
                $libpath = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce' . DS . 'classes' . DS . 'plugin' . DS;
                require_once($libpath . 'CrBcAdminPlugin.php' );
                require_once($libpath . 'CrBc'.ucfirst($data->type).'Plugin.php' );
                require_once($path . 'index.php');
                $class = 'CrBc_Plugins_' . ucfirst($data->type) . '_' . ucfirst($data->name) . '_Admin';
                if(class_exists($class)) {
                    $plugin = new $class;
                    if($plugin instanceof CrBcAdminPlugin) {
                        return $plugin;
                    }
                }else{
                    throw new CrBcCartException('Plugin admin class could not be found. Please check the classname.');
                }
            }
        }

        return null;
    }

    /**
    * Gets the plugins
    * @return array List of plugins
    */
    function getData()
    {
        // Load the data
        if (empty( $this->_data )) {
            $query = ' Select * From #__breezingcommerce_plugins '.
                    '  Where id = '.$this->_id;
            $this->_db->setQuery( $query );
            $this->_data = $this->_db->loadObject();

            $output = JText::_('No plugin settings available');
            $plugin = $this->getPlugin($this->_data);
            
            if($plugin !== null){
                $output = $plugin->getHtml();
            }
            
            $this->_data->output = $output;
            $this->_data->plugin = $plugin;
        }
        if (!$this->_data) {
            $this->_data = new stdClass();
            $this->_data->id = 0;
            $this->_data->name = null;
            $this->_data->type = null;
            $this->_data->version = null;
            $this->_data->selectable = null;
            $this->_data->ordering = null;
            $this->_data->published = null;
            $this->_data->output = null;
            $this->_data->plugin = null;
        }
        return $this->_data;

    }

    function store()
    {
        /*
        $row = $this->getTable();

        $data = JRequest::get( 'post' );
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }else{
            $query = ' Select * From #__breezingcommerce_plugins '.
                    '  Where id = '.$this->_id;
            $this->_db->setQuery( $query );
            $data = $this->_db->loadObject();

            $plugin = $this->getPlugin($data);

            if($plugin !== null){
                $plugin->store();
            }
        }
        
        $row->reorder();
        */
        
        return true;
    }

    function delete()
    {
        $cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        JArrayHelper::toInteger($cids);
        $row = $this->getTable();

        foreach($cids as $cid) {
            $this->_db->setQuery("Select `name`,`type` From #__breezingcommerce_plugins Where id = " . $cid);
            $plugin = $this->_db->loadObject();
            if (!$row->delete( $cid )) {
                $this->setError( $row->getErrorMsg() );
                return false;
            }
            else
            {
                jimport('joomla.filesystem.folder');
                jimport('joomla.filesystem.file');
                $path = JPATH_SITE . DS . 'media' . DS . 'breezingcommerce' . DS . 'plugins' . DS . $plugin->type . DS . $plugin->name;
                if(JFile::exists($path . DS. 'uninstall.php')){
                    $libpath = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce' . DS . 'classes' . DS . 'plugin' . DS;
                    require_once($libpath . 'CrBcUninstaller.php');
                    require_once($path . DS. 'uninstall.php');
                    $uninstaller = new CrBcUninstallation();
                    if($uninstaller instanceof CrBcUninstaller){
                        $uninstaller->uninstall();
                    }
                    $row->reorder("`type`=".$this->_db->Quote($plugin->type));
                }
                JFolder::delete($path);
                $this->_db->setQuery("Update #__breezingcommerce_orders Set plugin_id = 0 Where plugin_id = " . $cid);
                $this->_db->query();
            }
            break;
        }

        return true;
    }


    function move($direction) {

      $db = JFactory::getDBO();
      $mainframe = JFactory::getApplication();

      $row = $this->getTable('plugin');

      if (!$row->load($this->_id)) {
         $this->setError($db->getErrorMsg());
         return false;
      }

      if (!$row->move( $direction, "`type`=".$this->_db->Quote($row->type) )) {
         $this->setError($db->getErrorMsg());
         return false;
      }

      return true;
   }
}
