<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// No direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class BreezingcommerceModelProductproperties extends JModelLegacy
{
    /**
     * Items total
     * @var integer
     */
    private $_total = null;

    /**
     * Pagination object
     * @var object
     */
    private $_pagination = null;

    function  __construct($config) {
        parent::__construct($config);

        $mainframe = JFactory::getApplication();
        $option = 'com_breezingcommerce';

        // Get pagination request variables
        $limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
        $limitstart = JRequest::getVar('limitstart', 0, '', 'int');
        $product_id = JRequest::getVar('product_id', 0, '', 'int');

        // In case limit has been changed, adjust it
        $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

        $this->setState('limit', $limit);
        $this->setState('limitstart', $limitstart);

        $product_id     = $mainframe->getUserStateFromRequest(  $option.'product_id', 'product_id', 0, 'int' );
        $this->setState('product_id', $product_id);
        
        $readonly     = $mainframe->getUserStateFromRequest(  $option.'readonly', 'readonly', 0, 'int' );
        $this->setState('readonly', $readonly);

        $filter_order     = $mainframe->getUserStateFromRequest(  $option.'productproperties_filter_order', 'filter_order', 'ppk.ordering', 'cmd' );
        $filter_order_Dir = $mainframe->getUserStateFromRequest( $option.'productproperties_filter_order_Dir', 'filter_order_Dir', 'asc', 'word' );

        $this->setState('productproperties_filter_order', $filter_order);
        $this->setState('productproperties_filter_order_Dir', $filter_order_Dir);

        $filter_state = $mainframe->getUserStateFromRequest( $option.'productproperties_filter_state', 'filter_state', '', 'word' );
        $this->setState('productproperties_filter_state', $filter_state);
    }

    function delete()
    {
        $cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        JArrayHelper::toInteger($cids);
        $row = $this->getTable('productpropertykeys');

        foreach($cids as $cid) {
            $this->_db->setQuery("Select property_key_id From #__breezingcommerce_product_property_keys Where id = " . $cid);
            $ppkid = $this->_db->loadResult();
            //echo "Delete From #__breezingcommerce_product_property_values Where product_id = ".$this->getState('product_id')." And property_key_id = " . $ppkid;
            
            $this->_db->setQuery("Select id From #__breezingcommerce_product_property_values Where product_id = ".$this->getState('product_id')." And property_key_id = " . $ppkid);
            $productpropertyvalues = $this->_db->loadColumn();
            
            foreach($productpropertyvalues As $productpropertyvalue){
                $this->_db->setQuery("Delete From #__breezingcommerce_translations Where type = 'productpropertyvalue' And item_id = " . $productpropertyvalue);
                $this->_db->query();
            }
            
            $this->_db->setQuery("Delete From #__breezingcommerce_product_property_values Where product_id = ".$this->getState('product_id')." And property_key_id = " . $ppkid);
            $this->_db->query();
            $this->_db->setQuery("Delete From #__breezingcommerce_product_property_combination_items Where property_key_id = ".$ppkid." And product_id = ".$this->getState('product_id'));
            $this->_db->query();
            //echo $this->_db->getErrorMsg();
            if (!$row->delete( $cid )) {
                $this->setError( $row->getErrorMsg() );
            }
        }

        $row->reorder('product_id = '.$this->getState('product_id'));

        return true;
    }

    function importProperties(){

        require_once( JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcProperties.php' );
        return CrBcProperties::importProperties(array($this->getState('product_id')), $this, true, false, $this->getState('readonly') == 0 ? false : true);
    }

    function setRequired()
    {
        $cids = JRequest::getVar('cid', array(), '', 'array');
        JArrayHelper::toInteger($cids);
        $this->_db->setQuery( ' Update #__breezingcommerce_product_property_keys '.
                '  Set required = 1 Where id In ( ' . implode(',',$cids)  . ')');
        $this->_db->query();

    }

    function setUnrequired()
    {
        $cids = JRequest::getVar('cid', array(), '', 'array');
        JArrayHelper::toInteger($cids);
        $this->_db->setQuery( ' Update #__breezingcommerce_product_property_keys '.
                '  Set required = 0 Where id In ( ' . implode(',',$cids)  . ')');
        $this->_db->query();
    }

    function setPublished()
    {
        $cids = JRequest::getVar('cid', array(), '', 'array');
        JArrayHelper::toInteger($cids);
        $this->_db->setQuery( ' Update #__breezingcommerce_product_property_keys '.
                '  Set published = 1 Where id In ( ' . implode(',',$cids)  . ')');
        $this->_db->query();

    }

    function setUnpublished()
    {
        $cids = JRequest::getVar('cid', array(), '', 'array');
        JArrayHelper::toInteger($cids);
        $this->_db->setQuery( ' Update #__breezingcommerce_product_property_keys '.
                '  Set published = 0 Where id In ( ' . implode(',',$cids)  . ')');
        $this->_db->query();
    }

    /*
     *
     * MAIN LIST AREA
     * 
     */

    /**
     * @return string The query
     */
    private function _buildQuery(){
        $published = '';
        if($this->getState('productproperties_filter_state') == 'P')
        {
            $published = ' ppk.published = 1 And ';
        }
        else if($this->getState('productproperties_filter_state') == 'U')
        {
            $published = ' ppk.published = 0 And ';
        }
        return '
        Select
            SQL_CALC_FOUND_ROWS 
            ppk.*, 
            pk.key, 
            p.title As product_title 
        From 
            #__breezingcommerce_product_property_keys As ppk, 
            #__breezingcommerce_property_keys As pk,
            #__breezingcommerce_properties As pr,
            #__breezingcommerce_products As p 
        Where 
            ppk.product_id = p.id 
        And 
            '.$published.'
            ppk.product_id = ' . $this->_db->Quote( $this->getState('product_id') ) . '
        And
            pr.id = pk.property_id
        And
            pr.readonly = ' . $this->_db->Quote( $this->getState('readonly') ) . '
        And 
            pk.id = ppk.property_key_id 
        Order By 
            ppk.`ordering`';
    }

    /**
    * Gets the currencies
    * @return array List of currencies
    */
    function getData()
    {
        // Lets load the data if it doesn't already exist
        if (empty( $this->_data ))
        {
            $query = $this->_buildQuery();
            $this->_data = $this->_getList( $query, $this->getState('limitstart'), $this->getState('limit') );
        }

        return $this->_data;
    }

    function getTotal() {
        // Load the content if it doesn't already exist
        if (empty($this->_total)) {
            $query = $this->_buildQuery();
            $this->_total = $this->_getListCount($query);
        }
        return $this->_total;
    }

    function getPagination() {
        // Load the content if it doesn't already exist
        if (empty($this->_pagination)) {
            jimport('joomla.html.pagination');
            $this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
        }
        return $this->_pagination;
    }

    function move($direction) {

      $db = JFactory::getDBO();
      $mainframe = JFactory::getApplication();

      $items	= JRequest::getVar( 'cid', array(), 'post', 'array' );
      JArrayHelper::toInteger($items);

      if(count($items))
      {
          $row = $this->getTable('productpropertykeys');

          if (!$row->load($items[0])) {
             $this->setError($db->getErrorMsg());
             return false;
          }

          if (!$row->move( $direction, 'product_id = ' . JRequest::getInt('product_id', 0) )) {
             $this->setError($db->getErrorMsg());
             return false;
          }

      }

      return true;
   }

    function saveOrder()
    {
        $items	= JRequest::getVar( 'cid', array(), 'post', 'array' );
        JArrayHelper::toInteger($items);

        $total		= count( $items );
        $row		= $this->getTable('productpropertykeys');
        $groupings	= array();

        $order		= JRequest::getVar( 'order', array(), 'post', 'array' );
        JArrayHelper::toInteger($order);

        for( $i=0; $i < $total; $i++ ) {
            $row->load( $items[$i] );
            $groupings[] = $row->product_id;
            if ($row->ordering != $order[$i]) {
                $row->ordering = $order[$i];
                if (!$row->store()) {
                    $this->setError($row->getError());
                    return false;
                }
            } // if
        } // for

        // execute updateOrder for each parent group
        $groupings = array_unique( $groupings );
        foreach ($groupings as $group) {
            $row->reorder('product_id = '.(int) $group);
        }
    }

}
