<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// No direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class BreezingcommerceModelProducts extends JModelLegacy
{
    /**
     * Items total
     * @var integer
     */
    private $_total = null;

    /**
     * Pagination object
     * @var object
     */
    private $_pagination = null;

    function  __construct($config) {
        parent::__construct($config);

        $mainframe = JFactory::getApplication();
        $option = 'com_breezingcommerce';
        
        $search = $mainframe->getUserStateFromRequest("$option.product_search", 'product_search', '', 'string');
        $this->setState('product_search', $search);

        $search = $mainframe->getUserStateFromRequest("$option.product_search_by", 'product_search_by', '', 'string');
        $this->setState('product_search_by', $search);

        // Get pagination request variables
        $limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
        $limitstart = JRequest::getVar('limitstart', 0, '', 'int');

        // In case limit has been changed, adjust it
        $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

        $this->setState('limit', $limit);
        $this->setState('limitstart', $limitstart);

        $filter_order     = $mainframe->getUserStateFromRequest(  $option.'product_filter_order', 'filter_order', 'p.modified', 'cmd' );
        $filter_order_Dir = $mainframe->getUserStateFromRequest( $option.'product_filter_order_Dir', 'filter_order_Dir', 'desc', 'word' );

        $this->setState('product_filter_order', $filter_order);
        $this->setState('product_filter_order_Dir', $filter_order_Dir);

        $filter_state = $mainframe->getUserStateFromRequest( $option.'product_filter_state', 'filter_state', '', 'word' );
        $this->setState('product_filter_state', $filter_state);

        $filter_state = $mainframe->getUserStateFromRequest( $option.'product_filter_category', 'category', '', 'array' );
        if(isset($filter_state['category_id']) && $filter_state['category_id'] > 1){
            $this->setState('product_filter_category', $filter_state['category_id']);
        } else {
            $this->setState('product_filter_category', '');
        }
    }

    function importProperties($publish = false){
        $cids = JRequest::getVar('cid', array(), '', 'array');
        JArrayHelper::toInteger($cids);
        require_once( JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcProperties.php' );
        return CrBcProperties::importProperties($cids, $this, false, $publish);
    }

    function reorderProperties(){
        $cids = JRequest::getVar('cid', array(), '', 'array');
        JArrayHelper::toInteger($cids);
        require_once( JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcProperties.php' );
        return CrBcProperties::reorderProperties($cids, $this);
    }

    function copy()
    {
        $cids = JRequest::getVar('cid', array(), '', 'array');
        JArrayHelper::toInteger($cids);
        $this->_db->setQuery( ' Select * From #__breezingcommerce_products '.
                '  Where id In ( ' . implode(',',$cids)  . ')');
        $result = $this->_db->loadObjectList();
        require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcImage.php');
        require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcFile.php');
        require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcProperties.php');
        require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcAttributes.php');
        foreach($result As $obj)
        {
            $origId = $obj->id;
            unset($obj->id);
            mt_srand();
            $obj->item_number = '';
            $obj->title = 'Copy of ' . $obj->title;
            $obj->created = JFactory::getDate()->toSql();
            $obj->created_by = JFactory::getUser()->get('id', 0);
            $obj->created_by_alias = JFactory::getUser()->get('username', '');
            $obj->modified = JFactory::getDate()->toSql();
            $obj->modified_by = JFactory::getUser()->get('id', 0);
            $obj->modified_by_alias = JFactory::getUser()->get('username', '');
            $obj->published = 0;
            $this->_db->insertObject('#__breezingcommerce_products', $obj);
            $insertId = $this->_db->insertid();

            $obj->item_number = 'Item ' . $insertId;
            $obj->id = $insertId;
            $this->_db->updateObject('#__breezingcommerce_products', $obj, 'id');

            $this->_db->setQuery("Select category_id From #__breezingcommerce_product_categories Where product_id = " . $origId );
            $cats = $this->_db->loadObjectList();
            foreach($cats As $cat)
            {
                $this->_db->setQuery("Insert Into #__breezingcommerce_product_categories (product_id, category_id) Values (".$insertId.",".$cat->category_id.")");
                $this->_db->query();
                
                CrBcCategoriesHelper::reorderCategories($this, $cat->category_id);
            }

            $this->_db->setQuery("Select manufacturer_id From #__breezingcommerce_product_manufacturers Where product_id = " . $origId );
            $mans = $this->_db->loadObjectList();
            foreach($mans As $man)
            {
                $this->_db->setQuery("Insert Into #__breezingcommerce_product_manufacturers (product_id, manufacturer_id) Values (".$insertId.",".$man->manufacturer_id.")");
                $this->_db->query();
            }
            
            CrBcHelpers::copyTranslations($origId, $obj->id, 'product');

            CrBcProperties::copyProductProperties($origId, $insertId);
            CrBcAttributes::copyProductAttributes($origId, $insertId);
            CrBcImage::copyProductImages($origId, $insertId);
            $this->getTable('image')->reorder('product_id = ' . $insertId);
            CrBcFile::copyProductFiles($origId, $insertId);
            CrBcHelpers::addToPriceMap($insertId, $obj->producttaxclass_id);
        }
    }

    function setPublished()
    {
        $cids = JRequest::getVar('cid', array(), '', 'array');
        JArrayHelper::toInteger($cids);
        $this->_db->setQuery( ' Update #__breezingcommerce_products '.
                '  Set published = 1 Where id In ( ' . implode(',',$cids)  . ')');
        $this->_db->query();
        
        JPluginHelper::importPlugin('finder','crbcproduct');
        $dispatcher = JDispatcher::getInstance();
        $finder_row = new stdClass;
        
        foreach ($cids As $cid){
            $finder_row->id = $cid;
            $dispatcher->trigger('onFinderAfterSave', array('com_breezingcommerce.product', $finder_row, true));
        }
    }

    function setUnpublished()
    {
        $cids = JRequest::getVar('cid', array(), '', 'array');
        JArrayHelper::toInteger($cids);
        $this->_db->setQuery( ' Update #__breezingcommerce_products '.
                '  Set published = 0 Where id In ( ' . implode(',',$cids)  . ')');
        $this->_db->query();
        
        JPluginHelper::importPlugin('finder','crbcproduct');
        $dispatcher = JDispatcher::getInstance();
        $finder_row = new stdClass;
        
        foreach ($cids As $cid){
            $finder_row->id = $cid;
            $dispatcher->trigger('onFinderAfterSave', array('com_breezingcommerce.product', $finder_row, true));
        }
    }

    /*
     *
     * MAIN LIST AREA
     * 
     */

    private function buildOrderBy() {
        $mainframe = JFactory::getApplication();
        $option = 'com_breezingcommerce';

        $orderby = '';
        $filter_order     = $this->getState('product_filter_order');
        $filter_order_Dir = $this->getState('product_filter_order_Dir');

        /* Error handling is never a bad thing*/
        if(!empty($filter_order) && !empty($filter_order_Dir) ) {
            $orderby = ' ORDER BY '.$filter_order.' '.$filter_order_Dir;
        }

        return $orderby;
    }


    /**
     * @return string The query
     */
    private function _buildQuery(){

        $where = '';
        $match = '';

        // FILTER ACTIVATED?
        if($this->getState('product_search_by') == 'fulltext' && $this->getState('product_search') != '')
        {
            //$match = " Match (p.title, p.description_fulltext) Against (" . $this->_db->Quote( $this->getState('product_search') ) . " IN BOOLEAN MODE) ";
            
            $match = CrBcHelpers::createMatchAgainstLookupSql($this->getState('product_search'), array('title', 'description_fulltext'), 'p');
            
        }
        else if($this->getState('product_search_by') == 'item_number' && $this->getState('product_search') != '')
        {
            $match = " p.item_number = " . $this->_db->Quote( $this->getState('product_search' ) ) . " ";
        }
        else if($this->getState('product_search_by') == 'sku' && $this->getState('product_search') != '')
        {
            $match = " p.sku = " . $this->_db->Quote( $this->getState('product_search' ) ) . " ";
        }
        else if( ( $this->getState('product_search_by') == 'price' || $this->getState('product_search_by') == 'sale_price' ) && $this->getState('product_search') != '')
        {
            $column = 'p.'.$this->getState('product_search_by');
            $ex = explode(':', $this->getState('product_search'));

            if(count($ex) == 1 && is_numeric( trim($ex[0]) ))
            {
                $match = $column . " = " . $this->_db->Quote( $this->getState('product_search') ) . " ";
            }
            else if(count($ex) == 2 && is_numeric( trim($ex[0]) ) && is_numeric( trim($ex[1]) ))
            {
                $match = " ( " . $column . " >= " . $this->_db->Quote( trim($ex[0]) ) . " And " . $column . " <= " . $this->_db->Quote( trim($ex[1]) ) . " ) ";
            }
        }
        else if( ( $this->getState('product_search_by') == 'created' || $this->getState('product_search_by') == 'modified' ) && $this->getState('product_search') != '')
        {
            $column = 'p.'.$this->getState('product_search_by');
            $ex = explode('|', $this->getState('product_search'));

            if(count($ex) == 1)
            {
                $ex = explode(' ', $this->getState('product_search'));

                if( count($ex) == 1 )
                {
                    $match = " $column Between " . $this->_db->Quote( trim($ex[0]) . ' 00:00:00' ) . " And " . $this->_db->Quote( trim($ex[0]) . ' 23:59:59' );
                }
                else if( count($ex) == 2 )
                {
                    $match = " $column = " . $this->_db->Quote( trim($ex[0]) . ' ' . trim($ex[1]) ) . " ";
                }
            }
            else if(count($ex) == 2)
            {
                $dateFrom = trim($ex[0]);
                $dateTo = trim($ex[1]);
                
                $exFrom = explode(' ', $dateFrom);
                $exTo = explode(' ', $dateTo);

                if( count($exFrom) == 1 && count($exTo) == 1 )
                {
                    $match = " $column Between " . $this->_db->Quote( trim($exFrom[0]) . ' 00:00:00' ) . " And " . $this->_db->Quote( trim($exTo[0]) . ' 23:59:59' );
                }
                else if( count($exFrom) == 2 && count($exTo) == 2 )
                {
                    $match = " $column Between " . $this->_db->Quote( trim($exFrom[0]) . ' ' . trim($exFrom[1]) ) . " And " . $this->_db->Quote( trim($exTo[0]) . ' ' . trim($exTo[1]) ) . " ";
                }
            }
        }
        else if( $this->getState('product_search_by') == 'created_by_alias' && $this->getState('product_search') != '')
        {
            $column = 'p.'.$this->getState('product_search_by');
            $match = " $column = " . $this->_db->Quote( $this->getState('product_search' ) ) . " ";
        }
        // PUBLISHED FILTER SELECTED?
        $filter_state = '';
        if($this->getState('product_filter_state') == 'P' || $this->getState('product_filter_state') == 'U')
        {
            $published = 0;
            if($this->getState('product_filter_state') == 'P')
            {
                $published = 1;
            }

            $and = ' And';
            if($match != '') {
                $filter_state = ' And ';
            }

            $filter_state .= ' p.published = ' . $published;
        }
        // CATEGORY FILTER SELECTED?
        $filter_category = '';
        $filter_category_table = '';
        if($this->getState('product_filter_category') != '' && is_numeric($this->getState('product_filter_category'))){
            $and = ' And';
            if($filter_state != '' || $match != '') {
                $filter_category = ' And ';
            }
            $filter_category_table = ', #__breezingcommerce_categories As c, #__breezingcommerce_product_categories As pc ';
            $filter_category .= ' p.id = pc.product_id And c.id = pc.category_id And pc.category_id = ' . intval($this->getState('product_filter_category')) . ' ';
        }

        if($match != '' || $filter_state != '' || ($filter_category != '' && $filter_category_table != ''))
        {
            $where = ' Where ';
        }

        //echo 'Select SQL_CALC_FOUND_ROWS p.* From #__breezingcommerce_products As p ' . $filter_category_table . $where . $match . $filter_state . $filter_category . $this->buildOrderBy();
        return 'Select SQL_CALC_FOUND_ROWS p.* From #__breezingcommerce_products As p ' . $filter_category_table . $where . $match . $filter_state . $filter_category . $this->buildOrderBy();
    }

    /**
    * Gets the currencies
    * @return array List of products
    */
    function getData()
    {
        // Lets load the data if it doesn't already exist
        if (empty( $this->_data ))
        {
            $query = $this->_buildQuery();
            $this->_data = $this->_getList( $query, $this->getState('limitstart'), $this->getState('limit') );
        }

        return $this->_data;
    }

    function getTotal() {
        // Load the content if it doesn't already exist
        if (empty($this->_total)) {
            $query = $this->_buildQuery();
            $this->_total = $this->_getListCount($query);
        }
        return $this->_total;
    }

    function getPagination() {
        // Load the content if it doesn't already exist
        if (empty($this->_pagination)) {
            jimport('joomla.html.pagination');
            $this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
        }
        return $this->_pagination;
    }

}
