<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

defined('_JEXEC') or die('Restricted access');
?>
<script type="text/javascript">
    function crbc_submitbutton(pressbutton)
    {
        switch (pressbutton) {
            case 'cancel':
                submitform(pressbutton);
                break;
            case 'save':
                var error = false;

                if(!error)
                {
                    submitform(pressbutton);
                }
                
                break;
        }
    }


    // Joomla 1.6 compat
    if(typeof Joomla != 'undefined'){
        Joomla.submitbutton = crbc_submitbutton;
    }
    // Joomla 1.5 compat
    submitbutton = crbc_submitbutton;
</script>
<form action="index.php" method="post" name="adminForm" id="adminForm" class="inner-main">

    <div class='row-fluid'>
        <div class='span12' style='display:none;'></div>
        <div class="form-horizontal">
            <div class="tabbable tabs-stacked">
              <ul class="nav nav-tabs">
                <li class="active"><a href="#business_information" data-toggle="tab"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_BUSINESS_INFORMATION' ); ?></a></li>
                <li><a href="#products" data-toggle="tab"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCTS' ); ?></a></li>
                <li><a href="#invoices" data-toggle="tab"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_INVOICE' ); ?></a></li>
                <li><a href="#notifications" data-toggle="tab"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_NOTIFICATIONS' ); ?></a></li>
                <li><a href="#cart" data-toggle="tab"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_CART' ); ?></a></li>
                <li><a href="#checkout" data-toggle="tab"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_CHECKOUT' ); ?></a></li>
                <li><a href="#location_services" data-toggle="tab"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_MISC' ); ?></a></li>
              </ul>
              <div class="tab-content">
                <div class="tab-pane active" id="business_information">
                  <?php echo CrBcForm::render(
                        array(
                            'business_name',
                            'business_address',
                            'business_address2',
                            'business_zip',
                            'business_city',
                            'business_country',
                            'business_region',
                            'business_web',
                            'business_email',
                            'business_phone',
                            'business_mobile',
                            'business_fax',
                            'business_free_text_html',
                            'business_free_text',
                        ), 
                        $this->conf->attribs, 'configuration', 'business', 'params');?>
                </div>
                <div class="tab-pane" id="products">
                  <?php echo CrBcForm::render(array(
                        'backorders',
                        'weight_type',
                        'dimension_type',
                        'location_based_tax_rules',
                        'location_based_tax_rules_lax',
                        'apply_taxes_on',
                        'allow_currency_selection',
                        'decimal_places',
                        'thousands_separator',
                        'decimal_point',
                        'price_display',
                        'currency_display'
                      ), $this->conf->attribs, 'configuration', 'products', 'params');?>
                </div>
                <div class="tab-pane" id="invoices">
                  <?php echo CrBcForm::render(
                          array(
                              'zeros',
                              'invoice_prefix',
                              'invoice_suffix',
                              'invoice_return_prefix',
                              'invoice_return_suffix',
                              'invoice_attach_pdf',
                              'invoice_html_email',
                              'invoice_language',
                              'custom_invoice_numbers_algorithm',
                              'custom_order_numbers_algorithm',
                              
                              'invoice_template_pdf',
                              'reset_invoice_template_pdf',
                              'invoice_template_html',
                              'reset_invoice_template_html',
                              'invoice_template_text',
                              'reset_invoice_template_text',
                              
                              'invoice_return_template_pdf',
                              'reset_invoice_return_template_pdf',
                              'invoice_return_template_html',
                              'reset_invoice_return_template_html',
                              'invoice_return_template_text',
                              'reset_invoice_return_template_text'
                ), $this->conf->attribs, 'configuration', 'invoice', 'params');?>
                    
                </div>
                <div class="tab-pane" id="notifications">
                    <?php echo CrBcForm::render(array('notifications_default_status'), $this->conf->attribs, 'configuration', 'notifications', 'params');?>
                </div>
                <div class="tab-pane" id="cart">
                <?php echo CrBcForm::render(
                            array(
                                'cart_display_unit_net_column',
                                'cart_display_unit_tax_column',
                                'cart_display_unit_gross_column',
                                'cart_display_total_net_column',
                                'cart_display_total_tax_column',
                                'cart_display_total_gross_column',
                                'cart_display_subtotal_net_column',
                                'cart_display_subtotal_gross_column',
                                'cart_display_tax_position'
                            ), 
                            $this->conf->attribs, 
                            'configuration', 
                            'cart', 
                            'params');?>
                </div>
                <div class="tab-pane" id="checkout">
                <?php echo CrBcForm::render(
                            array(
                                'order_notification_emails',
                                'allow_guest_checkout',
                                'checkout_limited_address_data',
                                'thank_you_message',
                                'checkout_information1',
                                'checkout_confirm_information1',
                                'checkout_information2',
                                'checkout_confirm_information2',
                                'checkout_information3',
                                'checkout_confirm_information3',
                                'checkout_information4',
                                'checkout_confirm_information4'
                            ), 
                            $this->conf->attribs, 
                            'configuration', 
                            'checkout', 
                            'params');?>
                </div>
                <div class="tab-pane" id="location_services">
                <fieldset>
                        <label><h3><?php echo JText::_('COM_BREEZINGCOMMERCE_CONFIG_DEFAULT_MISC_OPTIONS'); ?></h3></label>

                <?php echo CrBcForm::render(
                            array(
                                'enable_location_services',
                                'default_cart_menu_item_id',
                                'default_checkout_menu_item_id',
                                'canonical_host',
                                'enable_alternate_tags',
                                'session_keepalive'
                            ), 
                            $this->conf->attribs, 
                            'configuration', 
                            'misc', 
                            'params');?>
                </fieldset>
                    <fieldset>
                        <label><h3><?php echo JText::_('COM_BREEZINGCOMMERCE_CONFIG_DEFAULT_CATEGORY_OPTIONS'); ?></h3></label>

                        <?php echo CrBcForm::render(
                                array(
                                    'hide_details',
                                    'cart_add_button_location',
                                    'display_image',
                                    'link_title',
                                    'display_text',
                                    'enable_category_description',
                                    'enable_simple_product_view',
                                    'enable_sortby',
                                    'enable_showperpage',
                                    'enable_blockview',
                                    'enable_listview',
                                    'enable_dynamic_price',
                                    'enable_ajax_cart_add'
                                ), 
                                $this->conf->attribs, 
                                'configuration', 
                                'misc', 
                                'params');?>
                    </fieldset>
                    
                </div>
            </div> <!-- /tabbable -->
        </div>

    </div>

<div class="crbc-clear"></div>

<input type="hidden" name="option" value="com_breezingcommerce" />
<input type="hidden" name="id" value="<?php echo $this->conf->id; ?>" />
<input type="hidden" name="cid[]" value="<?php echo $this->conf->id; ?>" />
<input type="hidden" name="task" value="" />
<input type="hidden" name="controller" value="configuration" />
</form>


