<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

defined('_JEXEC') or die('Restricted access');
?>
<script type="text/javascript">
    function crbc_submitbutton(pressbutton)
    {
        switch (pressbutton) {
            case 'cancel':
                submitform(pressbutton);
                break;
            case 'save':
                var error = false;

                if(!error)
                {
                    submitform(pressbutton);
                }

                break;
        }
    }

    // Joomla 1.6 compat
    if(typeof Joomla != 'undefined'){
        Joomla.submitbutton = crbc_submitbutton;
    }
    // Joomla 1.5 compat
    submitbutton = crbc_submitbutton;
</script>

<a href="#" onclick="javascript: submitbutton('save')" class="toolbar btn">
<span class="icon-save" title="Save">
</span>
<?php echo JText::_('COM_BREEZINGCOMMERCE_SAVE'); ?>
</a>

<a href="#" onclick="javascript: submitbutton('cancel')" class="toolbar btn">
<span class="icon-cancel" title="Close">
</span>
<?php echo JText::_('COM_BREEZINGCOMMERCE_CLOSE'); ?>
</a>

<br/>
<br/>

<form action="index.php" method="post" name="adminForm" id="adminForm" enctype="multipart/form-data">

    <div class="form-horizontal">

        <div class="control-group">
            <div class="control-label">
                <label class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_PRODUCT_FILE_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_FILE' ); ?></label>
            </div>
            <div class="controls">
                <a href="index.php?option=com_breezingcommerce&amp;controller=files&amp;task=download&amp;file_id=<?php echo $this->file->id;?>"><?php echo JText::_('COM_BREEZINGCOMMERCE_DOWNLOAD');?></a>
               <?php
                    $size = number_format($this->file->filesize/(1024*1024),2) . ' ' . JText::_('MB');
                    if(!floatval($size)){
                        $size = @number_format($this->file->filesize/(1024),2) . ' kb';
                    }
                    echo $size;
                ?>
            </div>
        </div>

        <div class="control-group">
            <div class="control-label">
                <label for="product_file" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_PRODUCT_FILE_UPLOAD_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_FILE_UPLOAD' ); ?></label>
            </div>
            <div class="controls">
                <input type="file" name="product_file" id="product_file" />
            </div>
        </div>

        <div class="control-group">
            <div class="control-label">
                <label class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_PRODUCT_FILENAME_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_FILENAME' ); ?></label>
            </div>
            <div class="controls">
                <?php echo htmlentities( $this->file->filename2, ENT_QUOTES, 'UTF-8');?>
            </div>
        </div>

        <div class="control-group">
            <div class="control-label">
                <label class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_REQUIRES_VERIFICATION_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_REQUIRES_VERIFICATION' ); ?></label>
            </div>
            <div class="controls">
                <fieldset id="file_verification_fieldset" class="radio btn-group btn-group-yesno">
                    <input type="radio" name="file_verification" id="file_verification_1" value="0" <?php echo !$this->file->requires_verification ? ' checked="checked"' : '' ?>/>
                    <label for="file_verification_1"><?php echo JText::_('COM_BREEZINGCOMMERCE_NO');?></label>
                    <input type="radio" name="file_verification" id="file_verification_2" value="1"<?php echo $this->file->requires_verification ? ' checked="checked"' : '' ?>/>
                    <label for="file_verification_2"><?php echo JText::_('COM_BREEZINGCOMMERCE_YES');?></label>
                </fieldset>
            </div>
        </div>

        <div class="control-group">
            <div class="control-label">
                <label for="file_verification_days" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_VERIFICATION_DAYS_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_VERIFICATION_DAYS' ); ?></label>
            </div>
            <div class="controls">
                <input type="text" name="file_verification_days" id="file_verification_days" value="<?php echo $this->file->verification_days?>" />
            </div>
        </div>

        <div class="control-group">
            <div class="control-label">
                <label for="file_verification_tries" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_VERIFICATION_DOWNLOAD_TRIES_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_VERIFICATION_DOWNLOAD_TRIES' ); ?></label>
            </div>
            <div class="controls">
                <input type="text" name="file_verification_tries" id="file_verification_tries" value="<?php echo $this->file->verification_download_tries?>" />
            </div>
        </div>

        <div class="control-group">
            <div class="control-label">
                <label for="file_name" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_FILE_NAME_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_NAME' ); ?></label>
            </div>
            <div class="controls">
                <input type="text" name="file_name" id="file_name" size="32" maxlength="250" value="<?php echo htmlentities( $this->file->name, ENT_QUOTES, 'UTF-8');?>" />
            </div>
        </div>

        <div class="form-vertical">

            <?php
            if(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','') != ''){

                $pane4 = new CrBcPane();
                echo $pane4->initPane(
                    array(
                        'translation-file-pane' => htmlentities(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language_title',''), ENT_QUOTES, 'UTF-8' ),
                        'original-file-pane' => JText::_( 'COM_BREEZINGCOMMERCE_DEFAULT_LANGUAGE' )
                    )
                );

                echo $pane4->startPane();
                echo $pane4->startPanel( 'translation-file-pane' );

            ?>

            <div class="control-group">
                <div class="control-label">
                    <label for="file_description_translation" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_PRODUCT_DESCRIPTION_FILE_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_DESCRIPTION' ); ?></label>
                </div>
                <div class="controls">
                    <?php
                    JImport( 'joomla.html.editor' );
                    $editor = JFactory::getEditor();
                    echo $editor->display("file_description_translation",$this->file->file_description_translation, '100%', '200', '75', '20');
                    ?>
                    </div>
            </div>

            <?php
                echo $pane4->endPanel();
                echo $pane4->startPanel( 'original-file-pane' );
            }
            ?>

            <div class="control-group">
                <div class="control-label">
                    <label for="file_description" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_PRODUCT_DESCRIPTION_FILE_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_DESCRIPTION' ); ?></label>
                </div>
                <div class="controls">
                    <?php
                    JImport( 'joomla.html.editor' );
                    $editor = JFactory::getEditor();
                    echo $editor->display("file_description",$this->file->description, '100%', '200', '75', '20');
                    ?>
                    </div>
            </div>

            <?php
            if(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','')){
                echo $pane4->endPanel();
                echo $pane4->endPane();
            }
            ?>

        </div>

    </div>


    <div class="ct-clear"></div>

    <input type="hidden" name="option" value="com_breezingcommerce" />
    <input type="hidden" name="id" value="<?php echo $this->file->id; ?>" />
    <input type="hidden" name="cid[]" value="<?php echo $this->file->id; ?>" />
    <input type="hidden" name="task" value="" />
    <input type="hidden" name="controller" value="files" />
    <input type="hidden" name="ordering" value="<?php echo $this->file->ordering ;?>" />
    <input type="hidden" name="published" value="<?php echo $this->file->published ;?>" />
    <input type="hidden" name="product_id" value="<?php echo $this->product_id ;?>" />
    <input type="hidden" name="limitstart" value="<?php echo $this->limitstart ;?>" />

</form>
