<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

defined('_JEXEC') or die('Restricted access');
?>
<script type="text/javascript">
    function crbc_submitbutton(pressbutton)
    {
        switch (pressbutton) {
            case 'cancel':
                submitform(pressbutton);
                break;
            case 'save':
                var error = false;

                if(!error)
                {
                    submitform(pressbutton);
                }

                break;
        }
    }

    // Joomla 1.6 compat
    if(typeof Joomla != 'undefined'){
        Joomla.submitbutton = crbc_submitbutton;
    }
    // Joomla 1.5 compat
    submitbutton = crbc_submitbutton;
</script>


<a href="#" onclick="javascript: submitbutton('save')" class="btn toolbar">
<span class="icon-save" title="Save">
</span>
<?php echo JText::_('COM_BREEZINGCOMMERCE_SAVE'); ?>
</a>

<a href="#" onclick="javascript: submitbutton('cancel')" class="btn toolbar">
<span class="icon-cancel" title="Close">
</span>
<?php echo JText::_('COM_BREEZINGCOMMERCE_CLOSE'); ?>
</a>

<br/>
<br/>

<form action="index.php" method="post" name="adminForm" id="adminForm" enctype="multipart/form-data">

        <div class="form-horizontal">

            <div class="control-group">
                <div class="control-label">
                    <label for="crbc-product-image<?php echo $this->image->id;?>" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_IMAGE_PREVIEW_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_IMAGE' ); ?></label>
                </div>
                <div class="controls">
                    <?php require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcImage.php'); ?>
                <?php echo CrBcImage::getProductImageTag($this->image->physical_name, 'medium', $this->image->id, $this->image->alt_name); ?>
                </div>
            </div>

            <div class="control-group">
                <div class="control-label">
                    <label for="image" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_IMAGE_UPLOAD_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_IMAGE_UPLOAD' ); ?></label>
                </div>
                <div class="controls">
                    <input type="file" name="image" id="image" />
                </div>
            </div>

            <div class="control-group">
                <div class="control-label">
                    <label class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_IMAGE_PHYSICAL_NAME_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_PHYSICAL_NAME' ); ?></label>
                </div>
                <div class="controls">
                    <?php echo htmlentities( $this->image->physical_name, ENT_QUOTES, 'UTF-8');?>
                </div>
            </div>

            <div class="control-group">
                <div class="control-label">
                    <label for="name" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_IMAGE_NAME_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_NAME' ); ?></label>
                </div>
                <div class="controls">
                    <input class="text_area" type="text" name="name" id="name" maxlength="250" value="<?php echo htmlentities( $this->image->name, ENT_QUOTES, 'UTF-8');?>" />
                </div>
            </div>

            <div class="control-group">
                <div class="control-label">
                    <label for="background_color" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_PRODUCT_IMAGE_BACKGROUND_COLOR_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_BACKGROUND_COLOR' ); ?></label>
                </div>
                <div class="controls">
                    <input type="text" name="background_color" id="background_color" maxlength="6" value="<?php echo htmlentities( $this->image->background_color, ENT_QUOTES, 'UTF-8');?>" />
                </div>
            </div>

            <div class="form-vertical">

                <?php
                if(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','') != ''){

                    $pane4 = new CrBcPane();
                    echo $pane4->initPane(
                        array(
                            'translation-image-pane' => htmlentities(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language_title',''), ENT_QUOTES, 'UTF-8' ),
                            'original-image-pane' => JText::_( 'COM_BREEZINGCOMMERCE_DEFAULT_LANGUAGE' )
                        )
                    );

                    echo $pane4->startPane();
                    echo $pane4->startPanel( 'translation-image-pane' );
                ?>

                <div class="control-group">
                    <div class="control-label">
                        <label for="alt_name_translation" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_PRODUCT_IMAGE_ALT_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_ALT_NAME' ); ?></label>
                    </div>
                    <div class="controls">
                        <input type="text" name="alt_name_translation" id="alt_name" maxlength="250" value="<?php echo htmlentities( $this->image->alt_name_translation, ENT_QUOTES, 'UTF-8');?>" />
                    </div>
                </div>

                <div class="control-group">
                    <div class="control-label">
                        <label for="description_translation" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_PRODUCT_IMAGE_DESCRIPTION_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_DESCRIPTION' ); ?></label>
                    </div>
                    <div class="controls">
                        <?php
                        JImport( 'joomla.html.editor' );
                        $editor = JFactory::getEditor();
                        echo $editor->display("description_translation",$this->image->description_translation, '100%', '350', '75', '20');
                        ?>
                    </div>
                </div>

                <?php
                    echo $pane4->endPanel();
                    echo $pane4->startPanel( 'original-image-pane' );
                }
                ?>

                <div class="control-group">
                    <div class="control-label">
                        <label for="alt_name" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_PRODUCT_IMAGE_ALT_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_ALT_NAME' ); ?></label>
                    </div>
                    <div class="controls">
                        <input type="text" name="alt_name" id="alt_name" maxlength="250" value="<?php echo htmlentities( $this->image->alt_name, ENT_QUOTES, 'UTF-8');?>" />
                    </div>
                </div>

                <div class="control-group">
                    <div class="control-label">
                        <label for="description" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_PRODUCT_IMAGE_DESCRIPTION_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_DESCRIPTION' ); ?></label>
                    </div>
                    <div class="controls">
                        <?php
                        JImport( 'joomla.html.editor' );
                        $editor = JFactory::getEditor();
                        echo $editor->display("description",$this->image->description, '100%', '350', '75', '20');
                        ?>
                    </div>
                </div>

                <?php
                if(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','')){
                    echo $pane4->endPanel();
                    echo $pane4->endPane();
                }
                ?>

            </div>

        </div>

<div class="ct-clear"></div>

<input type="hidden" name="option" value="com_breezingcommerce" />
<input type="hidden" name="id" value="<?php echo $this->image->id; ?>" />
<input type="hidden" name="cid[]" value="<?php echo $this->image->id; ?>" />
<input type="hidden" name="task" value="" />
<input type="hidden" name="controller" value="images" />
<input type="hidden" name="ordering" value="<?php echo $this->image->ordering ;?>" />
<input type="hidden" name="published" value="<?php echo $this->image->published ;?>" />
<input type="hidden" name="product_id" value="<?php echo $this->product_id ;?>" />
<input type="hidden" name="limitstart" value="<?php echo $this->limitstart ;?>" />
</form>
