<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

defined('_JEXEC') or die('Restricted access');
?>
<script type="text/javascript">
    function crbc_submitbutton(pressbutton)
    {
        switch (pressbutton) {
            case 'cancel':
                submitform(pressbutton);
                break;
            case 'save':
                var error = false;

                if(!error)
                {
                    submitform(pressbutton);
                }

                break;
        }
    }

    // Joomla 1.6 compat
    if(typeof Joomla != 'undefined'){
        Joomla.submitbutton = crbc_submitbutton;
    }
    // Joomla 1.5 compat
    submitbutton = crbc_submitbutton;
</script>


<a href="#" onclick="javascript: submitbutton('save')" class="toolbar btn">
<span class="icon-save" title="Save">
</span>
<?php echo JText::_('COM_BREEZINGCOMMERCE_SAVE'); ?>
</a>

<a href="#" onclick="javascript: submitbutton('cancel')" class="toolbar btn">
<span class="icon-cancel" title="Close">
</span>
<?php echo JText::_('COM_BREEZINGCOMMERCE_CLOSE'); ?>
</a>

<br/>
<br/>

<form action="index.php" method="post" name="adminForm" id="adminForm" enctype="multipart/form-data">

        <div class="form-horizontal">

            <div class="control-group">
                <div class="control-label">
                    <label class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_PROPERTIES_VALUE_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_VALUE' ); ?></label>
                </div>
                <div class="controls">
                    <?php echo htmlentities( $this->value->value, ENT_QUOTES, 'UTF-8');?>
                </div>
            </div>
            
            <?php
            // translations
            if(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','') != ''){

                $pane2 = new CrBcPane();
                echo $pane2->initPane(
                    array(
                        'translation-pane' => htmlentities(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language_title',''), ENT_QUOTES, 'UTF-8' ),
                        'original-pane' => JText::_( 'COM_BREEZINGCOMMERCE_DEFAULT_LANGUAGE' )
                    )
                );

                echo $pane2->startPane();
                echo $pane2->startPanel( 'translation-pane' );
            ?>

            <div class="control-group">
                <div class="control-label">
                    <label for="custom_value_translation" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_PROPERTIES_CUSTOM_VALUE_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_CUSTOM_VALUE' ); ?></label>
                </div>
                <div class="controls">
                    <input type="text" name="custom_value_translation" id="custom_value_translation" value="<?php echo htmlentities( $this->value->custom_value_translation, ENT_QUOTES, 'UTF-8');?>" />
                </div>
            </div>

            <?php
                echo $pane2->endPanel();
                echo $pane2->startPanel( 'original-pane' );
            }

            // default (all) case
            ?>

            <div class="control-group">
                <div class="control-label">
                    <label for="custom_value" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_PROPERTIES_CUSTOM_VALUE_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_CUSTOM_VALUE' ); ?></label>
                </div>
                <div class="controls">
                    <input type="text" name="custom_value" id="custom_value" value="<?php echo htmlentities( $this->value->custom_value, ENT_QUOTES, 'UTF-8');?>" />
                </div>
            </div>

            <?php
            if(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','')){
                echo $pane2->endPanel();
                echo $pane2->endPane();
            }
            // translations end
            ?>

            <div class="control-group">
                <div class="control-label">
                    <label for="image" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_PROPERTIES_PRICE_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRICE' ); ?></label>
                </div>
                <div class="controls">
                    <input type="text" name="price" id="price" maxlength="250" value="<?php echo htmlentities( $this->value->price < 0 ? '' : $this->value->price, ENT_QUOTES, 'UTF-8');?>" />
                </div>
            </div>

            <div class="control-group">
                <div class="control-label">
                    <label for="image" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_PROPERTIES_PLUS_PRICE_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_IS_PLUS_PRICE' ); ?></label>
                </div>
                <div class="controls">
                    <fieldset id="is_plus_price_fieldset" class="radio btn-group btn-group-yesno">
                        <input type="radio" name="is_plus_price" id="is_plus_price_1" value="1"<?php echo $this->value->is_plus_price ? ' checked="checked"' : '';?>/>
                        <label for="is_plus_price_1"><?php echo JText::_('COM_BREEZINGCOMMERCE_YES');?></label>
                        <input type="radio" name="is_plus_price" id="is_plus_price_2" value="0"<?php echo !$this->value->is_plus_price ? ' checked="checked"' : '';?>/>
                        <label for="is_plus_price_2"><?php echo JText::_('COM_BREEZINGCOMMERCE_NO');?></label>
                    </fieldset>
                </div>
            </div>

            <div class="control-group">
                <div class="control-label">
                    <label for="image" class="tip-top hasTooltip" title="<?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_PROPERTIES_SELECTED_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_SELECTED' ); ?></label>
                </div>
                <div class="controls">
                    <fieldset id="selected_fieldset" class="radio btn-group btn-group-yesno">
                        <input type="radio" id="selected_1" name="selected" value="1"<?php echo $this->value->selected ? ' checked="checked"' : ''?>/>
                        <label for="selected_1"><?php echo JText::_('COM_BREEZINGCOMMERCE_YES');?></label>
                        <input type="radio" id="selected_2" name="selected" value="0"<?php echo !$this->value->selected ? ' checked="checked"' : ''?>/>
                        <label for="selected_2"><?php echo JText::_('COM_BREEZINGCOMMERCE_NO');?></label>
                    </fieldset>
                </div>
            </div>

        </div>

<div class="ct-clear"></div>

<input type="hidden" name="option" value="com_breezingcommerce" />
<input type="hidden" name="id" value="<?php echo $this->value->id; ?>" />
<input type="hidden" name="cid[]" value="<?php echo $this->value->id; ?>" />
<input type="hidden" name="task" value="" />
<input type="hidden" name="controller" value="productpropertyvalues" />
<input type="hidden" name="ordering" value="<?php echo $this->value->ordering ;?>" />
<input type="hidden" name="published" value="<?php echo $this->value->published ;?>" />
<input type="hidden" name="product_id" value="<?php echo $this->product_id ;?>" />
<input type="hidden" name="key_id" value="<?php echo $this->key_id ;?>" />
<input type="hidden" name="limitstart" value="<?php echo $this->limitstart ;?>" />
</form>
