<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// INSTEAD OF COST INTENSIVE NESTED CATEGORIES THAT ANYWAY WOULD MAKE PROBLEMS ON
// ON NARROW MODULE POSITIONS AND MOBILES, THIS IS A FLAT CATEGORY VIEW

// no direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

$more_steps = $params->get('count',10);

$menu_item_id = 0;

if( intval($params->get('default_menu_item_id',0)) > 0 ){

    $menu_item_id = intval($params->get('default_menu_item_id',0));
}else{

    $menu_item_id = CrBcHelpers::getDefaultMenuItemId();
}

// please don't move this around

$db = JFactory::getDbo();

// current url, don't touch

$here = JUri::getInstance()->toString();

// unlike the default above, the default with the session is 1,
// as it is the ROOT category id which is always invisible and immutable
// same goes for the session default (2nd parameter)

$selected_category_id = 1;

if( JRequest::getInt('crbc_mod_category_id', 0) != 0 ){
    
    JFactory::getSession()->set('com_breezingcommerce.mod_categories.selected_category', 1);
    $selected_category_id = JFactory::getSession()->get('com_breezingcommerce.mod_categories.selected_category', 1);
    
    // going "home" also resets the more button
    JFactory::getSession()->set('com_breezingcommerce.mod_categories.categories_more', $more_steps);
    
}
else
if( JRequest::getInt('category_id', 0) != 0 && JRequest::getVar('option', '') == 'com_breezingcommerce' ){

    JFactory::getSession()->set('com_breezingcommerce.mod_categories.selected_category', JRequest::getInt('category_id', 0));

    $selected_category_id = JFactory::getSession()->get('com_breezingcommerce.mod_categories.selected_category', 0);
}
else
if( JRequest::getInt('product_id', 0) != 0 && JRequest::getVar('option', '') == 'com_breezingcommerce' ){
    
    $db->setQuery("Select category_id From #__breezingcommerce_product_categories Where product_id = " . $db->quote(JRequest::getInt('product_id', 0)) . " Order By ordering Limit 1");
    $product_category_id = $db->loadResult();
    
    JFactory::getSession()->set('com_breezingcommerce.mod_categories.selected_category', $product_category_id);
    $selected_category_id = JFactory::getSession()->get('com_breezingcommerce.mod_categories.selected_category', $product_category_id);
    
}


/* I would say we off that for now
else
{
    $selected_category_id = JFactory::getSession()->get('com_breezingcommerce.mod_categories.selected_category', $selected_category_id);
}*/

// Setting and remembering the MORE button and how many to show max. (more at the bottom)

if( JRequest::getInt('crbc_mod_categories_more', 0) != 0 ){

    JFactory::getSession()->set('com_breezingcommerce.mod_categories.categories_more', JRequest::getInt('crbc_mod_categories_more', $more_steps));

}
else
{
    $categories_more = JFactory::getSession()->get('com_breezingcommerce.mod_categories.categories_more', $more_steps);
    JRequest::setVar('crbc_mod_categories_more', $categories_more);
}

// make sure not to show categories that haven't been translated at least partially
$check_for_translation_tbl = '';
$check_for_translation_lookup = '';
$check_for_translation_lookup_root = '';

$default = JComponentHelper::getParams('com_languages')->get('site');
if( count(JFactory::getLanguage()->getKnownLanguages()) > 1 && $default != JFactory::getLanguage()->getTag() ){

    $check_for_translation_tbl = ' Left Join #__breezingcommerce_translations As trns ';
    $check_for_translation_tbl .= ' On c.id = trns.item_id And trns.language_code = ' . $db->quote(JFactory::getLanguage()->getTag()) . ' And `type` = "category" ';
    $check_for_translation_lookup = ' And trns.item_id Is Not Null And ( trns.title <> "" Or trns.alias <> "" Or trns.body <> "" ) ';
    $check_for_translation_lookup_root = ' And ( c.id = 1 Or ( trns.item_id Is Not Null And ( trns.title <> "" Or trns.alias <> "" Or trns.body <> "" ) ) ) ';

}

// first retrieve the parent of the current category, as we will need it to display the back to parent navigation....

$db->setQuery("Select c.* From #__breezingcommerce_categories As c $check_for_translation_tbl Where c.published = 1 And c.id = " . $db->quote($selected_category_id) . $check_for_translation_lookup);
$current = $db->loadObject();

$top = null;

if($current){

    $current = CrBcHelpers::populateTranslation($current, 'category', array('title' => 'title', 'alias' => 'alias'));
    
    $db->setQuery("Select c.* From #__breezingcommerce_categories As c $check_for_translation_tbl Where c.id = " . $db->quote($current->parent_id) . $check_for_translation_lookup_root);
    $top = $db->loadObject();

}

// ... then retrieve the current categories from the ID we are in right now

$db->setQuery("Select SQL_CALC_FOUND_ROWS c.* From #__breezingcommerce_categories As c $check_for_translation_tbl Where c.published = 1 And c.parent_id = " . $db->quote($selected_category_id) . $check_for_translation_lookup . " Order By c.ordering Limit " . JRequest::getInt('crbc_mod_categories_more', $more_steps) );
$categories = $db->loadObjectList();

$categories = CrBcHelpers::populateTranslation($categories, 'category', array('title' => 'title', 'alias' => 'alias'));

$db->setQuery('SELECT FOUND_ROWS();');
$found_cats = $db->loadResult();

echo '<div class="crbc crbc-mod_breezingcommerce_currencies'.htmlspecialchars($params->get('moduleclass_sfx')).'">'."\n";
echo '<ul role="navigation" class="crbc-nav crbc-nav-tabs crbc-nav-stacked nav nav-tabs nav-stacked">';

if( $top ){

    $top = CrBcHelpers::populateTranslation($top, 'category', array('title' => 'title', 'alias' => 'alias'));
    
    // here we write the navigation top button
    if( $top->id != 1 ){

        $link = JRoute::_('index.php?option=com_breezingcommerce&controller=category&alias='.$top->alias.'&category_id='.$top->id.'&Itemid='.$menu_item_id);
        echo '<li><a href="'.$link.'"><i class="crbc-fa crbc-fa-arrow-up"></i> '.$top->title.'</a></li>';

    }
    // there is a special case when we reach the end (ROOT)
    // we cannot go on like above as this would result in a category not found exception, so we simply route
    // to the home page and reset the selected category id
    else
    {
        $param_begin = '?';
        if( strpos($here, '?') !== false ){
            $param_begin = '&';
        }
        
        $here = str_replace($param_begin.'crbc_mod_category_id=1', '', $here);
        
        echo '<li><a href="'.$here.$param_begin.'crbc_mod_category_id=1"><i class="crbc-fa crbc-fa-arrow-up"></i> '.JText::_('COM_BREEZINGCOMMERCE_CATEGORIES_ROOT').'</a></li>';
    }
}

// letting the user know where he is

if($current){
    
    echo '<li class="crbc-active active"><a class="crbc-muted muted">'.JText::_('COM_BREEZINGCOMMERCE_CATEGORIES_YOU_ARE_HERE').' '.$current->title.'</a></li>';
    
}

// the categories we are viewing right now

foreach( $categories As $category ){

    $link = JRoute::_('index.php?option=com_breezingcommerce&controller=category&alias='.$category->alias.'&category_id='.$category->id.'&Itemid='.$menu_item_id);
    echo '<li><a href="'.$link.'">'.$category->title.'</a></li>';

}

// here we add the MORE button at the lists bottom

if( $found_cats > JRequest::getInt('crbc_mod_categories_more',$more_steps) ){

    // removing possible already existing parameters from the url, so they won't appear over and over again
    $here = str_replace(
                array(
                    '?crbc_mod_categories_more='.JRequest::getInt('crbc_mod_categories_more',$more_steps),
                    '&crbc_mod_categories_more='.JRequest::getInt('crbc_mod_categories_more',$more_steps)
                )
                , ''
                ,$here
            );

    // depending if there are parameters already, we set either ? or &
    // this can be written a lot shorter but it demonstrates better how it works like this
    if( strpos($here, '?') === false ){

        $here = $here . '?crbc_mod_categories_more=' . ( JRequest::getInt('crbc_mod_categories_more',$more_steps) + $more_steps );

    }
    else
    {
        $here = $here . '&crbc_mod_categories_more=' . ( JRequest::getInt('crbc_mod_categories_more',$more_steps) + $more_steps );
    }

    // the MORE button
    echo '<li><a href="'.$here.'"><i class="crbc-fa crbc-fa-arrow-down"></i> '.JText::_('COM_BREEZINGCOMMERCE_CATEGORIES_MORE').'</a></li>';

}

echo '</ul>';
echo '</div>';
