<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

if(!file_exists(JPATH_ADMINISTRATOR . '/components/com_breezingcommerce/classes/CrBcHelpers.php')){
    return;
}

require_once(JPATH_ADMINISTRATOR . '/components/com_breezingcommerce/classes/CrBcHelpers.php');

// remember the selected currency
if( JRequest::getInt('crbc_set_currency', 0) != 0 ){
    JFactory::getDbo()->setQuery("Select id From #__breezingcommerce_currencies Where id = " . JRequest::getInt('crbc_set_currency', 0) . " And published = 1");
    if( JFactory::getDbo()->loadResult() ){
        JFactory::getSession()->set('com_breezingcommerce.currency', JRequest::getInt('crbc_set_currency', 0));
    }
}

$db = JFactory::getDbo();
$db->setQuery("Select * From #__breezingcommerce_currencies Where published = 1 Order By ordering");
$currencies = $db->loadObjectList();

CrBcHelpers::addCss('
    
    .crbc-mod_breezingcommerce_currencies{
        width: 100%;
        height: auto;
        margin-bottom: 20px;
    }
    
    .crbc-mod_breezingcommerce_currencies .crbc-currency{
        margin-bottom: 5px;
    }
');

$url = JURI::getInstance()->toString();
$url = preg_replace("/(.*)[&|?]crbc_set_currency=[0-9]*$/i",'${1}',$url);

echo '<div class="crbc crbc-mod_breezingcommerce_currencies'.htmlspecialchars($params->get('moduleclass_sfx')).'">'."\n";

foreach($currencies As $currency){
    
    $translated_object = CrBcHelpers::loadTranslation($currency->id, 'currency');
    if($translated_object !== null){
        $currency->name = $translated_object->title;
    }
    
?>

<a class="crbc-currency crbc-btn crbc-btn-secondary btn btn-secondary" href="<?php echo $url.(strstr($url,'?') !== false ? '&' : '?').'crbc_set_currency='.$currency->id; ?>"<?php echo JFactory::getSession()->get('com_breezingcommerce.currency', 0) == $currency->id ? ' disabled="disabled"' : ''?>>
    <?php echo $currency->symbol . ' '.$currency->code.''; ?>
</a>

<?php
}

echo '</div>'."\n";
echo '<div style="clear:both"></div>'."\n";

