<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

if(!defined('DS')){
    define('DS','/');
}

require_once(JPATH_SITE.'/administrator/components/com_breezingcommerce/classes/CrBcHelpers.php');
require_once(JPATH_SITE.'/administrator/components/com_breezingcommerce/classes/plugin/CrBcPlugin.php');
require_once(JPATH_SITE.'/administrator/components/com_breezingcommerce/classes/CrBcCart.php');
require_once(JPATH_SITE.'/administrator/components/com_breezingcommerce/classes/CrBcImage.php');

JFactory::getDocument()->addScript(JURI::root(true) . '/components/com_breezingcommerce/js/remodal/remodal.min.js');
JFactory::getDocument()->addScript(JUri::root(true).'/components/com_breezingcommerce/js/breezingcommerce.js');
CrBcHelpers::addCssFile( JURI::root(true) . '/components/com_breezingcommerce/js/remodal/remodal.css' );
CrBcHelpers::addCssFile( JURI::root(true) . '/components/com_breezingcommerce/js/remodal/remodal-default-theme.css' );



CrBcHelpers::addCssFile(JUri::root(true).'/modules/mod_breezingcommerce_minicart/css/minicart.css');
JFactory::getDocument()->addScript(JUri::root(true).'/modules/mod_breezingcommerce_minicart/js/minicart.js');

$max_items = intval($params->get('max_items',3));
$micro_cart = intval($params->get('micro_cart',0)); 

$moduleclass_sfx = intval($params->get('moduleclass_sfx',0));  

$_session_cart = JFactory::getSession()->get('crbc_cart', array());
$_cart = new CrBcCart( $_session_cart !== null ? $_session_cart : array() );

$_cart_items = $_cart->getItems(true);

$empty = false;

if(count($_cart_items) == 0){
    $empty = true;
}

JFactory::getDocument()->addScriptDeclaration('
    if(typeof crbc_mod_minicart == "undefined"){
        crbc_mod_minicart_proceed_msg = '.CrBcHelpers::jsonEncode(JText::_('COM_BREEZINGCOMMERCE_PROCEED_MSG')).';
        crbc_mod_minicart_continue_msg = '.CrBcHelpers::jsonEncode(JText::_('COMBREEZINGCOMMERCE_CONTINUE_MSG')).';
        jQuery(document).ready(function(){
            crbc_mod_minicart = new CrBcModMinicart('.CrBcHelpers::jsonEncode(JUri::getInstance()->toString() ).', '.CrBcHelpers::jsonEncode( $module->id ).');
        });
    }
');

if($empty || !isset( $_session_cart['order_id'] ) || intval($_session_cart['order_id']) < 1 ){
    
    require JModuleHelper::getLayoutPath('mod_breezingcommerce_minicart', 'empty');
    
} else if(JRequest::getVar('controller') == 'cart'){
    
    require JModuleHelper::getLayoutPath('mod_breezingcommerce_minicart', 'cart');
    
} else if(JRequest::getVar('controller') == 'checkout'){
    
    require JModuleHelper::getLayoutPath('mod_breezingcommerce_minicart', 'checkout');
    
} else {
    
    $customer = null;
    if(isset($_cart->cart['customer_id']) && $_cart instanceof CrBcCart){
        JFactory::getDbo()->setQuery("Select * From #__breezingcommerce_customers Where id = " . intval($_cart->cart['customer_id']));
        $customer = JFactory::getDbo()->loadObject();
    }

    $_cart_items = $_cart->getItems(true);
    
    if(count($_cart_items) == 0){
        
        require JModuleHelper::getLayoutPath('mod_breezingcommerce_minicart', 'empty');
        
    } else {
        
        $items = CrBcCart::getData($_session_cart['order_id'], $_cart_items, -1, -1);
        
        $order_info = CrBcCart::getOrder(
                                    $_session_cart['order_id'], 
                                    $_cart, 
                                    $_session_cart, 
                                    $_cart_items, 
                                    $customer,
                                    $items,
                                    array(),
                                    array()
                            );
        
        if( $micro_cart == 0 ){
            
            require JModuleHelper::getLayoutPath('mod_breezingcommerce_minicart');
        }
        else
        {
            require JModuleHelper::getLayoutPath('mod_breezingcommerce_minicart','micro');
        }
        
    }
    
}