<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

$libpath = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce' . DS . 'classes' . DS . 'plugin' . DS;
require_once($libpath . 'CrBcAProductdetailsSitePlugin.php');
require_once($libpath . 'CrBcProductdetailsSitePlugin.php');

class CrBc_Plugins_Productdetails_Characteristics_Site extends CrBcAProductdetailsSitePlugin implements CrBcProductdetailsSitePlugin
{
    
    function __construct() {
        parent::__construct();
    }
    
    public static function productViewport($product_id, $combination_id) {
        ;
    }
    
    public static function viewportReceive($product_id, $combination_id, $data) {
        ;
    }
    
    public static function getInfo($product_id, $combination_id) {
        
        $amount = 1;
        $selected = array();
        $use_combinations = false;
        
        require_once( JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcProperties.php' );
        
        $rows = CrBcProperties::getPropertyRows($product_id, true);
        
        if( count($rows) == 0){
            
            return '';
        }
        
        $out = '<h3 >'.JText::_('COM_BREEZINGCOMMERCE_PLUGIN_CHARACTERISTICS_TITLE').'</h3>';
        $out .= '<div id="crbc-plugin-characteristics-'.$product_id.'" class="crbc-plugin-characteristics crbc-well well">';

        $options = array();

        require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcCart.php');
        
        foreach($rows As $row){
            
            if(!isset($options[$row->property_key])){
                
                $options[$row->property_key] = array();
                $options[$row->property_key]['ppk_id'] = $row->ppk_id;
                $options[$row->property_key]['required'] = $row->required;
                $options[$row->property_key]['property_keys_id'] = $row->property_keys_id;
                $options[$row->property_key]['property_key'] = 'property_key_'.$row->property_id;
            }
            
            if($row->custom_value == ''){
            
                $translation = CrBcHelpers::loadTranslation($row->property_values_id, 'property_value_'.$row->property_values_key_id);
                if(is_object($translation)){
                    $row->value = $translation->title;
                }
            
            }
            else
            {
                $row->value = $row->custom_value;
                        
                $translation = CrBcHelpers::loadTranslation($row->id, 'productpropertyvalue');
                if(is_object($translation)){
                    $row->value = $translation->body;
                }
            }
            
            $options[$row->property_key]['options'][] = htmlentities($row->value, ENT_QUOTES, 'UTF-8')."\n";
        }

        foreach($options As $key => $opts){
            
            $out .= '<div class="crbc-plugin-characteristics-entry">';
            
            $translation = CrBcHelpers::loadTranslation($opts['property_keys_id'], $opts['property_key']);
            if(is_object($translation)){
                $key = $translation->title;
            }
            
            if(count($opts['options']) > 1 ){
            
                $out .= '<div class="crbc-plugin-characteristics-key crbc-plugin-characteristics-key-list">' . $key . "</div>\n";
                
                $out .= '<ul class="crbc-plugin-characteristics-list">';
                 
                foreach($opts['options'] As $opt){
                    $out .= '<li>' . $opt . '</li>';
                }
                
                $out .= '</ul>';
            
            } else {
                
                $out .= '<span class="crbc-plugin-characteristics-key crbc-plugin-characteristics-key-single">' . $key . ":</span> \n";
                
                foreach($opts['options'] As $opt){
                    $out .= ' <span class="crbc-plugin-characteristics-single">' . $opt . '</span>';
                }
            }
            
            $out .= '</div>'; // well end
            
        }

        $out .= '</div>';
        
        return $out;
    }
    
    public function getPluginDisplayName() {
        return JText::_('COM_BREEZINGCOMMERCE_PLUGIN_CHARACTERISTICS_TITLE');
    }
    
    public static function infoBeforePrice($info){
        return '';
    }
    
    public static function infoAfterPrice($info){
        
        static $cssAdded = false;
        
        if(!$cssAdded){
            
            CrBcHelpers::addCss('
                .crbc-plugin-characteristics-key {
                    font-weight: bold;
                }
                .crbc-plugin-characteristics{
                    text-align: left;
                }
            ');
            
            $cssAdded = true;
        }
        
        return $info;
    }
    
    public static function infoBeforeDescription($info){
        return '';
    }
    
    public static function infoAfterDescription($info){
        return '';
    }
    
    public static function infoInsideFooter($info){
        return '';
    }
    
    
}